/*

 File: tinycolor.js
 TinyColor v0.9.15+
 https://github.com/bgrins/TinyColor
 2013-02-24, Brian Grinstead, MIT License

 File: CanvasInput.js
  CanvasInput v1.0.10
  http://goldfirestudios.com/blog/108/CanvasInput-HTML5-Canvas-Text-Input

  (c) 2013, James Simpson of GoldFire Studios
  goldfirestudios.com

  (c) 2013, Axios, Inc.
  Modifications made by Axios, Inc.
  axiosengineering.com

  MIT License

 File: spin.js
 Copyright (c) 2011-2013 Felix Gnass
 Licensed under the MIT license

 File: sigplot.layer1d.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or
 (at your option) any later version. This library is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the
 GNU Lesser General Public License along with SigPlot.

 File: sigplot.layer2d.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or
 (at your option) any later version. This library is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the
 GNU Lesser General Public License along with SigPlot.

 File: license.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser 
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or 
 (at your option) any later version. This library is distributed in the hope that it will be useful, but 
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the 
 GNU Lesser General Public License along with SigPlot.

 Portions of SigPlot may utilize the following open-source software:

   loglevel.js          - MIT License; Copyright (c) 2014, Tim Perry
   typedarray.js        - MIT License; Copyright (c) 2010, Linden Research, Inc.
   tinycolor.js         - MIT License; Copyright (c) 2013, Brian Grinstead
   CanvasInput.js       - MIT License; Copyright (c) 2013, James Simpson of GoldFire Studios
   spin.js              - MIT License; Copyright (c) 2011-2013 Felix Gnass
   Array.remove         - MIT License; Copyright (c) 2007, John Resig
   Firefox subarray fix - Public Domain; Copyright (c) 2011, Ryan Berdeen

 File: typedarray.js
 $LicenseInfo:firstyear=2010&license=mit$

 Copyright (c) 2010, Linden Research, Inc.

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 $/LicenseInfo$

 Copyright (c) 2013, Michael Ihde - Added big-endian/little-endian support

 File: common.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or
 (at your option) any later version. This library is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the
 GNU Lesser General Public License along with SigPlot.


 File: bluefile.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or
 (at your option) any later version. This library is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the
 GNU Lesser General Public License along with SigPlot.


 File: m.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or
 (at your option) any later version. This library is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the
 GNU Lesser General Public License along with SigPlot.

 File: mx.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or
 (at your option) any later version. This library is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the
 GNU Lesser General Public License along with SigPlot.

 File: sigplot.js
 Copyright (c) 2012-2014, Michael Ihde, All rights reserved.
 Copyright (c) 2012-2014, Axios Inc., All rights reserved.

 This file is part of SigPlot.

 SigPlot is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser
 General Public License as published by the Free Software Foundation; either version 3.0 of the License, or
 (at your option) any later version. This library is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE. See the GNU Lesser General Public License for more details. You should have received a copy of the
 GNU Lesser General Public License along with SigPlot.
*/
var ArrayBuffer,ArrayBufferView,Int8Array,Uint8Array,Int16Array,Uint16Array,Int32Array,Uint32Array,Float32Array,Float64Array,DataView;
(function(){function e(){document&&document.createTextNode("").splitText(1);throw new RangeError("INDEX_SIZE_ERR");}function a(c){if(Object.getOwnPropertyNames&&Object.defineProperty){var p=Object.getOwnPropertyNames(c),q;for(q=0;q<p.length;q+=1)Object.defineProperty(c,p[q],{value:c[p[q]],writable:!1,enumerable:!1,configurable:!1})}}function d(c){function p(q){Object.defineProperty(c,q,{get:function(){return c._getter(q)},set:function(p){c._setter(q,p)},enumerable:!0,configurable:!1})}if(Object.defineProperty){var q;
for(q=0;q<c.length;q+=1)p(q)}}function y(c){return[c&255]}function r(c){return p(c[0],8)}function g(c){return[c&255]}function h(c){return q(c[0],8)}function f(c){return[c>>8&255,c&255]}function n(c){return p(c[0]<<8|c[1],16)}function l(c){return[c>>8&255,c&255]}function C(c){return q(c[0]<<8|c[1],16)}function u(c){return[c>>24&255,c>>16&255,c>>8&255,c&255]}function D(c){return p(c[0]<<24|c[1]<<16|c[2]<<8|c[3],32)}function w(c){return[c>>24&255,c>>16&255,c>>8&255,c&255]}function x(c){return q(c[0]<<
24|c[1]<<16|c[2]<<8|c[3],32)}function F(c){var p=[];for(c=c.join("");c.length;)p.push(parseInt(c.substring(0,8),2)),c=c.substring(8);return p}function B(c){var p=[],q,k;for(q=c.length;q;q-=1)for(b=c[q-1],k=8;k;k-=1)p.push(b%2?1:0),b>>=1;p.reverse();return p}function M(c){return[c&255]}function N(c){return p(c[0],8)}function T(c){return[c&255]}function O(c){return q(c[0],8)}function z(c){return[c&255,c>>8&255]}function W(c){return p(c[1]<<8|c[0],16)}function c(c){return[c&255,c>>8&255]}function v(c){return q(c[1]<<
8|c[0],16)}function E(c){return[c&255,c>>8&255,c>>16&255,c>>24&255]}function H(c){return p(c[3]<<24|c[2]<<16|c[1]<<8|c[0],32)}function P(c){return[c&255,c>>8&255,c>>16&255,c>>24&255]}function t(c){return q(c[3]<<24|c[2]<<16|c[1]<<8|c[0],32)}function Q(c){var p=[];for(c=c.join("");c.length;)p.push(parseInt(c.substring(c.length-8,c.length),2)),c=c.substring(0,c.length-8);return p}function R(c){var p=[],q,k;for(q=0;q<c.length;q++)for(b=c[q],k=8;k;k-=1)p.push(b%2?1:0),b>>=1;p.reverse();return p}function p(c,
p){var q=32-p;return c<<q>>q}function q(c,p){var q=32-p;return c<<q>>>q}function s(c,p,q){var k=(1<<p-1)-1,v,s,a;isNaN(c)?(s=(1<<k)-1,k=Math.pow(2,q-1),v=0):Infinity===c||-Infinity===c?(s=(1<<k)-1,k=0,v=0>c?1:0):0===c?(k=s=0,v=-Infinity===1/c?1:0):(v=0>c,c=Math.abs(c),c>=Math.pow(2,1-k)?(a=Math.min(Math.floor(Math.log(c)/Math.LN2),k),s=a+k,k=Math.round(c*Math.pow(2,q-a)-Math.pow(2,q))):(s=0,k=Math.round(c/Math.pow(2,1-k-q))));for(c=[];q;q-=1)c.push(k%2?1:0),k=Math.floor(k/2);for(q=p;q;q-=1)c.push(s%
2?1:0),s=Math.floor(s/2);c.push(v?1:0);c.reverse();return $(c)}function k(c,p,q){var k=[],v,s,k=aa(c);v=k.join("");c=(1<<p-1)-1;k=parseInt(v.substring(0,1),2)?-1:1;s=parseInt(v.substring(1,1+p),2);v=parseInt(v.substring(1+p),2);return s===(1<<p)-1?0!==v?NaN:Infinity*k:0<s?k*Math.pow(2,s-c)*(1+v/Math.pow(2,q)):0!==v?k*Math.pow(2,-(c-1))*(v/Math.pow(2,q)):0>k?-0:0}function A(c){return k(c,11,52)}function G(c){return s(c,11,52)}function J(c){return k(c,8,23)}function K(c){return s(c,8,23)}var V={ToInt32:function(c){return c>>
0},ToUint32:function(c){return c>>>0}};Object.prototype.__defineGetter__&&!Object.defineProperty&&(Object.defineProperty=function(c,p,q){q.hasOwnProperty("get")&&c.__defineGetter__(p,q.get);q.hasOwnProperty("set")&&c.__defineSetter__(p,q.set)});var ba=window.BIG_ENDIAN_ARRAYBUFFERS?y:M,L=window.BIG_ENDIAN_ARRAYBUFFERS?r:N,S=window.BIG_ENDIAN_ARRAYBUFFERS?g:T,X=window.BIG_ENDIAN_ARRAYBUFFERS?h:O,ca=window.BIG_ENDIAN_ARRAYBUFFERS?f:z,da=window.BIG_ENDIAN_ARRAYBUFFERS?n:W,ea=window.BIG_ENDIAN_ARRAYBUFFERS?
l:c,fa=window.BIG_ENDIAN_ARRAYBUFFERS?C:v,I=window.BIG_ENDIAN_ARRAYBUFFERS?u:E,ga=window.BIG_ENDIAN_ARRAYBUFFERS?D:H,ha=window.BIG_ENDIAN_ARRAYBUFFERS?w:P,ia=window.BIG_ENDIAN_ARRAYBUFFERS?x:t,$=window.BIG_ENDIAN_ARRAYBUFFERS?F:Q,aa=window.BIG_ENDIAN_ARRAYBUFFERS?B:R;ArrayBuffer||function(){function c(p,q,k){var v;v=function(c,p,q){var k,s,E;if(arguments.length&&"number"!==typeof arguments[0])if("object"===typeof arguments[0]&&arguments[0].constructor===v)for(k=arguments[0],this.length=k.length,this.byteLength=
this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),s=this.byteOffset=0;s<this.length;s+=1)this._setter(s,k._getter(s));else if("object"!==typeof arguments[0]||arguments[0]instanceof ArrayBuffer)if("object"===typeof arguments[0]&&arguments[0]instanceof ArrayBuffer){this.buffer=c;this.byteOffset=V.ToUint32(p);this.byteOffset>this.buffer.byteLength&&e();if(this.byteOffset%this.BYTES_PER_ELEMENT)throw new RangeError("ArrayBuffer length minus the byteOffset is not a multiple of the element size.");
3>arguments.length?(this.byteLength=this.buffer.byteLength-this.byteOffset,this.byteLength%this.BYTES_PER_ELEMENT&&e(),this.length=this.byteLength/this.BYTES_PER_ELEMENT):(this.length=V.ToUint32(q),this.byteLength=this.length*this.BYTES_PER_ELEMENT);this.byteOffset+this.byteLength>this.buffer.byteLength&&e()}else throw new TypeError("Unexpected argument type(s)");else for(k=arguments[0],this.length=V.ToUint32(k.length),this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new ArrayBuffer(this.byteLength),
s=this.byteOffset=0;s<this.length;s+=1)E=k[s],this._setter(s,Number(E));else{this.length=V.ToInt32(arguments[0]);if(0>q)throw new RangeError("ArrayBufferView size is not a small enough positive integer.");this.byteLength=this.length*this.BYTES_PER_ELEMENT;this.buffer=new ArrayBuffer(this.byteLength);this.byteOffset=0}this.constructor=v;a(this);d(this)};v.prototype=new ArrayBufferView;v.prototype.BYTES_PER_ELEMENT=p;v.prototype.emulated=!0;v.prototype._pack=q;v.prototype._unpack=k;v.BYTES_PER_ELEMENT=
p;v.prototype._getter=function(c){if(1>arguments.length)throw new SyntaxError("Not enough arguments");c=V.ToUint32(c);if(!(c>=this.length)){var p=[],q,k;q=0;for(k=this.byteOffset+c*this.BYTES_PER_ELEMENT;q<this.BYTES_PER_ELEMENT;q+=1,k+=1)p.push(this.buffer._bytes[k]);return this._unpack(p)}};v.prototype.get=v.prototype._getter;v.prototype._setter=function(c,p){if(2>arguments.length)throw new SyntaxError("Not enough arguments");c=V.ToUint32(c);if(!(c>=this.length)){var q=this._pack(p),k,v;k=0;for(v=
this.byteOffset+c*this.BYTES_PER_ELEMENT;k<this.BYTES_PER_ELEMENT;k+=1,v+=1)this.buffer._bytes[v]=q[k]}};v.prototype.set=function(c,p){if(1>arguments.length)throw new SyntaxError("Not enough arguments");var q,k,v,s,a,d;if("object"===typeof arguments[0]&&arguments[0].constructor===this.constructor)if(q=arguments[0],k=V.ToUint32(arguments[1]),k+q.length>this.length&&e(),d=this.byteOffset+k*this.BYTES_PER_ELEMENT,k=q.length*this.BYTES_PER_ELEMENT,q.buffer===this.buffer){v=[];s=0;for(a=q.byteOffset;s<
k;s+=1,a+=1)v[s]=q.buffer._bytes[a];for(s=0;s<k;s+=1,d+=1)this.buffer._bytes[d]=v[s]}else for(s=0,a=q.byteOffset;s<k;s+=1,a+=1,d+=1)this.buffer._bytes[d]=q.buffer._bytes[a];else if("object"===typeof arguments[0]&&"undefined"!==typeof arguments[0].length)for(q=arguments[0],v=V.ToUint32(q.length),k=V.ToUint32(arguments[1]),k+v>this.length&&e(),s=0;s<v;s+=1)a=q[s],this._setter(k+s,Number(a));else throw new TypeError("Unexpected argument type(s)");};v.prototype.subarray=function(c,p){c=V.ToInt32(c);p=
V.ToInt32(p);1>arguments.length&&(c=0);2>arguments.length&&(p=this.length);0>c&&(c=this.length+c);0>p&&(p=this.length+p);var q=this.length;c=0>c?0:c>q?q:c;q=this.length;q=(0>p?0:p>q?q:p)-c;0>q&&(q=0);return new this.constructor(this.buffer,c*this.BYTES_PER_ELEMENT,q)};return v}ArrayBuffer=function(c){c=V.ToInt32(c);if(0>c)throw new RangeError("ArrayBuffer size is not a small enough positive integer.");this.byteLength=c;this._bytes=[];this._bytes.length=c;for(c=0;c<this.byteLength;c+=1)this._bytes[c]=
0;a(this)};ArrayBuffer.isNative=!1;ArrayBufferView=function(){};Int8Array=Int8Array||c(1,ba,L);Uint8Array=Uint8Array||c(1,S,X);Int16Array=Int16Array||c(2,ca,da);Uint16Array=Uint16Array||c(2,ea,fa);Int32Array=Int32Array||c(4,I,ga);Uint32Array=Uint32Array||c(4,ha,ia);Float32Array=Float32Array||c(4,K,J);Float64Array=Float64Array||c(8,G,A)}();DataView||function(){function c(p,q){return"function"===typeof p.get?p.get(q):p[q]}function p(q){return function(p,v){p=V.ToUint32(p);p+q.BYTES_PER_ELEMENT>this.byteLength&&
e();p+=this.byteOffset;var s=new Uint8Array(this.buffer,p,q.BYTES_PER_ELEMENT),a=[],d;for(d=0;d<q.BYTES_PER_ELEMENT;d+=1)a.push(c(s,d));Boolean(v)===Boolean(k)&&a.reverse();return c(new q((new Uint8Array(a)).buffer),0)}}function q(p){return function(q,v,s){q=V.ToUint32(q);q+p.BYTES_PER_ELEMENT>this.byteLength&&e();v=new p([v]);v=new Uint8Array(v.buffer);var a=[],d;for(d=0;d<p.BYTES_PER_ELEMENT;d+=1)a.push(c(v,d));Boolean(s)===Boolean(k)&&a.reverse();(new Uint8Array(this.buffer,q,p.BYTES_PER_ELEMENT)).set(a)}}
var k=function(){var p=new Uint16Array([4660]),p=new Uint8Array(p.buffer);return 18===c(p,0)}();DataView=function(c,p,q){if(!("object"===typeof c&&c instanceof ArrayBuffer))throw new TypeError("TypeError");this.buffer=c;this.byteOffset=V.ToUint32(p);this.byteOffset>this.buffer.byteLength&&e();this.byteLength=3>arguments.length?this.buffer.byteLength-this.byteOffset:V.ToUint32(q);this.byteOffset+this.byteLength>this.buffer.byteLength&&e();a(this)};ArrayBufferView&&(DataView.prototype=new ArrayBufferView);
DataView.prototype.getUint8=p(Uint8Array);DataView.prototype.getInt8=p(Int8Array);DataView.prototype.getUint16=p(Uint16Array);DataView.prototype.getInt16=p(Int16Array);DataView.prototype.getUint32=p(Uint32Array);DataView.prototype.getInt32=p(Int32Array);DataView.prototype.getFloat32=p(Float32Array);DataView.prototype.getFloat64=p(Float64Array);DataView.prototype.setUint8=q(Uint8Array);DataView.prototype.setInt8=q(Int8Array);DataView.prototype.setUint16=q(Uint16Array);DataView.prototype.setInt16=q(Int16Array);
DataView.prototype.setUint32=q(Uint32Array);DataView.prototype.setInt32=q(Int32Array);DataView.prototype.setFloat32=q(Float32Array);DataView.prototype.setFloat64=q(Float64Array)}()})();window.ArrayBuffer&&!ArrayBuffer.prototype.slice&&(ArrayBuffer.prototype.slice=function(e,a){var d=new Uint8Array(this);void 0===a&&(a=d.length);for(var y=new ArrayBuffer(a-e),r=new Uint8Array(y),g=0;g<r.length;g++)r[g]=d[g+e];return y});
Array.prototype.remove=function(e,a){var d=this.slice((a||e)+1||this.length);this.length=0>e?this.length+e:e;return this.push.apply(this,d)};window.requestAnimFrame=function(e){return window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(a){return window.setTimeout(a,1E3/60)}}();
window.cancelAnimFrame=function(e){return window.cancelAnimationFrame||window.webkitCancelAnimationFrame||window.mozCancelAnimationFrame||window.oCancelAnimationFrame||window.msCanelAnimationFrame||function(a){window.clearTimeout(a)}}();function dashOn(e,a,d){return e.setLineDash?(e.setLineDash([a,d]),!0):void 0!==e.mozDash?(e.mozDash=[a,d],!0):e.webkitLineDash&&0===e.webkitLineDash.length?(e.webkitLineDash=[a,d],!0):!1}
function dashOff(e){e.setLineDash?e.setLineDash([]):e.mozDash?e.mozDash=null:e.webkitLineDash&&(e.webkitLineDash=[])}function getKeyCode(e){e=window.event||e;return e=e.charCode||e.keyCode}function setKeypressHandler(e){window.addEventListener?window.addEventListener("keypress",e,!1):window.attachEvent&&window.attachEvent("onkeypress",e)}Array.isArray||(Array.isArray=function(e){return"[object Array]"===Object.prototype.toString.call(e)});
window.Float64Array||(window.Float64Array=function(){return window.Float64Array||function(e,a,d){if(!(e instanceof ArrayBuffer))throw"Invalid type";var y=new DataView(e),r=[];e=(e.byteLength-a)/8;r.length=void 0===d?e:Math.min(d,e);for(d=0;d<r.length;d++)r[d]=y.getFloat64(8*d+a,!0);r.subarray=function(a,d){return r.slice(a,d)};return r}}());
(function(){var e=function(){};window.console||(window.console={log:e,info:e,warn:e,debug:e,error:e});if((new Int8Array([0,1,0])).subarray(1).subarray(1)[0]){var a=function(a,e){0===arguments.length?(a=0,e=this.length):(0>a&&(a+=this.length),a=Math.max(0,Math.min(this.length,a)),1===arguments.length?e=this.length:(0>e&&(e+=this.length),e=Math.max(a,Math.min(this.length,e))));return new this.constructor(this.buffer,this.byteOffset+a*this.BYTES_PER_ELEMENT,e-a)};[Int8Array,Uint8Array,Int16Array,Uint16Array,
Int32Array,Uint32Array,Float32Array,Float64Array].forEach(function(d){d.prototype.subarray=a})}})();
(function(e,a){function d(a,d,n,l){a[r](y+d,"wheel"===g?n:function(a){!a&&(a=e.event);var d={originalEvent:a,target:a.target||a.srcElement,type:"wheel",deltaMode:"MozMousePixelScroll"===a.type?0:1,deltaX:0,delatZ:0,preventDefault:function(){a.preventDefault?a.preventDefault():a.returnValue=!1}};"mousewheel"===g?(d.deltaY=-0.025*a.wheelDelta,a.wheelDeltaX&&(d.deltaX=-0.025*a.wheelDeltaX)):d.deltaY=a.detail;return n(d)},l||!1)}var y="",r,g;e.addEventListener?r="addEventListener":(r="attachEvent",y=
"on");g="onwheel"in a.createElement("div")?"wheel":void 0!==a.onmousewheel?"mousewheel":"DOMMouseScroll";e.addWheelListener=function(a,e,n){d(a,g,e,n);"DOMMouseScroll"===g&&d(a,"MozMousePixelScroll",e,n)}})(window,document);
(function(e){function a(a){a=new Uint8Array(a);if(C)return String.fromCharCode.apply(null,a);for(var d="",e=0;e<a.length;e++)d+=String.fromCharCode(a[e]);return d}function d(d){this.file_name=this.file=null;this.offset=0;this.buf=d;if(null!=this.buf){d=new DataView(this.buf);this.version=a(this.buf.slice(0,4));this.headrep=a(this.buf.slice(4,8));this.datarep=a(this.buf.slice(8,12));var e="EEEI"===this.headrep,g="EEEI"===this.datarep;this.type=d.getUint32(48,e);this["class"]=this.type/1E3;this.format=
a(this.buf.slice(52,54));this.timecode=d.getFloat64(56,e);1===this["class"]?(this.xstart=d.getFloat64(256,e),this.xdelta=d.getFloat64(264,e),this.xunits=d.getInt32(272,e),this.yunits=d.getInt32(296,e),this.subsize=1):2===this["class"]&&(this.xstart=d.getFloat64(256,e),this.xdelta=d.getFloat64(264,e),this.xunits=d.getInt32(272,e),this.subsize=d.getInt32(276,e),this.ystart=d.getFloat64(280,e),this.ydelta=d.getFloat64(288,e),this.yunits=d.getInt32(296,e));this.data_start=d.getFloat64(32,e);this.data_size=
d.getFloat64(40,e);this.setData(this.buf,this.data_start,this.data_start+this.data_size,g)}}function y(a){var d=document.createElement("a");d.href=a;for(var e=d.protocol.replace(":",""),g=d.hostname,h=d.port,f=d.search,l={},n=d.search.replace(/^\?/,"").split("&"),z=n.length,r=0,c;r<z;r++)n[r]&&(c=n[r].split("="),l[c[0]]=c[1]);return{source:a,protocol:e,host:g,port:h,query:f,params:l,file:(d.pathname.match(/\/([^\/?#]+)$/i)||[null,""])[1],hash:d.hash.replace("#",""),path:d.pathname.replace(/^([^\/])/,
"/$1"),relative:(d.href.match(/tps?:\/\/[^\/]+(.+)/)||[null,""])[1],segments:d.pathname.replace(/^\//,"").split("/")}}function r(a,d,e){e=e||1024;var g=0,h=new ArrayBuffer(a.length),f=new Uint8Array(h),l=function(){for(var n=g+e;g<n;g++)f[g]=a.charCodeAt(g)&255;g>=a.length?d(h):setTimeout(l,0)};setTimeout(l,0)}function g(a){this.options=a}navigator.userAgent.match(/(iPad|iPhone|iPod)/i);var h=function(){var a=new ArrayBuffer(4),d=new Uint32Array(a),a=new Uint8Array(a);d[0]=3735928559;if(239===a[0])return"LE";
if(222===a[0])return"BE";throw Error("unknown endianness");}(),f={S:1,C:2,V:3,Q:4,M:9,X:10,T:16,U:1,1:1,2:2,3:3,4:4,5:5,6:6,7:7,8:8,9:9},n={P:0.125,A:1,O:1,B:1,I:2,L:4,X:8,F:4,D:8},l={P:null,A:null,O:Uint8Array,B:Int8Array,I:Int16Array,L:Int32Array,X:null,F:Float32Array,D:Float64Array},C=!0;try{var u=new UInt8Array(new ArrayBuffer(4));u[0]=66;u[1]=76;u[2]=85;u[3]=69;"BLUE"!==String.fromCharCode.apply(null,u)&&(C=!1)}catch(D){C=!1}d.prototype={setData:function(a,d,e,g){1===this["class"]?(this.spa=
f[this.format[0]],this.bps=n[this.format[1]],this.bpa=this.spa*this.bps,this.ape=1,this.bpe=this.ape*this.bpa):2===this["class"]&&(this.spa=f[this.format[0]],this.bps=n[this.format[1]],this.bpa=this.spa*this.bps,this.ape=this.subsize,this.bpe=this.ape*this.bpa);void 0===g&&(g="LE"===h);if("LE"===h&&!g)throw"Not supported "+h+" "+g;if("BE"===h&&this.littleEndianData)throw"Not supported "+h+" "+g;a?(this.dview=d&&e?this.createArray(a,d,(e-d)/this.bps):this.createArray(a),this.size=this.dview.length/
(this.spa*this.ape)):this.dview=this.createArray(null,null,this.size)},createArray:function(a,d,e){var g=l[this.format[1]];if(void 0===g)throw"unknown format "+this.format[1];void 0===d&&(d=0);void 0===e&&(e=a.length||a.byteLength/n[this.format[1]]);return a?new g(a,d,e):new g(e)}};g.prototype={readheader:function(a,e){var g=new FileReader,h=a.webkitSlice(0,512);g.onloadend=function(a){return function(h){h.target.error?e(null):(h=new d(g.result),h.file=a,e(h))}}(a);g.readAsArrayBuffer(h)},read:function(a,
e){var g=new FileReader;g.onloadend=function(a){return function(h){h.target.error?e(null):(h=new d(g.result),h.file=a,h.file_name=a.name,e(h))}}(a);g.readAsArrayBuffer(a)},read_http:function(a,e){var g=new XMLHttpRequest;g.open("GET",a,!0);g.responseType="arraybuffer";g.overrideMimeType("text/plain; charset=x-user-defined");g.onload=function(h){if(4!==g.readyState||200!==g.status&&0!==g.status)e(null);else if(h=null,g.response){h=g.response;h=new d(h);y(a);var f=y(a);h.file_name=f.file;e(h)}else g.responseText&&
r(g.responseText,function(g){g=new d(g);y(a);var h=y(a);g.file_name=h.file;e(g)})};g.onerror=function(a){e(null)};g.send(null)}};e.BlueHeader=e.BlueHeader||d;e.BlueFileReader=e.BlueFileReader||g})(this);
(function(e){function a(e,l){e=e?e:"";l=l||{};if("object"==typeof e&&e.hasOwnProperty("_tc_id"))return e;var c=d(e),v=c.r,E=c.g,H=c.b,P=c.a,t=x(100*P)/100,Q=l.format||c.format;1>v&&(v=x(v));1>E&&(E=x(E));1>H&&(H=x(H));return{ok:c.ok,format:Q,_tc_id:D++,alpha:P,toHsv:function(){var c=g(v,E,H);return{h:360*c.h,s:c.s,v:c.v,a:P}},toHsvString:function(){var c=g(v,E,H),p=x(360*c.h),q=x(100*c.s),c=x(100*c.v);return 1==P?"hsv("+p+", "+q+"%, "+c+"%)":"hsva("+p+", "+q+"%, "+c+"%, "+t+")"},toHsl:function(){var c=
y(v,E,H);return{h:360*c.h,s:c.s,l:c.l,a:P}},toHslString:function(){var c=y(v,E,H),p=x(360*c.h),q=x(100*c.s),c=x(100*c.l);return 1==P?"hsl("+p+", "+q+"%, "+c+"%)":"hsla("+p+", "+q+"%, "+c+"%, "+t+")"},toHex:function(c){return h(v,E,H,c)},toHexString:function(c){return"#"+h(v,E,H,c)},toRgb:function(){return{r:x(v),g:x(E),b:x(H),a:P}},toRgbString:function(){return 1==P?"rgb("+x(v)+", "+x(E)+", "+x(H)+")":"rgba("+x(v)+", "+x(E)+", "+x(H)+", "+t+")"},toPercentageRgb:function(){return{r:x(100*f(v,255))+
"%",g:x(100*f(E,255))+"%",b:x(100*f(H,255))+"%",a:P}},toPercentageRgbString:function(){return 1==P?"rgb("+x(100*f(v,255))+"%, "+x(100*f(E,255))+"%, "+x(100*f(H,255))+"%)":"rgba("+x(100*f(v,255))+"%, "+x(100*f(E,255))+"%, "+x(100*f(H,255))+"%, "+t+")"},toName:function(){return 0===P?"transparent":T[h(v,E,H,!0)]||!1},toFilter:function(c){var p=h(v,E,H),q=p,s=Math.round(255*parseFloat(P)).toString(16),k=s,d=l&&l.gradientType?"GradientType = 1, ":"";c&&(c=a(c),q=c.toHex(),k=Math.round(255*parseFloat(c.alpha)).toString(16));
return"progid:DXImageTransform.Microsoft.gradient("+d+"startColorstr=#"+n(s)+p+",endColorstr=#"+n(k)+q+")"},toString:function(c){var p=!!c;c=c||this.format;var q=!1,p=!p&&1>P&&0<P&&("hex"===c||"hex6"===c||"hex3"===c||"name"===c);"rgb"===c&&(q=this.toRgbString());"prgb"===c&&(q=this.toPercentageRgbString());if("hex"===c||"hex6"===c)q=this.toHexString();"hex3"===c&&(q=this.toHexString(!0));"name"===c&&(q=this.toName());"hsl"===c&&(q=this.toHslString());"hsv"===c&&(q=this.toHsvString());return p?this.toRgbString():
q||this.toHexString()}}}function d(a){var d={r:0,g:0,b:0},c=1,v=!1,E=!1;if("string"==typeof a)a:{a=a.replace(C,"").replace(u,"").toLowerCase();var e=!1;if(N[a])a=N[a],e=!0;else if("transparent"==a){a={r:0,g:0,b:0,a:0,format:"name"};break a}var g;a=(g=O.rgb.exec(a))?{r:g[1],g:g[2],b:g[3]}:(g=O.rgba.exec(a))?{r:g[1],g:g[2],b:g[3],a:g[4]}:(g=O.hsl.exec(a))?{h:g[1],s:g[2],l:g[3]}:(g=O.hsla.exec(a))?{h:g[1],s:g[2],l:g[3],a:g[4]}:(g=O.hsv.exec(a))?{h:g[1],s:g[2],v:g[3]}:(g=O.hex6.exec(a))?{r:parseInt(g[1],
16),g:parseInt(g[2],16),b:parseInt(g[3],16),format:e?"name":"hex"}:(g=O.hex3.exec(a))?{r:parseInt(g[1]+""+g[1],16),g:parseInt(g[2]+""+g[2],16),b:parseInt(g[3]+""+g[3],16),format:e?"name":"hex"}:!1}if("object"==typeof a){if(a.hasOwnProperty("r")&&a.hasOwnProperty("g")&&a.hasOwnProperty("b"))d=a.g,v=a.b,d={r:255*f(a.r,255),g:255*f(d,255),b:255*f(v,255)},v=!0,E="%"===String(a.r).substr(-1)?"prgb":"rgb";else if(a.hasOwnProperty("h")&&a.hasOwnProperty("s")&&a.hasOwnProperty("v")){a.s=l(a.s);a.v=l(a.v);
var E=a.h,e=a.s,d=a.v,E=6*f(E,360),e=f(e,100),d=f(d,100),v=w.floor(E),t=E-v,E=d*(1-e);g=d*(1-t*e);e=d*(1-(1-t)*e);v%=6;d={r:255*[d,g,E,E,e,d][v],g:255*[e,d,d,g,E,E][v],b:255*[E,E,e,d,d,g][v]};v=!0;E="hsv"}else a.hasOwnProperty("h")&&a.hasOwnProperty("s")&&a.hasOwnProperty("l")&&(a.s=l(a.s),a.l=l(a.l),d=r(a.h,a.s,a.l),v=!0,E="hsl");a.hasOwnProperty("a")&&(c=a.a)}c=parseFloat(c);if(isNaN(c)||0>c||1<c)c=1;return{ok:v,format:a.format||E,r:F(255,B(d.r,0)),g:F(255,B(d.g,0)),b:F(255,B(d.b,0)),a:c}}function y(a,
d,c){a=f(a,255);d=f(d,255);c=f(c,255);var v=B(a,d,c),e=F(a,d,c),g,h=(v+e)/2;if(v==e)g=e=0;else{var t=v-e,e=0.5<h?t/(2-v-e):t/(v+e);switch(v){case a:g=(d-c)/t+(d<c?6:0);break;case d:g=(c-a)/t+2;break;case c:g=(a-d)/t+4}g/=6}return{h:g,s:e,l:h}}function r(a,d,c){function v(c,v,a){0>a&&(a+=1);1<a&&(a-=1);return a<1/6?c+6*(v-c)*a:0.5>a?v:a<2/3?c+(v-c)*(2/3-a)*6:c}a=f(a,360);d=f(d,100);c=f(c,100);if(0===d)c=d=a=c;else{var e=0.5>c?c*(1+d):c+d-c*d,g=2*c-e;c=v(g,e,a+1/3);d=v(g,e,a);a=v(g,e,a-1/3)}return{r:255*
c,g:255*d,b:255*a}}function g(a,d,c){a=f(a,255);d=f(d,255);c=f(c,255);var v=B(a,d,c),e=F(a,d,c),g,h=v-e;if(v==e)g=0;else{switch(v){case a:g=(d-c)/h+(d<c?6:0);break;case d:g=(c-a)/h+2;break;case c:g=(a-d)/h+4}g/=6}return{h:g,s:0===v?0:h/v,v:v}}function h(a,d,c,v){a=[n(x(a).toString(16)),n(x(d).toString(16)),n(x(c).toString(16))];return v&&a[0].charAt(0)==a[0].charAt(1)&&a[1].charAt(0)==a[1].charAt(1)&&a[2].charAt(0)==a[2].charAt(1)?a[0].charAt(0)+a[1].charAt(0)+a[2].charAt(0):a.join("")}function f(a,
d){var c=a;"string"==typeof c&&-1!=c.indexOf(".")&&1===parseFloat(c)&&(a="100%");c="string"===typeof a&&-1!=a.indexOf("%");a=F(d,B(0,parseFloat(a)));c&&(a=parseInt(a*d,10)/100);return 1E-6>w.abs(a-d)?1:a%d/parseFloat(d)}function n(a){return 1==a.length?"0"+a:""+a}function l(a){1>=a&&(a=100*a+"%");return a}var C=/^[\s,#]+/,u=/\s+$/,D=0,w=Math,x=w.round,F=w.min,B=w.max,M=w.random;a.fromRatio=function(d,e){if("object"==typeof d){var c={},v;for(v in d)d.hasOwnProperty(v)&&(c[v]="a"===v?d[v]:l(d[v]));
d=c}return a(d,e)};a.equals=function(d,e){return d&&e?a(d).toRgbString()==a(e).toRgbString():!1};a.random=function(){return a.fromRatio({r:M(),g:M(),b:M()})};a.desaturate=function(d,e){e=0===e?0:e||10;var c=a(d).toHsl();c.s-=e/100;c.s=F(1,B(0,c.s));return a(c)};a.saturate=function(d,e){e=0===e?0:e||10;var c=a(d).toHsl();c.s+=e/100;c.s=F(1,B(0,c.s));return a(c)};a.greyscale=function(d){return a.desaturate(d,100)};a.lighten=function(d,e){e=0===e?0:e||10;var c=a(d).toHsl();c.l+=e/100;c.l=F(1,B(0,c.l));
return a(c)};a.darken=function(d,e){e=0===e?0:e||10;var c=a(d).toHsl();c.l-=e/100;c.l=F(1,B(0,c.l));return a(c)};a.complement=function(d){d=a(d).toHsl();d.h=(d.h+180)%360;return a(d)};a.triad=function(d){var e=a(d).toHsl(),c=e.h;return[a(d),a({h:(c+120)%360,s:e.s,l:e.l}),a({h:(c+240)%360,s:e.s,l:e.l})]};a.tetrad=function(d){var e=a(d).toHsl(),c=e.h;return[a(d),a({h:(c+90)%360,s:e.s,l:e.l}),a({h:(c+180)%360,s:e.s,l:e.l}),a({h:(c+270)%360,s:e.s,l:e.l})]};a.splitcomplement=function(d){var e=a(d).toHsl(),
c=e.h;return[a(d),a({h:(c+72)%360,s:e.s,l:e.l}),a({h:(c+216)%360,s:e.s,l:e.l})]};a.analogous=function(d,e,c){e=e||6;c=c||30;var v=a(d).toHsl();c=360/c;d=[a(d)];for(v.h=(v.h-(c*e>>1)+720)%360;--e;)v.h=(v.h+c)%360,d.push(a(v));return d};a.monochromatic=function(d,e){e=e||6;for(var c=a(d).toHsv(),v=c.h,E=c.s,c=c.v,g=[],h=1/e;e--;)g.push(a({h:v,s:E,v:c})),c=(c+h)%1;return g};a.readability=function(d,e){var c=a(d).toRgb(),v=a(e).toRgb(),E=(299*c.r+587*c.g+114*c.b)/1E3,g=(299*v.r+587*v.g+114*v.b)/1E3,c=
Math.max(c.r,v.r)-Math.min(c.r,v.r)+Math.max(c.g,v.g)-Math.min(c.g,v.g)+Math.max(c.b,v.b)-Math.min(c.b,v.b);return{brightness:Math.abs(E-g),color:c}};a.readable=function(d,e){var c=a.readability(d,e);return 125<c.brightness&&500<c.color};a.mostReadable=function(d,e){for(var c=null,v=0,E=!1,g=0;g<e.length;g++){var h=a.readability(d,e[g]),t=125<h.brightness&&500<h.color,h=h.brightness/125*3+h.color/500;if(t&&!E||t&&E&&h>v||!t&&!E&&h>v)E=t,v=h,c=a(e[g])}return c};var N=a.names={aliceblue:"f0f8ff",antiquewhite:"faebd7",
aqua:"0ff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000",blanchedalmond:"ffebcd",blue:"00f",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",burntsienna:"ea7e5d",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"0ff",darkblue:"00008b",darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkgrey:"a9a9a9",darkkhaki:"bdb76b",darkmagenta:"8b008b",darkolivegreen:"556b2f",
darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkslategrey:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dimgrey:"696969",dodgerblue:"1e90ff",firebrick:"b22222",floralwhite:"fffaf0",forestgreen:"228b22",fuchsia:"f0f",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",greenyellow:"adff2f",
grey:"808080",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgray:"d3d3d3",lightgreen:"90ee90",lightgrey:"d3d3d3",lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslategray:"789",lightslategrey:"789",lightsteelblue:"b0c4de",lightyellow:"ffffe0",
lime:"0f0",limegreen:"32cd32",linen:"faf0e6",magenta:"f0f",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370db",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",orchid:"da70d6",
palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"db7093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",red:"f00",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",slategrey:"708090",snow:"fffafa",springgreen:"00ff7f",steelblue:"4682b4",
tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",wheat:"f5deb3",white:"fff",whitesmoke:"f5f5f5",yellow:"ff0",yellowgreen:"9acd32"},T=a.hexNames=function(a){var d={},c;for(c in a)a.hasOwnProperty(c)&&(d[a[c]]=c);return d}(N),O={rgb:RegExp("rgb[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),rgba:RegExp("rgba[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),
hsl:RegExp("hsl[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),hsla:RegExp("hsla[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),hsv:RegExp("hsv[\\s|\\(]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))[,|\\s]+((?:[-\\+]?\\d*\\.\\d+%?)|(?:[-\\+]?\\d+%?))\\s*\\)?"),
hex3:/^([0-9a-fA-F]{1})([0-9a-fA-F]{1})([0-9a-fA-F]{1})$/,hex6:/^([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/};"undefined"!==typeof module&&module.exports?module.exports=a:"undefined"!==typeof define?define(function(){return a}):e.tinycolor=a})(this);
(function(){var e=[];(window.CanvasInput=function(a){var d=this;a=a?a:{};d._canvas=a.canvas||null;d._ctx=d._canvas?d._canvas.getContext("2d"):null;d._x=a.x||0;d._y=a.y||0;d._extraX=a.extraX||0;d._extraY=a.extraY||0;d._fontSize=a.fontSize||14;d._fontFamily=a.fontFamily||"Arial";d._fontColor=a.fontColor||"#000";d._placeHolderColor=a.placeHolderColor||"#bfbebd";d._fontWeight=a.fontWeight||"normal";d._fontStyle=a.fontStyle||"normal";d._readonly=a.readonly||!1;d._maxlength=a.maxlength||null;d._width=a.width||
150;d._height=a.height||d._fontSize;d._padding=0<=a.padding?a.padding:5;d._borderWidth=0<=a.borderWidth?a.borderWidth:1;d._borderColor=a.borderColor||"#959595";d._borderRadius=0<=a.borderRadius?a.borderRadius:3;d._backgroundImage=a.backgroundImage||"";d._boxShadow=a.boxShadow||"1px 1px 0px rgba(255, 255, 255, 1)";d._innerShadow=a.innerShadow||"0px 0px 4px rgba(0, 0, 0, 0.4)";d._selectionColor=a.selectionColor||"rgba(179, 212, 253, 0.8)";d._placeHolder=a.placeHolder||"";d._value=a.value||d._placeHolder;
d._onsubmit=a.onsubmit||function(){};d._onkeydown=a.onkeydown||function(){};d._onkeyup=a.onkeyup||function(){};d._onfocus=a.onfocus||function(){};d._onblur=a.onblur||function(){};d._cursor=!1;d._cursorPos=0;d._hasFocus=!1;d._selection=[0,0];d._wasOver=!1;d._renderOnReturn=void 0!==a.renderOnReturn?a.renderOnReturn:!0;d._disableBlur=a.disableBlur||!1;d._tabToClear=a.tabToClear||!1;d.boxShadow(d._boxShadow,!0);d._calcWH();d._renderCanvas=document.createElement("canvas");d._renderCanvas.setAttribute("width",
d.outerW);d._renderCanvas.setAttribute("height",d.outerH);d._renderCtx=d._renderCanvas.getContext("2d");d._shadowCanvas=document.createElement("canvas");d._shadowCanvas.setAttribute("width",d._width+2*d._padding);d._shadowCanvas.setAttribute("height",d._height+2*d._padding);d._shadowCtx=d._shadowCanvas.getContext("2d");"undefined"!==typeof a.backgroundGradient?(d._backgroundColor=d._renderCtx.createLinearGradient(0,0,0,d.outerH),d._backgroundColor.addColorStop(0,a.backgroundGradient[0]),d._backgroundColor.addColorStop(1,
a.backgroundGradient[1])):d._backgroundColor=a.backgroundColor||"#fff";d._canvas&&(d.mousemoveCanvasListener=function(a){a=a||window.event;d.mousemove(a,d)},d._canvas.addEventListener("mousemove",d.mousemoveCanvasListener,!1),d.mousedownCanvasListener=function(a){a=a||window.event;d.mousedown(a,d)},d._canvas.addEventListener("mousedown",d.mousedownCanvasListener,!1),d.mouseupCanvasListener=function(a){a=a||window.event;d.mouseup(a,d)},d._canvas.addEventListener("mouseup",d.mouseupCanvasListener,!1));
d.mouseupWindowListener=function(a){d._hasFocus&&!d._mouseDown&&d.blur()};window.addEventListener("mouseup",d.mouseupWindowListener,!0);d.keydownWindowListener=function(a){a=a||window.event;d._hasFocus&&d.keydown(a,d)};window.addEventListener("keydown",d.keydownWindowListener,!1);d.keyupWindowListener=function(a){a=a||window.event;d._hasFocus&&d._onkeyup(a,d)};window.addEventListener("keyup",d.keyupWindowListener,!1);d.pasteWindowListener=function(a){a=a||window.event;if(d._hasFocus){a=a.clipboardData.getData("text/plain");
var e=d._value.substr(0,d._cursorPos),g=d._value.substr(d._cursorPos);d._value=e+a+g;d._cursorPos+=a.length;d.render()}};window.addEventListener("paste",d.pasteWindowListener,!1);e.push(d);d._inputsIndex=e.length-1;d.render()}).prototype={canvas:function(a){return"undefined"!==typeof a?(this._canvas=a,this._ctx=this._canvas.getContext("2d"),this.render()):this._canvas},x:function(a){return"undefined"!==typeof a?(this._x=a,this.render()):this._x},y:function(a){return"undefined"!==typeof a?(this._y=
a,this.render()):this._y},extraX:function(a){return"undefined"!==typeof a?(this._extraX=a,this.render()):this._extraX},extraY:function(a){return"undefined"!==typeof a?(this._extraY=a,this.render()):this._extraY},fontSize:function(a){return"undefined"!==typeof a?(this._fontSize=a,this.render()):this._fontSize},fontFamily:function(a){return"undefined"!==typeof a?(this._fontFamily=a,this.render()):this._fontFamily},fontColor:function(a){return"undefined"!==typeof a?(this._fontColor=a,this.render()):
this._fontColor},placeHolderColor:function(a){return"undefined"!==typeof a?(this._placeHolderColor=a,this.render()):this._placeHolderColor},fontWeight:function(a){return"undefined"!==typeof a?(this._fontWeight=a,this.render()):this._fontWeight},fontStyle:function(a){return"undefined"!==typeof a?(this._fontStyle=a,this.render()):this._fontStyle},width:function(a){return"undefined"!==typeof a?(this._width=a,this._calcWH(),this._updateCanvasWH(),this.render()):this._width},height:function(a){return"undefined"!==
typeof a?(this._height=a,this._calcWH(),this._updateCanvasWH(),this.render()):this._height},padding:function(a){return"undefined"!==typeof a?(this._padding=a,this._calcWH(),this._updateCanvasWH(),this.render()):this._padding},borderWidth:function(a){return"undefined"!==typeof a?(this._borderWidth=a,this._calcWH(),this._updateCanvasWH(),this.render()):this._borderWidth},borderColor:function(a){return"undefined"!==typeof a?(this._borderColor=a,this.render()):this._borderColor},borderRadius:function(a){return"undefined"!==
typeof a?(this._borderRadius=a,this.render()):this._borderRadius},backgroundColor:function(a){return"undefined"!==typeof a?(this._backgroundColor=a,this.render()):this._backgroundColor},backgroundGradient:function(a){return"undefined"!==typeof a?(this._backgroundColor=this._renderCtx.createLinearGradient(0,0,0,this.outerH),this._backgroundColor.addColorStop(0,a[0]),this._backgroundColor.addColorStop(1,a[1]),this.render()):this._backgroundColor},boxShadow:function(a,d){if("undefined"!==typeof a){var e=
a.split("px ");this._boxShadow={x:"none"===this._boxShadow?0:parseInt(e[0],10),y:"none"===this._boxShadow?0:parseInt(e[1],10),blur:"none"===this._boxShadow?0:parseInt(e[2],10),color:"none"===this._boxShadow?"":e[3]};this.shadowL=0>this._boxShadow.x?Math.abs(this._boxShadow.x)+this._boxShadow.blur:Math.abs(this._boxShadow.blur-this._boxShadow.x);this.shadowR=this._boxShadow.blur+this._boxShadow.x;this.shadowT=0>this._boxShadow.y?Math.abs(this._boxShadow.y)+this._boxShadow.blur:Math.abs(this._boxShadow.blur-
this._boxShadow.y);this.shadowB=this._boxShadow.blur+this._boxShadow.y;this.shadowW=this.shadowL+this.shadowR;this.shadowH=this.shadowT+this.shadowB;this._calcWH();if(!d)return this._updateCanvasWH(),this.render()}else return this._boxShadow},innerShadow:function(a){return"undefined"!==typeof a?(this._innerShadow=a,this.render()):this._innerShadow},selectionColor:function(a){return"undefined"!==typeof a?(this._selectionColor=a,this.render()):this._selectionColor},placeHolder:function(a){return"undefined"!==
typeof a?(this._placeHolder=a,this.render()):this._placeHolder},value:function(a){return"undefined"!==typeof a?(this._value=a,this.focus()):this._value},onsubmit:function(a){if("undefined"!==typeof a)return this._onsubmit=a,this;this._onsubmit()},onkeydown:function(a){if("undefined"!==typeof a)return this._onkeydown=a,this;this._onkeydown()},onkeyup:function(a){if("undefined"!==typeof a)return this._onkeyup=a,this;this._onkeyup()},focus:function(a){var d=this,e;if(!d._readonly){d._hasFocus||d._onfocus(d);
d._selectionUpdated?delete d._selectionUpdated:d._selection=[0,0];d._cursorPos="number"===typeof a?a:d._clipText().length;d._placeHolder===d._value&&(d._value="");d._hasFocus=!0;d._cursor=!0;d._cursorInterval&&clearInterval(d._cursorInterval);d._cursorInterval=setInterval(function(){d._cursor=!d._cursor;d.render()},500);a=navigator.userAgent.toLowerCase();a=0<=a.indexOf("chrome")&&0<=a.indexOf("mobile")&&0<=a.indexOf("android");var r="undefined"!==typeof window.orientation;r&&!a&&document&&document.createElement&&
(e=document.createElement("input"))?(e.type="text",e.style.opacity=0,e.style.position="absolute",e.style.left=d._x+d._extraX+(d._canvas?d._canvas.offsetLeft:0)+"px",e.style.top=d._y+d._extraY+(d._canvas?d._canvas.offsetTop:0)+"px",e.style.width=d._width,e.style.height=0,document.body.appendChild(e),e.focus(),e.addEventListener("blur",function(){d.blur(d)},!1)):r&&d.value(prompt(d._placeHolder)||"");return d.render()}},blur:function(a){a=a||this;a._disableBlur||(a._onblur(a),a._cursorInterval&&clearInterval(a._cursorInterval),
a._hasFocus=!1,a._cursor=!1,a._selection=[0,0],""===a._value&&(a._value=a._placeHolder));return a.render()},disableBlur:function(a){(a||this)._disableBlur=!0},enableBlur:function(a){(a||this)._disableBlur=!1},keydown:function(a,d){var y=a.which,r=a.shiftKey,g=null,h;if(d._hasFocus){d._onkeydown(a,d);if(65===y&&(a.ctrlKey||a.metaKey))return d._selection=[0,d._value.length],a.preventDefault(),d.render();if(17===y||a.metaKey||a.ctrlKey)return d;a.preventDefault();if(8===y)!d._clearSelection()&&0<d._cursorPos&&
(r=d._value.substr(0,d._cursorPos-1),h=d._value.substr(d._cursorPos,d._value.length),d._value=r+h,d._cursorPos--);else if(37===y)0<d._cursorPos&&(d._cursorPos--,d._cursor=!0,d._selection=[0,0]);else if(39===y)d._cursorPos<d._value.length&&(d._cursorPos++,d._cursor=!0,d._selection=[0,0]);else if(13===y)d._onsubmit(a,d);else if(9===y)if(d._tabToClear)d._value="",d._cursorPos=0;else{var f=e[d._inputsIndex+1]?d._inputsIndex+1:0;f!==d._inputsIndex&&(d.blur(),setTimeout(function(){e[f].focus()},10))}else if(g=
d._mapCodeToKey(r,y)){d._clearSelection();if(d._maxlength&&d._maxlength<=d._value.length)return;r=d._value?d._value.substr(0,d._cursorPos):"";h=d._value?d._value.substr(d._cursorPos):"";d._value=r+g+h;d._cursorPos++}return 13==y&&d._renderOnReturn||13!==y?d.render():function(){}}},click:function(a,d){var e=d._mousePos(a),r=e.x,e=e.y;if(d._endSelection)delete d._endSelection,delete d._selectionUpdated;else if(d._canvas&&d._overInput(r,e)||!d._canvas){if(d._mouseDown)return d._mouseDown=!1,d.click(a,
d),d.focus(d._clickPos(r,e))}else return d.blur()},mousemove:function(a,d){var e=d._mousePos(a),r=e.x,g=e.y;(e=d._overInput(r,g))&&d._canvas?(d._canvas.style.cursor="text",d._wasOver=!0):d._wasOver&&d._canvas&&(d._canvas.style.cursor="default",d._wasOver=!1);if(d._hasFocus&&0<=d._selectionStart)if(g=d._clickPos(r,g),r=Math.min(d._selectionStart,g),g=Math.max(d._selectionStart,g),!e)d._selectionUpdated=!0,d._endSelection=!0,delete d._selectionStart,d.render();else if(d._selection[0]!==r||d._selection[1]!==
g)d._selection=[r,g],d.render()},mousedown:function(a,d){var e=d._mousePos(a),r=e.x,e=e.y,g=d._overInput(r,e);d._mouseDown=g;d._hasFocus&&g&&(d._selectionStart=d._clickPos(r,e))},mouseup:function(a,d){var e=d._mousePos(a),r=e.x,e=e.y,g=d._clickPos(r,e)!==d._selectionStart;d._hasFocus&&0<=d._selectionStart&&d._overInput(r,e)&&g?(d._selectionUpdated=!0,delete d._selectionStart,d.render()):delete d._selectionStart;d.click(a,d)},renderCanvas:function(){return this._renderCanvas},cleanup:function(){this._canvas.removeEventListener("mouseup",
this.mouseupCanvasListener,!1);this._canvas.removeEventListener("mousedown",this.mousedownCanvasListener,!1);this._canvas.removeEventListener("mousemove",this.mousemoveCanvasListener,!1);window.removeEventListener("keydown",this.keydownWindowListener,!1);window.removeEventListener("keyup",this.keyupWindowListener,!1);window.removeEventListener("mouseup",this.mouseupWindowListener,!0);window.removeEventListener("paste",this.pasteWindowListener,!1);clearInterval(this._cursorInterval);this._canvas.style.cursor=
"default";for(var a=0;a<e.length;a++)e[a]===this&&e.remove(a)},render:function(){var a=this,d=a._renderCtx,e=a.outerW,r=a.outerH,g=a._borderRadius,h=a._borderWidth,f=a.shadowW,n=a.shadowH;d.clearRect(0,0,d.canvas.width,d.canvas.height);d.shadowOffsetX=a._boxShadow.x;d.shadowOffsetY=a._boxShadow.y;d.shadowBlur=a._boxShadow.blur;d.shadowColor=a._boxShadow.color;0<a._borderWidth&&(d.fillStyle=a._borderColor,a._roundedRect(d,a.shadowL,a.shadowT,e-f,r-n,g),d.fill(),d.shadowOffsetX=0,d.shadowOffsetY=0,
d.shadowBlur=0);a._drawTextBox(function(){d.shadowOffsetX=0;d.shadowOffsetY=0;d.shadowBlur=0;var l=a._clipText(),C=a._padding+a._borderWidth+a.shadowT;if(0<a._selection[1]){var u=a._textWidth(l.substring(0,a._selection[0])),D=a._textWidth(l.substring(a._selection[0],a._selection[1]));d.fillStyle=a._selectionColor;d.fillRect(C+u,C,D,a._height)}d.fillStyle=a._placeHolder===a._value&&""!==a._value?a._placeHolderColor:a._fontColor;a._cursor&&(u=a._textWidth(l.substring(0,a._cursorPos)),d.fillRect(C+u,
C,1,a._height));u=a._padding+a._borderWidth+a.shadowL;C=Math.round(C+a._height/2);d.font=a._fontStyle+" "+a._fontWeight+" "+a._fontSize+"px "+a._fontFamily;d.textAlign="left";d.textBaseline="middle";d.fillText(l,u,C);D=a._innerShadow.split("px ");l="none"===a._innerShadow?0:parseInt(D[0],10);C="none"===a._innerShadow?0:parseInt(D[1],10);u="none"===a._innerShadow?0:parseInt(D[2],10);D="none"===a._innerShadow?"":D[3];if(0<u){var w=a._shadowCtx,x=w.canvas.width,F=w.canvas.height;w.clearRect(0,0,x,F);
w.shadowBlur=u;w.shadowColor=D;w.shadowOffsetX=0;w.shadowOffsetY=C;w.fillRect(-1*e,-100,3*e,100);w.shadowOffsetX=l;w.shadowOffsetY=0;w.fillRect(x,-1*r,100,3*r);w.shadowOffsetX=0;w.shadowOffsetY=C;w.fillRect(-1*e,F,3*e,100);w.shadowOffsetX=l;w.shadowOffsetY=0;w.fillRect(-100,-1*r,100,3*r);a._roundedRect(d,h+a.shadowL,h+a.shadowT,e-2*h-f,r-2*h-n,g);d.clip();d.drawImage(a._shadowCanvas,0,0,x,F,h+a.shadowL,h+a.shadowT,x,F)}a._ctx&&(a._ctx.clearRect(a._x,a._y,d.canvas.width,d.canvas.height),a._ctx.drawImage(a._renderCanvas,
a._x,a._y));return a})},_drawTextBox:function(a){var d=this,e=d._renderCtx,r=d.outerW,g=d.outerH,h=d._borderRadius,f=d._borderWidth,n=d.shadowW,l=d.shadowH;if(""===d._backgroundImage)e.fillStyle=d._backgroundColor,d._roundedRect(e,f+d.shadowL,f+d.shadowT,r-2*f-n,g-2*f-l,h),e.fill(),a();else{var C=new Image;C.src=d._backgroundImage;C.onload=function(){e.drawImage(C,0,0,C.width,C.height,f+d.shadowL,f+d.shadowT,r,g);a()}}},_clearSelection:function(){if(0<this._selection[1]){var a=this._selection[0],
d=this._selection[1];this._value=this._value.substr(0,a)+this._value.substr(d);this._cursorPos=a;this._cursorPos=0>this._cursorPos?0:this._cursorPos;this._selection=[0,0];return!0}return!1},_clipText:function(a){a="undefined"===typeof a?this._value:a;var d=this._textWidth(a)/(this._width-this._padding);return(1<d?a.substr(-1*Math.floor(a.length/d)):a)+""},_textWidth:function(a){var d=this._renderCtx;d.font=this._fontStyle+" "+this._fontWeight+" "+this._fontSize+"px "+this._fontFamily;d.textAlign=
"left";return d.measureText(a).width},_calcWH:function(){this.outerW=this._width+2*this._padding+2*this._borderWidth+this.shadowW;this.outerH=this._height+2*this._padding+2*this._borderWidth+this.shadowH},_updateCanvasWH:function(){var a=this._renderCanvas.width,d=this._renderCanvas.height;this._renderCanvas.setAttribute("width",this.outerW);this._renderCanvas.setAttribute("height",this.outerH);this._shadowCanvas.setAttribute("width",this._width+2*this._padding);this._shadowCanvas.setAttribute("height",
this._height+2*this._padding);this._ctx&&this._ctx.clearRect(this._x,this._y,a,d)},_roundedRect:function(a,d,e,r,g,h){r<2*h&&(h=r/2);g<2*h&&(h=g/2);a.beginPath();a.moveTo(d+h,e);a.lineTo(d+r-h,e);a.quadraticCurveTo(d+r,e,d+r,e+h);a.lineTo(d+r,e+g-h);a.quadraticCurveTo(d+r,e+g,d+r-h,e+g);a.lineTo(d+h,e+g);a.quadraticCurveTo(d,e+g,d,e+g-h);a.lineTo(d,e+h);a.quadraticCurveTo(d,e,d+h,e);a.closePath()},_overInput:function(a,d){var e=a<=this._x+this._extraX+this._width+2*this._padding,r=d>=this._y+this._extraY,
g=d<=this._y+this._extraY+this._height+2*this._padding;return a>=this._x+this._extraX&&e&&r&&g},_clickPos:function(a,d){var e=this._value;this._value===this._placeHolder&&(e="");var e=this._clipText(e),r=0,g=e.length;if(a-(this._x+this._extraX)<this._textWidth(e))for(var h=0;h<e.length;h++)if(r+=this._textWidth(e[h]),r>=a-(this._x+this._extraX)){g=h;break}return g},_mousePos:function(a){var d=a.target,e=document.defaultView.getComputedStyle(d,void 0),r=parseInt(e.paddingLeft,10)||0,g=parseInt(e.paddingLeft,
10)||0,h=parseInt(e.borderLeftWidth,10)||0,e=parseInt(e.borderLeftWidth,10)||0,f=document.body.parentNode.offsetTop||0,n=document.body.parentNode.offsetLeft||0,l=0,C=0;if("unefined"!==typeof d.offsetParent){do l+=d.offsetLeft,C+=d.offsetTop;while(d=d.offsetParent)}return{x:a.pageX-(l+(r+h+n)),y:a.pageY-(C+(g+e+f))}},_mapCodeToKey:function(a,d){for(var e=[8,9,13,16,17,18,20,27,91,92],r="",r=0;r<e.length;r++)if(d===e[r])return;if("boolean"===typeof a&&"number"===typeof d)return e={32:" ",48:")",49:"!",
50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",59:":",107:"+",189:"_",186:":",187:"+",188:"<",190:">",191:"?",192:"~",219:"{",220:"|",221:"}",222:'"'},r=a?65<=d&&90>=d?String.fromCharCode(d):e[d]:65<=d&&90>=d?String.fromCharCode(d).toLowerCase():96===d?"0":97===d?"1":98===d?"2":99===d?"3":100===d?"4":101===d?"5":102===d?"6":103===d?"7":104===d?"8":105===d?"9":188===d?",":190===d?".":191===d?"/":192===d?"`":220===d?"\\":187===d?"=":189===d?"-":222===d?"'":186===d?";":219===d?"[":221===d?"]":
String.fromCharCode(d)}}})();
(function(e,a){"object"==typeof exports?module.exports=a():"function"==typeof define&&define.amd?define(a):e.Spinner=a()})(this,function(){function e(a,d){var e=document.createElement(a||"div"),g;for(g in d)e[g]=d[g];return e}function a(a){for(var d=1,e=arguments.length;d<e;d++)a.appendChild(arguments[d]);return a}function d(a,d,e,g){var h=["opacity",d,~~(100*a),e,g].join("-");e=0.01+e/g*100;g=Math.max(1-(1-a)/d*(100-e),a);var f=D.substring(0,D.indexOf("Animation")).toLowerCase();u[h]||(w.insertRule("@"+
(f&&"-"+f+"-"||"")+"keyframes "+h+"{0%{opacity:"+g+"}"+e+"%{opacity:"+a+"}"+(e+0.01)+"%{opacity:1}"+(e+d)%100+"%{opacity:"+a+"}100%{opacity:"+g+"}}",w.cssRules.length),u[h]=1);return h}function y(a,d){var e=a.style,g,h;d=d.charAt(0).toUpperCase()+d.slice(1);for(h=0;h<C.length;h++)if(g=C[h]+d,void 0!==e[g])return g;if(void 0!==e[d])return d}function r(a,d){for(var e in d)a.style[y(a,e)||e]=d[e];return a}function g(a){for(var d=1;d<arguments.length;d++){var e=arguments[d],g;for(g in e)void 0===a[g]&&
(a[g]=e[g])}return a}function h(a){for(var d={x:a.offsetLeft,y:a.offsetTop};a=a.offsetParent;)d.x+=a.offsetLeft,d.y+=a.offsetTop;return d}function f(a,d){return"string"==typeof a?a:a[d%a.length]}function n(a){if("undefined"==typeof this)return new n(a);this.opts=g(a||{},n.defaults,x)}function l(){function d(a,g){return e("<"+a+' xmlns="urn:schemas-microsoft.com:vml" class="spin-vml">',g)}w.addRule(".spin-vml","behavior:url(#default#VML)");n.prototype.lines=function(e,g){function h(){return r(d("group",
{coordsize:C+" "+C,coordorigin:-n+" "+-n}),{width:C,height:C})}function l(c,e,P){a(v,a(r(h(),{rotation:360/g.lines*c+"deg",left:~~e}),a(r(d("roundrect",{arcsize:g.corners}),{width:n,height:g.width,left:g.radius,top:-g.width>>1,filter:P}),d("fill",{color:f(g.color,c),opacity:g.opacity}),d("stroke",{opacity:0}))))}var n=g.length+g.width,C=2*n,c=2*-(g.width+g.length)+"px",v=r(h(),{position:"absolute",top:c,left:c});if(g.shadow)for(c=1;c<=g.lines;c++)l(c,-2,"progid:DXImageTransform.Microsoft.Blur(pixelradius=2,makeshadow=1,shadowopacity=.3)");
for(c=1;c<=g.lines;c++)l(c);return a(e,v)};n.prototype.opacity=function(a,d,e,g){a=a.firstChild;g=g.shadow&&g.lines||0;a&&d+g<a.childNodes.length&&(a=(a=(a=a.childNodes[d+g])&&a.firstChild)&&a.firstChild)&&(a.opacity=e)}}var C=["webkit","Moz","ms","O"],u={},D,w=function(){var d=e("style",{type:"text/css"});a(document.getElementsByTagName("head")[0],d);return d.sheet||d.styleSheet}(),x={lines:12,length:7,width:5,radius:10,rotate:0,corners:1,color:"#000",direction:1,speed:1,trail:100,opacity:0.25,fps:20,
zIndex:2E9,className:"spinner",top:"auto",left:"auto",position:"relative"};n.defaults={};g(n.prototype,{spin:function(a){this.stop();var d=this,g=d.opts,f=d.el=r(e(0,{className:g.className}),{position:g.position,width:0,zIndex:g.zIndex}),l=g.radius+g.length+g.width,n,C;a&&(a.insertBefore(f,a.firstChild||null),C=h(a),n=h(f),r(f,{left:("auto"==g.left?C.x-n.x+(a.offsetWidth>>1):parseInt(g.left,10)+l)+"px",top:("auto"==g.top?C.y-n.y+(a.offsetHeight>>1):parseInt(g.top,10)+l)+"px"}));f.setAttribute("role",
"progressbar");d.lines(f,d.opts);if(!D){var c=0,v=(g.lines-1)*(1-g.direction)/2,E,H=g.fps,P=H/g.speed,t=(1-g.opacity)/(P*g.trail/100),Q=P/g.lines;(function p(){c++;for(var q=0;q<g.lines;q++)E=Math.max(1-(c+(g.lines-q)*Q)%P*t,g.opacity),d.opacity(f,q*g.direction+v,E,g);d.timeout=d.el&&setTimeout(p,~~(1E3/H))})()}return d},stop:function(){var a=this.el;a&&(clearTimeout(this.timeout),a.parentNode&&a.parentNode.removeChild(a),this.el=void 0);return this},lines:function(g,h){function l(a,c){return r(e(),
{position:"absolute",width:h.length+h.width+"px",height:h.width+"px",background:a,boxShadow:c,transformOrigin:"left",transform:"rotate("+~~(360/h.lines*n+h.rotate)+"deg) translate("+h.radius+"px,0)",borderRadius:(h.corners*h.width>>1)+"px"})}for(var n=0,C=(h.lines-1)*(1-h.direction)/2,w;n<h.lines;n++)w=r(e(),{position:"absolute",top:1+~(h.width/2)+"px",transform:h.hwaccel?"translate3d(0,0,0)":"",opacity:h.opacity,animation:D&&d(h.opacity,h.trail,C+n*h.direction,h.lines)+" "+1/h.speed+"s linear infinite"}),
h.shadow&&a(w,r(l("#000","0 0 4px #000"),{top:"2px"})),a(g,a(w,l(f(h.color,n),"0 0 1px rgba(0,0,0,.1)")));return g},opacity:function(a,d,e){d<a.childNodes.length&&(a.childNodes[d].style.opacity=e)}});var F=r(e("group"),{behavior:"url(#default#VML)"});!y(F,"transform")&&F.adj?l():D=y(F,"animation");return n});window.m=window.m||{};
(function(e,a){var d="undefined";(function(a){e.log=a()})(function(){function e(d,g){var h=d[g];if(h.bind===a){if(Function.prototype.bind===a)return r(h,d);try{return Function.prototype.bind.call(d[g],d)}catch(f){return r(h,d)}}else return d[g].bind(d)}function r(a,d){return function(){Function.prototype.apply.apply(a,[d,arguments])}}function g(a){for(var d=0;d<u.length;d++)l[u[d]]=a(u[d])}function h(){return typeof window!==d&&window.document!==a&&window.document.cookie!==a}function f(){try{return typeof window!==
d&&window.localStorage!==a}catch(e){return!1}}function n(a){var d=!1,e,g;for(g in l.levels)if(l.levels.hasOwnProperty(g)&&l.levels[g]===a){e=g;break}if(f())try{window.localStorage.mloglevel=e}catch(n){d=!0}else d=!0;d&&h()&&(window.document.cookie="mloglevel="+e+";")}var l={},C=function(){},u=["trace","debug","info","warn","error"],D=/mloglevel=([^;]+)/;l.levels={TRACE:0,DEBUG:1,INFO:2,WARN:3,ERROR:4,SILENT:5};l.setLevel=function(h){if("number"===typeof h&&0<=h&&h<=l.levels.SILENT)if(n(h),h===l.levels.SILENT)g(function(){return C});
else{if(typeof console===d)return g(function(a){return function(){typeof console!==d&&(l.setLevel(h),l[a].apply(l,arguments))}}),"No console available for logging";g(function(g){return h<=l.levels[g.toUpperCase()]?typeof console===d?C:console[g]===a?console.log!==a?e(console,"log"):C:e(console,g):C})}else if("string"===typeof h&&l.levels[h.toUpperCase()]!==a)l.setLevel(l.levels[h.toUpperCase()]);else throw"log.setLevel() called with invalid level: "+h;};l.enableAll=function(){l.setLevel(l.levels.TRACE)};
l.disableAll=function(){l.setLevel(l.levels.SILENT)};(function(){var d;f()&&(d=window.localStorage.mloglevel);d===a&&h()&&(d=(D.exec(window.document.cookie)||[])[1]);l.levels[d]===a&&(d="WARN");l.setLevel(l.levels[d])})();return l})})(window.m);window.m=window.m||{};
(function(e,a){function d(a){return(10>a?"0":"")+a}var y={0:["None","U"],1:["Time","sec"],2:["Delay","sec"],3:["Frequency","Hz"],4:["Time code format",""],5:["Distance","m"],6:["Speed","m/s"],7:["Acceleration","m/sec^2"],8:["Jerk","m/sec^3"],9:["Doppler","Hz"],10:["Doppler rate","Hz/sec"],11:["Energy","J"],12:["Power","W"],13:["Mass","g"],14:["Volume","l"],15:["Angular power density","W/ster"],16:["Integrated power density","W/rad"],17:["Spatial power density","W/m^2"],18:["Integrated power density",
"W/m"],19:["Spectral power density","W/MHz"],20:["Amplitude","U"],21:["Real","U"],22:["Imaginary","U"],23:["Phase","rad"],24:["Phase","deg"],25:["Phase","cycles"],26:["10*Log","U"],27:["20*Log","U"],28:["Magnitude","U"],29:["Unknown","U"],30:["Unknown","U"],31:["General dimensionless",""],32:["Counts",""],33:["Angle","rad"],34:["Angle","deg"],35:["Relative power","dB"],36:["Relative power","dBm"],37:["Relative power","dBW"],38:["Solid angle","ster"],40:["Distance","ft"],41:["Distance","nmi"],42:["Speed",
"ft/sec"],43:["Speed","nmi/sec"],44:["Speed","knots=nmi/hr"],45:["Acceleration","ft/sec^2"],46:["Acceleration","nmi/sec^2"],47:["Acceleration","knots/sec"],48:["Acceleration","G"],49:["Jerk","G/sec"],50:["Rotation","rps"],51:["Rotation","rpm"],52:["Angular velocity","rad/sec"],53:["Angular velocity","deg/sec"],54:["Angular acceleration","rad/sec^2"],55:["Angular acceleration","deg/sec^2"],60:["Latitude","deg"],61:["Longitude","deg"],62:["Altitude","ft"],63:["Altitude","m"]};e.Mc={colormap:[[{pos:0,
red:0,green:0,blue:0},{pos:60,red:50,green:50,blue:50},{pos:100,red:100,green:100,blue:100},{pos:100,red:0,green:0,blue:0},{pos:100,red:0,green:0,blue:0},{pos:100,red:0,green:0,blue:0},{pos:100,red:0,green:0,blue:0}],[{pos:0,red:0,green:0,blue:15},{pos:10,red:0,green:0,blue:50},{pos:31,red:0,green:65,blue:75},{pos:50,red:0,green:85,blue:0},{pos:70,red:75,green:80,blue:0},{pos:83,red:100,green:60,blue:0},{pos:100,red:100,green:0,blue:0}],[{pos:0,red:100,green:100,blue:0},{pos:20,red:0,green:80,blue:40},
{pos:30,red:0,green:100,blue:100},{pos:50,red:10,green:10,blue:0},{pos:65,red:100,green:0,blue:0},{pos:88,red:100,green:40,blue:0},{pos:100,red:100,green:100,blue:0}],[{pos:0,red:0,green:75,blue:0},{pos:22,red:0,green:90,blue:90},{pos:37,red:0,green:0,blue:85},{pos:49,red:90,green:0,blue:85},{pos:68,red:90,green:0,blue:0},{pos:80,red:90,green:90,blue:0},{pos:100,red:95,green:95,blue:95}],[{pos:0,red:10,green:0,blue:23},{pos:18,red:34,green:0,blue:60},{pos:36,red:58,green:20,blue:47},{pos:55,red:74,
green:20,blue:28},{pos:72,red:90,green:43,blue:0},{pos:87,red:100,green:72,blue:0},{pos:100,red:100,green:100,blue:76}]]};e.PIPESIZE=1048576;e.initialize=function(a,d){var f=new BlueHeader(null);f.version="BLUE";f.size=0;f.type=1E3;f.format="SF";f.timecode=0;f.xstart=0;f.xdelta=1;f.xunits=0;f.subsize=1;f.ystart=0;f.ydelta=1;f.yunits=0;d||(d={});for(var n in d)f[n]=d[n];f["class"]=f.type/1E3;d.pipe?(f.pipe=!0,f.in_byte=0,f.out_byte=0,f.buf=new ArrayBuffer(d.pipesize||e.PIPESIZE),f.setData(f.buf),f.data_free=
f.dview.length):f.setData(a);return f};e.force1000=function(a){2===a["class"]&&(a.size=a.size&&!a.pipe?a.subsize*a.size:a.subsize,a.bpe/=a.subsize,a.ape=1)};e.grab=function(d,e,f,n){if(!d.dview)return 0;"C"===d.format[0]&&(f*=2);n=Math.min(e.length,d.dview.length-f);if(e.set===a)for(var l=0;l<n;l++)e[l]=d.dview[f+l];else e.set(d.dview.subarray(f,f+n));"C"===d.format[0]&&(n/=2);return n};e.filad=function(a,d,e){if(a.data_free<d.length)throw"Pipe full";var n=a.in_byte/a.dview.BYTES_PER_ELEMENT,l=n+
d.length;if(l>a.dview.length){var l=a.dview.length-n,r=d.length-l;d.subarray?(a.dview.set(d.subarray(0,l),n),a.dview.set(d.subarray(l,d.length),0)):(a.dview.set(d.slice(0,l),n),a.dview.set(d.slice(l,d.length),0));a.in_byte=r*a.dview.BYTES_PER_ELEMENT}else a.dview.set(d,n),a.in_byte=l*a.dview.BYTES_PER_ELEMENT%a.buf.byteLength;a.data_free-=d.length;if(a.onwritelisteners)for(d=0;d<a.onwritelisteners.length;d++)if(e)a.onwritelisteners[d]();else window.setTimeout(a.onwritelisteners[d],0)};e.pavail=function(a){return a.dview.length-
a.data_free};e.grabx=function(d,e,f,n){var l=d.dview.length-d.data_free;n===a&&(n=0);if(!f)f=Math.min(e.length-n,l);else if(f>e.length-n)throw"m.grabx : nget larger then available buffer space";if(0>f)throw"m.grabx : nget cannot be negative";if(f>l)return 0;var l=d.out_byte/d.dview.BYTES_PER_ELEMENT,r=l+f;if(r>=d.dview.length){var u=d.dview.length-l,r=r-d.dview.length;e.set(d.dview.subarray(l,d.dview.length),n);e.set(d.dview.subarray(0,r),n+u)}else e.set(d.dview.subarray(l,r),n);d.out_byte=r*d.dview.BYTES_PER_ELEMENT%
d.buf.byteLength;d.data_free+=f;return f};e.addPipeWriteListener=function(a,d){a.onwritelisteners||(a.onwritelisteners=[]);-1===a.onwritelisteners.indexOf(d)&&a.onwritelisteners.push(d)};e.units_name=function(a){a=y[a];return a[0]+" ("+a[1]+")"};e.trim_name=function(a){var d=a.indexOf("]");-1===d&&(d=a.indexOf("/"));-1===d&&(d=a.indexOf(":"));var e=a.substr(d+1,a.length).indexOf(".");0>e&&(e=a.length-d);return a.substr(d+1,d+e+1)};e.label=function(d,e){var f=["Unknown","U"];"string"===typeof d?f=
[d,null]:Array.isArray(d)?f=d:(f=y[d],f===a&&(f=["Unknown","U"]));var n="?";1E3===e?n="K":0.001===e?n="m":1E6===e?n="M":1E-6===e?n="u":1E9===e?n="G":1E-9===e?n="n":1E12===e?n="T":1E-12===e?n="p":1===e&&(n="");return f[1]?f[0]+" ("+n+f[1]+")":f[0]};var r="F";e.vstype=function(a){r=a;"D"===r||"L"===r||"F"===r||"I"===r||"B"===r||alert("Unsupported vector type")};e.vlog10=function(d,e,f){e===a&&(e=1E-20);f===a&&(f=d);for(var n=0;n<d.length&&!(f.length<=n);n++)f[n]=Math.log(Math.max(d[n],e))/Math.log(10)};
e.vlogscale=function(d,e,f,n){e===a&&(e=1E-20);f===a&&(f=1);n===a&&(n=d);for(var l=0;l<d.length&&!(n.length<=l);l++)n[l]=Math.log(Math.abs(Math.max(d[l],e)))/Math.log(10),n[l]*=f};e.cvmag2logscale=function(d,e,f,n){e===a&&(e=1E-20);f===a&&(f=1);n===a&&(n=d);for(var l=0,r=0;r<n.length;r++){l=2*r+1;if(l>=d.length)break;n[r]=d[l-1]*d[l-1]+d[l]*d[l];n[r]=Math.log(Math.abs(Math.max(n[r],e)))/Math.log(10);n[r]*=f}};e.vsmul=function(d,e,f,n){f===a&&(f=d);n===a&&(n=f.length);n=Math.min(f.length,n);n=Math.min(d.length,
n);for(var l=0;l<n&&!(f.length<=l);l++)f[l]=d[l]*e};e.vmxmn=function(a,d){var e=a[0],n=a[0],l=0,r=0;d=Math.min(d,a.length);for(var u=0;u<d;u++)a[u]>e&&(e=a[u],l=u),a[u]<n&&(n=a[u],r=u);return{smax:e,smin:n,imax:l,imin:r}};e.vmov=function(d,e,f,n,l){l===a&&(l=d.length);l=Math.min(d.length,l);for(var r=0;r<l;r++){var u=r*e,y=r*n;if(u>=d.length)break;if(y>=f.length)break;f[y]=d[u]}};e.vfill=function(d,e,f){f===a&&(f=d.length);f=Math.min(d.length,f);for(var n=0;n<f;n++)d[n]=e};e.vabs=function(d,e,f){f===
a&&(f=d.length);e===a&&(e=d);for(var n=0;n<f;n++)e[n]=Math.abs(d[n])};e.cvmag=function(d,e,f){f===a&&(f=e.length);f=Math.min(e.length,f);for(var n=0;n<f;n++){var l=2*n+1;if(l>=d.length)break;e[n]=Math.sqrt(d[l-1]*d[l-1]+d[l]*d[l])}};e.cvmag2=function(d,e,f){f===a&&(f=e.length);f=Math.min(e.length,f);for(var n=0,l=0;l<f;l++){n=2*l+1;if(n>=d.length)break;e[l]=d[n-1]*d[n-1]+d[n]*d[n]}};e.cvpha=function(d,e,f){f===a&&(f=e.length);f=Math.min(e.length,f);for(var n=0,l=0,r=n=0;r<f;r++){n=2*r+1;if(n>=d.length)break;
l=d[n-1];n=d[n];0===l&&0===n&&(l=1);e[r]=Math.atan2(n,l)}};e.cvphad=function(d,e,f){f===a&&(f=e.length);f=Math.min(e.length,f);for(var n=0,l=0,r=n=0;r<f;r++){n=2*r+1;if(n>=d.length)break;l=d[n-1];n=d[n];0===l&&0===n&&(l=1);e[r]=Math.atan2(n,l)*(180/Math.PI)}};e.trunc=function(a){return a-a%1};e.sign=function(a,d){return 0<=d?Math.abs(a):-Math.abs(a)};e.sec2tod=function(a,e){var f="",n=Date.UTC(1950,0,1);Date.UTC(1949,11,31);var l=new Date,f=new Date(l.getFullYear(),l.getMonth(),l.getDate(),0,0,0,
0),r=new Date(l.getFullYear(),l.getMonth(),l.getDate()+1,0,0,0,0),u=new Date(l.getFullYear(),0,1,0,0,0,0),y=new Date(l.getFullYear()+1,0,1,0,0,0),l=(r-f)/1E3,u=(y-u)/1E3,r=-1*u;0<=a?a<l?(f=f.getTime()+1E3*a,l=new Date(f),f=d(l.getHours())+":"+d(l.getMinutes())+":"+d(l.getSeconds())):86400===a?f="24:00:00":a<u?(n=a/l,n=[0<n?Math.floor(n):Math.ceil(n)],l=new Date(1E3*a+f.getTime()),f=n.toString()+"::"+d(l.getHours())+":"+d(l.getMinutes())+":"+d(l.getSeconds())):(f=Math.floor(1E3*a)+n,l=new Date(f),
f=l.getUTCFullYear()+":"+d(l.getUTCMonth()+1)+":"+d(l.getUTCDate())+"::"+d(l.getUTCHours())+":"+d(l.getUTCMinutes())+":"+d(l.getUTCSeconds())):a>r?(n=a/l,n=0>=n?Math.ceil(n):Math.floor(n),l=new Date(Math.abs(1E3*a)+f.getTime()),n=0===n?"-0":n.toString(),f=n+"::"+d(l.getHours())+":"+d(l.getMinutes())+":"+d(l.getSeconds())):(f=Math.floor(1E3*a)+n,l=new Date(f),f=l.getUTCFullYear()+":"+d(l.getUTCMonth()+1)+":"+d(l.getUTCDate())+"::"+d(l.getUTCHours())+":"+d(l.getUTCMinutes())+":"+d(l.getUTCSeconds()));
0!==a%1&&(f+="."+Math.abs(a%1).toPrecision(6).slice(2,8));e&&(n=f.indexOf("."),u=-1,-1!==n&&(u=f.substr(n,f.length).indexOf("0")),-1!==u&&(f=f.substr(0,n+u)));return f};e.sec2tspec=function(a,d,f){d=d||"";if(0<=a&&86400>=a)return e.sec2tod(a,f);a%=86400;return"delta"!==d&&0>=a?e.sec2tod(a+86400,f):"delta"===d&&0>=a?"-"+e.sec2tod(-1*a,f):e.sec2tod(a,f)};e.sec2tod_j1970=function(a){var e="";0<=a&&86400>a?(e=new Date(1E3*a),e=d(e.getHours())+":"+d(e.getMinutes())+":"+d(e.getSeconds())):0>a&&-31536E3<
a?(e=new Date(1E3*a),e=(a/86400*-1).toString()+"::"+d(e.getHours())+":"+d(e.getMinutes())+":"+d(e.getSeconds())):(e=new Date(1E3*(a-631152E3)),e=e.getFullYear()+":"+d(e.getMonth())+":"+d(e.getDate())+"::"+d(e.getHours())+":"+d(e.getMinutes())+":"+d(e.getSeconds()));0!==a%1&&(e+="."+(a%1).toPrecision(6).slice(2,8));return e};e.throttle=function(a,d){var e=(new Date).getTime();return function(){var n=(new Date).getTime();n-e>=a&&(e=n,d.apply(null,arguments))}}})(window.m);window.mx=window.mx||{};
(function(e,a,d){function y(){this.ymax=this.ymin=this.xmax=this.xmin=this.yl=this.xl=this.yo=this.xo=0;this.mode=this.func=d}function r(c){this.root=c;this.parent=document.createElement("div");this.parent.style.position="relative";this.parent.width=c.clientWidth;this.parent.height=c.clientHeight;c.appendChild(this.parent);this.canvas=document.createElement("canvas");this.canvas.style.position="absolute";this.canvas.style.top="0px";this.canvas.style.left="0px";this.canvas.width=c.clientWidth;this.canvas.height=
c.clientHeight;this.parent.appendChild(this.canvas);this.active_canvas=this.canvas;this.wid_canvas=document.createElement("canvas");this.wid_canvas.style.position="absolute";this.wid_canvas.style.top="0px";this.wid_canvas.style.left="0px";this.wid_canvas.style.zIndex=1;this.wid_canvas.width=c.clientWidth;this.wid_canvas.height=c.clientHeight;this.parent.appendChild(this.wid_canvas);this.level=this.text_h=this.text_w=0;this.width=this.parent.width;this.height=this.parent.height;this.ymrk=this.xmrk=
this.ypos=this.xpos=0;this.origin=1;this.stk=[new e.STKSTRUCT];e.setbgfg(this,"black","white");this.warpbox=this.event_cb=d;this.rmode=!1;this.linewidth=1;this.style=d;this.xi=!1;this.l=this.state_mask=this.button_press=this.button_release=0;this.r=this.width;this.t=0;this.b=this.height;this.scrollbar_x=new e.SCROLLBAR;this.scrollbar_y=new e.SCROLLBAR;this.prompt=d;this.pixel=[];this._renderCanvas=document.createElement("canvas")}function g(c,a,d,e,g,t,f){g<=d?f>d&&0<(e-a)*(f-d)-(t-a)*(g-d)&&(c+=
1):f<=d&&0>(e-a)*(f-d)-(t-a)*(g-d)&&(c-=1);return c}function h(c,a){a.animationFrameHandle||(a.animationFrameHandle=requestAnimFrame(e.withWidgetLayer(c,function(){e.erase_window(c);a.animationFrameHandle=d;var E=1.5*c.text_h;a.x=Math.max(a.x,0);a.y=Math.max(a.y,0);a.x=Math.min(a.x,c.width-a.w);a.y=Math.min(a.y,c.height-a.h);var H=a.x+z.GBorder+Math.max(0,z.sidelab),g=a.y+z.GBorder+z.toplab*(E+z.GBorder),t=a.w-2*z.GBorder-Math.abs(z.sidelab);e.widgetbox(c,a.x,a.y,a.w,a.h,H,g,t,a.h-2*z.GBorder-z.toplab*
(E+z.GBorder),a.title);var f=c.wid_canvas.getContext("2d");f.lineWidth=1;f.strokeStyle=c.xwbs;f.beginPath();f.moveTo(H,g-4+0.5);f.lineTo(H+t-1,g-4+0.5);f.stroke();f.strokeStyle=c.xwts;f.beginPath();f.moveTo(H,g-3+0.5);f.lineTo(H+t-1,g-3+0.5);f.stroke();for(var h=0;h<a.items.length;h++){var p=a.items[h],q=g+E*h;"separator"===p.style?(f.fillStyle=c.xwbs,f.fillRect(H,q,t,E),f.beginPath(),f.moveTo(H,q+0.5),f.lineTo(H+t,q+0.5),f.stroke(),f.textBaseline="middle",f.textAlign="left",f.fillStyle=c.xwfg,f.fillText(" "+
p.text+" ",H+2*c.text_w,q+E/2)):(f.fillStyle=c.xwlo,f.fillRect(H,q,t,E),f.beginPath(),f.moveTo(H,q+0.5),f.lineTo(H+t,q+0.5),f.stroke(),p.selected&&e.shadowbox(c,H-1,q,t+2,E,1,2,"",0),f.textBaseline="middle",f.textAlign="left",f.fillStyle=c.xwfg,"checkbox"===p.style?(f.fillText(" "+p.text+" ",H+2*c.text_w,q+E/2),f.strokeStyle=c.xwfg,f.strokeRect(H+1+c.text_w,q+(E-c.text_w)/2,c.text_w,c.text_w),p.checked&&(f.beginPath(),f.moveTo(H+1+c.text_w,q+(E-c.text_w)/2),f.lineTo(H+1+c.text_w+c.text_w,q+(E-c.text_w)/
2+c.text_w),f.stroke(),f.beginPath(),f.moveTo(H+1+c.text_w+c.text_w,q+(E-c.text_w)/2),f.lineTo(H+1+c.text_w,q+(E-c.text_w)/2+c.text_w),f.stroke())):(f.fillText(" "+p.text+" ",H,q+E/2),p.checked&&(f.beginPath(),f.moveTo(H+1,q+c.text_h/4),f.lineTo(H+1+c.text_w-2,q+c.text_h/4+c.text_h/2),f.lineTo(H+1,q+c.text_h/4+c.text_h),f.lineTo(H+1,q+c.text_h/4),f.fill())))}})))}function f(c,a){e.onWidgetLayer(c,function(){e.erase_window(c)});c.menu=d;c.widget=null;for(var E=0;E<a.items.length;E++){var H=a.items[E];
if(H.selected){H.handler?H.handler():H.menu&&(E=H.menu,"function"===typeof H.menu&&(E=H.menu()),E.finalize=a.finalize,e.menu(c,E));break}}!c.menu&&a.finalize&&a.finalize()}function n(c,a){e.onWidgetLayer(c,function(){e.erase_window(c)});c.menu=d;c.widget=null;!c.menu&&a.finalize&&a.finalize()}function l(c,a,d){var e=!0,f;f=a/c;0<c?f>d.tL?e=!1:f>d.tE&&(d.tE=f):0>c?f<d.tE?e=!1:f<d.tL&&(d.tL=f):0<a&&(e=!1);return e}function C(c,a,d,e,f,t,g,h){0>a&&(a=0);0>d&&(d=0);0>e&&(e=0);0>f&&(f=0);h&&(c.lineWidth=
h);g&&(c.strokeStyle=g);1===c.lineWidth%2&&(a===e&&(e=a=Math.floor(a)+0.5),d===f&&(f=d=Math.floor(d)+0.5));if(!t||!t.mode)c.beginPath(),c.moveTo(a,d),c.lineTo(e,f),c.stroke(),c.beginPath();else if("dashed"===t.mode){if(dashOn(c,t.on,t.off))c.beginPath(),c.moveTo(a,d),c.lineTo(e,f),c.stroke(),dashOff(c);else if(c.beginPath(),d===f)for(f=Math.min(a,e),e=Math.max(a,e);f<e;)c.moveTo(f,d),c.lineTo(f+t.on,d),c.stroke(),f+=t.on+t.off;else if(a===e)for(e=Math.min(d,f),f=Math.max(d,f);e<f;)c.moveTo(a,e),c.lineTo(a,
e+t.on),c.stroke(),e+=t.on+t.off;else throw"Only horizontal or vertical dashed lines are supported";c.beginPath()}else if("xor"===t.mode)if("undefined"===typeof Uint8ClampedArray)c.beginPath(),c.moveTo(a,d),c.lineTo(e,f),c.stroke(),c.beginPath();else{g=t=0;if(d===f)t=Math.abs(e-a),g=h,a=Math.min(a,e);else if(a===e)t=h,g=Math.abs(f-d),d=Math.min(d,f);else throw"Only horizontal and vertical lines can be drawn with XOR";if(0!==t&&0!==g){a=Math.floor(a);d=Math.floor(d);e=c.getImageData(a,d,t,g);f=e.data;
t=0;for(h=f.length;t<h;t+=4)f[t]=255-f[t],f[t+1]=255-f[t+1],f[t+2]=255-f[t+2],f[t+3]=255;c.putImageData(e,a,d);c.clearRect(0,0,1,1)}}}function u(c,a,d,e,f){D(c,a,f);d&&(c.strokeStyle=d);e&&(c.fillStyle=e);c.fill();c.closePath()}function D(c,a,d){if(!(1>a.length)){var e=a[0].x,f=a[0].y;c.lineWidth=d?d:1;c.beginPath();c.moveTo(e,f);for(d=0;d<a.length;d++)e=a[d].x,f=a[d].y,c.lineTo(e,f)}}function w(c){return Math.floor(Math.round(c/100*255))}function x(c,a,d){return"rgb("+Math.round(c)+", "+Math.round(a)+
", "+Math.round(d)+")"}function F(c,a){var d,e;if(".000000"===c.substring(5,8))d=4;else for(d=c.length-1;"0"===c[d];)d-=1;for(e=0;" "===c[e]&&(5<d-e+1||a);)e+=1;d=c.substring(e,d+1);-1===d.indexOf(".")&&(d+=".");return d}function B(c){c._animationFrameHandle=d;var a=c.warpbox;c.active_canvas.getContext("2d");if(a&&c.xpos>=a.xmin&&c.xpos<=a.xmax&&c.ypos>=a.ymin&&c.ypos<=a.ymax){a.xl=c.xpos;a.yl=c.ypos;var f=Math.min(a.xo,a.xl),g=Math.min(a.yo,a.yl),h=Math.abs(a.xl-a.xo),t=Math.abs(a.yl-a.yo);0!==h&&
0!==t&&("vertical"===a.mode?(f=c.l,h=c.r-c.l):"horizontal"===a.mode&&(g=c.t,t=c.b-c.t),e.onWidgetLayer(c,function(){e.erase_window(c);e.draw_box(c,"xor",f,g,h,t,a.style.opacity,a.style.fill_color)}))}}function M(c,a,d){return c<a?a:c>d?d:c}function N(c,a,e,f,g,t,h,l,p,q,s,k,A){q===d&&(q=0);s===d&&(s=0);k===d&&(k=e.width-q);A===d&&(A=e.height-s);c._renderCanvas.width=e.width;c._renderCanvas.height=e.height;for(var G=c._renderCanvas.getContext("2d"),J=G.createImageData(c._renderCanvas.width,c._renderCanvas.height),
n=new Uint8Array(e),r=0;r<e.height;++r)for(var u=0;u<e.width;++u){var L=4*(r*e.width+u);J.data[L]=n[L];J.data[L+1]=n[L+1];J.data[L+2]=n[L+2];J.data[L+3]=255}G.putImageData(J,0,0);a.save();a.globalAlpha=f;g||(a.imageSmoothingEnabled=!1,a.mozImageSmoothingEnabled=!1,a.webkitImageSmoothingEnabled=!1);a.drawImage(c._renderCanvas,q,s,k,A,t,h,l,p);a.restore()}function T(c,a,e,f,g,t,h,l,p,q,s,k,A){q===d&&(q=0);s===d&&(s=0);k===d&&(k=e.width-q);A===d&&(A=e.height-s);if(32768>e.width&&32768>e.height){c._renderCanvas.width=
e.width;c._renderCanvas.height=e.height;var G=c._renderCanvas.getContext("2d"),n=G.createImageData(c._renderCanvas.width,c._renderCanvas.height);e=new Uint8ClampedArray(e);n.data.set(e);G.putImageData(n,0,0)}else 32768>k&&32768>A?(c._renderCanvas.width=k,c._renderCanvas.height=A,O(c._renderCanvas,e,q,s,k,A)):(c._renderCanvas.width=Math.min(2*l,e.width),c._renderCanvas.height=Math.min(2*p,e.height),O(c._renderCanvas,e,q,s,k,A),k=c._renderCanvas.width,A=c._renderCanvas.height),s=q=0;a.save();a.globalAlpha=
f;g||(a.imageSmoothingEnabled=!1,a.mozImageSmoothingEnabled=!1,a.webkitImageSmoothingEnabled=!1);a.drawImage(c._renderCanvas,q,s,k,A,t,h,l,p);a.restore()}function O(c,a,d,e,f,g){var h=new Uint32Array(a);f||(f=a.width);g||(g=a.height);d||(d=0);e||(e=0);var l=c.width,p=c.height;c=c.getContext("2d");var q=c.createImageData(l,p),s=new ArrayBuffer(q.data.length),k=new Uint8ClampedArray(s),s=new Uint32Array(s);f/=l;g/=p;for(var A=0,G=0,p=A=0;p<s.length;p++)A=Math.round(Math.floor(p%l)*f)+d,G=Math.round(Math.floor(p/
l)*g)+e,A=Math.floor(G*a.width+A),s[p]=h[A];q.data.set(k);c.putImageData(q,0,0)}e.XW_INIT=-3;e.XW_DRAW=1;e.XW_EVENT=2;e.XW_UPDATE=3;e.XW_COMMAND=5;e.SB_EXPAND=1;e.SB_SHRINK=2;e.SB_FULL=3;e.SB_STEPINC=4;e.SB_STEPDEC=5;e.SB_PAGEINC=6;e.SB_PAGEDEC=7;e.SB_DRAG=8;e.SB_WHEELUP=9;e.SB_WHEELDOWN=10;e.L_ArrowLeft=1001;e.L_ArrowRight=1002;e.L_ArrowUp=1003;e.L_ArrowDown=1004;e.L_dashed=801;e.GBorder=3;e.L_RModeOff=900;e.L_RModeOn=901;e.L_PixelSymbol=1;e.L_CircleSymbol=2;e.L_SquareSymbol=3;e.L_PlusSymbol=4;e.L_XSymbol=
5;e.L_TriangleSymbol=6;e.L_ITriangleSymbol=7;e.L_HLineSymbol=8;e.L_VLineSymbol=9;e.STKSTRUCT=function(){this.y2=this.x2=this.y1=this.x1=this.yscl=this.xscl=this.ymax=this.ymin=this.xmax=this.xmin=0};e.SCROLLBAR=function(){this.repeat_count=this.origin=this.mxevent=this.arrow=this.a2=this.a1=this.soff=this.swmin=this.sw=this.s1=this.h=this.w=this.y=this.x=this.repeat_pause=this.initial_pause=this.dragoutline=this.scale=this.page=this.step=this.trange=this.tmin=this.srange=this.smin=this.action=this.flag=
null};e.open=function(c){c=new r(c);c.wid_canvas.oncontextmenu=function(c){c.preventDefault();return!1};this._ctx=c.active_canvas.getContext("2d");c.onmousemove=function(c){return function(a){var f=a.target.getBoundingClientRect();c.x=a.x||a.clientX;c.y=a.y||a.clientY;c.xpos=a.offsetX===d?a.pageX-f.left-window.scrollX:a.offsetX;c.ypos=a.offsetX===d?a.pageY-f.top-window.scrollY:a.offsetY;c.warpbox&&(c.warpbox.style=(a.ctrlKey||a.metaKey)&&c.warpbox.alt_style!==d?c.warpbox.alt_style:c.warpbox.def_style,
e.redraw_warpbox(c));e.widget_callback(c,a)}}(c);c.onmouseup=function(c){return function(a){if(c.warpbox){e.onWidgetLayer(c,function(){e.erase_window(c)});var f=c.warpbox;c.warpbox=d;if(1===a.which&&f.func){var g=f.xo,t=f.yo,h=f.xl,l=f.yl;"vertical"===f.mode?(g=c.l,h=c.r):"horizontal"===f.mode&&(t=c.t,l=c.b);f.func(a,g,t,h,l,f.style.return_value)}}e.widget_callback(c,a)}}(c);c.onmousedown=function(c){return function(a){a.preventDefault();e.widget_callback(c,a);return!1}}(c);c.onkeydown=function(c){return function(a){if(c.warpbox){var d=
getKeyCode(a);17!==d&&224!==d&&91!==d&&93!==d||c.warpbox.style===c.warpbox.alt_style||(c.warpbox.style=c.warpbox.alt_style,e.redraw_warpbox(c))}e.widget_callback(c,a)}}(c);c.onkeyup=function(c){return function(a){c.warpbox&&(a=getKeyCode(a),17!==a&&224!==a&&91!==a&&93!==a||c.warpbox.style===c.warpbox.def_style||(c.warpbox.style=c.warpbox.def_style,e.redraw_warpbox(c)))}}(c);c.ontouchend=function(c){return function(a){c.onmouseup({which:1})}}(c);c.ontouchmove=function(c){return function(a){var f=c.canvas,
g=0,t=0;if(f.offsetParent!==d){do g+=f.offsetLeft,t+=f.offsetTop;while(f=f.offsetParent)}c.xpos=a.targetTouches[0].pageX-g;c.ypos=a.targetTouches[0].pageY-t;e.redraw_warpbox(c)}}(c);e.enableListeners(c);return c};e.enableListeners=function(c){e.addEventListener(c,"mousemove",c.onmousemove,!1);window.addEventListener("mouseup",c.onmouseup,!1);e.addEventListener(c,"mousedown",c.onmousedown,!1);window.addEventListener("keydown",c.onkeydown,!1);window.addEventListener("keyup",c.onkeyup,!1)};e.disableListeners=
function(c){e.removeEventListener(c,"mousemove",c.onmousemove,!1);window.removeEventListener("mouseup",c.onmouseup,!1);e.removeEventListener(c,"mousedown",c.onmousedown,!1);window.removeEventListener("keydown",c.onkeydown,!1);window.removeEventListener("keyup",c.onkeyup,!1)};e.addEventListener=function(c,a,d,e){return c.wid_canvas.addEventListener(a,d,e)};e.removeEventListener=function(c,a,d,e){return c.wid_canvas.removeEventListener(a,d,e)};e.dispatchEvent=function(c,a){return c.wid_canvas.dispatchEvent(a)};
e.onWidgetLayer=function(c,a){var d=c.active_canvas;c.active_canvas=c.wid_canvas;try{if(a)return a()}finally{c.active_canvas=d}};e.withWidgetLayer=function(c,a){return function(){e.onWidgetLayer(c,a)}};e.render=function(c,a){if(a){var e=c.active_canvas;e._animationFrameHandle||(e._animationFrameHandle=requestAnimFrame(function(){e._animationFrameHandle=d;a()}))}};e.fullscreen=function(c,a){a===d&&(a=!c.fullscreen);a?(c.fullscreen={position:c.root.style.position,height:c.root.style.height,width:c.root.style.width,
left:c.root.style.left,top:c.root.style.top,zIndex:c.root.style.zIndex},c.root.style.position="fixed",c.root.style.height="100%",c.root.style.width="100%",c.root.style.left="0px",c.root.style.top="0px",c.root.style.zIndex=16777271):(c.root.style.position=c.fullscreen.position,c.root.style.height=c.fullscreen.height,c.root.style.width=c.fullscreen.width,c.root.style.left=c.fullscreen.left,c.root.style.top=c.fullscreen.top,c.root.style.zIndex=c.fullscreen.zIndex,c.fullscreen=d);e.checkresize(c)};e.checkresize=
function(c){var a=c.canvas;return a.height!==c.root.clientHeight||a.width!==c.root.clientWidth?(c.height=c.root.clientHeight,c.width=c.root.clientWidth,c.canvas.height=c.height,c.canvas.width=c.width,c.wid_canvas.height=c.height,c.wid_canvas.width=c.width,!0):!1};e.invertbgfg=function(c){e.setbgfg(c,c.fg,c.bg,!c.xi)};e.mixcolor=function(c,a,d){c=tinycolor(c).toRgb();a=tinycolor(a).toRgb();var e=1-d;a.r=c.r*e+a.r*d;a.g=c.g*e+a.g*d;a.b=c.b*e+a.b*d;return tinycolor(a).toHexString(!0)};e.linear_gradient=
function(c,a,d,e,f,g){var h=c.active_canvas.getContext("2d");c=1/g.length;a=h.createLinearGradient(a,d,e,f);for(d=0;d<g.length-1;d++)a.addColorStop(c*d,g[d]);a.addColorStop(1,g[g.length-1]);return a};e.setbgfg=function(c,a,d,f){c.bg=a;c.fg=d;c.xi=f;tinycolor.equals(c.bg,"black")&&tinycolor.equals(c.fg,"white")?(c.xwfg=c.fg,c.xwbg="rgb(35%,35%,30%)",c.xwts="rgb(60%,60%,55%)",c.xwbs="rgb(25%,25%,20%)",c.xwms=e.mixcolor(c.xwts,c.xwbs,0.5),c.xwlo="rgb(15%,15%,10%)",c.hi=c.xwts):tinycolor.equals(c.bg,
"white")&&tinycolor.equals(c.fg,"black")?(c.xwfg=c.fg,c.xwbg="rgb(60%,60%,55%)",c.xwts="rgb(80%,80%,75%)",c.xwbs="rgb(40%,40%,35%)",c.xwms=e.mixcolor(c.xwts,c.xwbs,0.5),c.xwlo="rgb(70%,70%,65%)",c.hi=c.xwbs):(a=tinycolor(c.bg).toRgb(),127.5<Math.sqrt(0.299*a.r*a.r+0.587*a.g*a.g+0.114*a.b*a.b)?(c.xwfg="black",c.xwbg="rgb(60%,60%,55%)",c.xwts="rgb(80%,80%,75%)",c.xwbs="rgb(40%,40%,35%)",c.xwms=e.mixcolor(c.xwts,c.xwbs,0.5),c.xwlo="rgb(70%,70%,65%)",c.hi=c.xwts):(c.xwfg="white",c.xwbg="rgb(35%,35%,30%)",
c.xwts="rgb(60%,60%,55%)",c.xwbs="rgb(25%,25%,20%)",c.xwms=e.mixcolor(c.xwts,c.xwbs,0.5),c.xwlo="rgb(15%,15%,10%)",c.hi=c.xwbs))};e.settheme=function(c,a){c.bg=a.bg;c.fg=a.fg;c.xi=a.xi;c.xwfg=a.xwfg;c.xwbg=a.xwbg;c.xwts=a.xwts;c.xwbs=a.xwbs;c.xwlo=a.xwlo;c.hi=a.hi};e.close=function(c){var a=c.wid_canvas;a.removeEventListener("mousemove",c.onmousemove,!1);a.removeEventListener("mouseup",c.onmouseup,!1);c.parent&&c.parent.parentNode&&c.parent.parentNode.removeChild(c.parent)};e.scrollbar=function(c,
a,f,g,h,t,l,n,p,q,s){var k,A,G,J=0,r=new e.SCROLLBAR;k=a.flag!==d?a.flag:a;A=Math.abs(k);G=t-h>g-f?3>c.origin?2:4:c.origin&2?3:1;10>A&&(a=r);if(10>A||0===a.action)e.scroll(c,a,e.XW_INIT,d,s),a.flag=k,a.initial_pause=-1,e.scroll_loc(a,f,h,g-f+1,t-h+1,G,s);a.srange=l.pe-l.ps;switch(A){case 0:f=g=h=1;break;case 1:case 11:f=g=0.9*a.srange;h=2;break;case 2:case 12:f=0.1*a.srange;g=9*f;h=2;break;case 3:case 13:f=1;g=a.srange-1;h=1;break;default:return 0}e.scroll_vals(a,l.ps,a.srange,n,p-n,f,g,h,s);0===
k?e.scroll(c,a,e.XW_DRAW,d,d):e.scroll(c,a,e.XW_EVENT,q,s)&&(l.ps!==a.smin&&(l.ps=a.smin,J+=1),l.pe!==a.smin+a.srange&&(l.pe=a.smin+a.srange,J+=2));return J};e.scroll=function(c,a,f,g,h){var t;if(a===d)return!1;switch(f){case e.XW_INIT:e.scroll_loc(a,0,0,c.width,20,1,h);e.scroll_vals(a,0,10,0,100,1,10,1,h);a.flag=0;a.action=0;a.initial_pause=0.25;a.repeat_pause=0.05;a.mxevent=!0;a.repeat_count=0;break;case e.XW_EVENT:t=0;if(a.mxevent)t=c.button_release?-c.button_release:c.button_press;else if("mousedown"===
g.type||"mouseup"===g.type){switch(g.which){case 1:t=1;break;case 2:t=2;break;case 3:t=3;break;case 4:t=4;break;case 5:t=5}"mouseup"===g.type&&(t=-t)}else if("mousewheel"===g.type||"DOM-MouseScroll"===g.type)g.wheelDelta&&0<g.wheelDelta?t=4:g.wheelDelta&&0>g.wheelDelta&&(t=5);if(0===a.action){if(4===t||5===t)c.xpos=a.x;if(1!==t&&2!==t&&4!==t&&5!==t||c.xpos<a.x||c.ypos<a.y||c.xpos>a.x+a.w||c.ypos>a.y+a.h)return!1}else if(0>t){a.action=a.repeat_count=0;break}a.origin&1?(g=c.xpos-a.x,a.origin&2&&(g=
a.w-g)):(g=c.ypos-a.y,2>=a.origin&&(g=a.h-g));if(0===a.action){a.repeat_count=0;var l=e.scroll_real2pix(a);a.s1=h.s1=l.s1;a.sw=h.sw=l.sw;a.soff=h.soff=g-a.s1;if(0===a.trange)a.smin=h.smin=a.tmin,a.srange=h.srange=0;else switch(t){case 1:a.action=g>a.a1&&g<a.a2?0<a.soff?e.SB_PAGEINC:e.SB_PAGEDEC:0<a.soff?e.SB_STEPINC:e.SB_STEPDEC;break;case 4:a.action=e.SB_WHEELUP;break;case 5:a.action=e.SB_WHEELDOWN;break}}else switch(a.action){case e.SB_WHEELUP:case e.SB_WHEELDOWN:case e.SB_EXPAND:case e.SB_SHRINK:case e.SB_FULL:a.action=
a.repeat_count=0}case e.XW_COMMAND:t=a.smin;g=a.srange;switch(a.action){case e.SB_STEPINC:t+=a.step;break;case e.SB_STEPDEC:t-=a.step;break;case e.SB_PAGEINC:t+=a.page;break;case e.SB_PAGEDEC:t-=a.page;break;case e.SB_FULL:t=a.tmin;g=a.trange;break;case e.SB_EXPAND:g*=a.scale;t=0>=t&&0<=t+a.srange?t*a.scale:t-(g-a.srange)/2;break;case e.SB_SHRINK:g/=a.scale;t=0>t&&0<=t+a.srange?t+g/a.scale:0===t&&0<=t+a.srange?g/a.scale:t+(a.srange-g)/2;break;case e.SB_WHEELUP:t-=a.page;break;case e.SB_WHEELDOWN:t+=
a.page}0<a.trange?(t=Math.max(a.tmin,Math.min(t,a.tmin+a.trange-g)),g=Math.min(g,a.trange)):(t=Math.min(a.tmin,Math.max(t,a.tmin+a.trange-g)),g=Math.max(g,a.trange));a.smin===t&&a.srange===g?a.action!==e.SB_DRAG&&(a.action=a.repeat_count=0):(a.smin=h.smin=t,a.srange=h.srange=g,a.repeat_count++);f===e.XW_COMMAND&&(e.scroll(c,a,e.XW_UPDATE,d),a.action=0);break;case e.XW_DRAW:case e.XW_UPDATE:e.redrawScrollbar(a,c,f)}return!0};e.scroll_loc=function(c,f,g,h,l,t,n){c!==d&&(c.x=n.x=f,c.y=n.y=g,c.w=n.w=
h,c.h=n.h=l,c.origin=n.origin=Math.max(1,Math.min(4,t)),c.origin&1?(c.a2=n.a2=c.w,c.arrow=n.arrow=Math.min(a.trunc((c.w-a.trunc(2*e.GBorder))/3),c.h+e.GBorder)):(c.a2=n.a2=c.h,c.arrow=n.arrow=Math.min(a.trunc((c.h-a.trunc(2*e.GBorder))/3),c.w+e.GBorder)),c.a1=n.a1=c.arrow+e.GBorder,c.a2-=c.arrow+e.GBorder,n.a2-=c.arrow+e.GBorder,c.swmin=n.swmin=Math.min(10,c.a2-c.a1),c.s1=n.s1=0,c.sw=n.sw=0,c.action=n.action=0)};e.scroll_vals=function(c,a,e,f,g,t,h,l,p){c!==d&&(c.smin=p.smin=a,c.srange=p.srange=e,
c.tmin=p.tmin=f,c.trange=p.trange=g,c.step=p.step=t,c.page=p.page=h,c.scale=p.scale=Math.max(l,1))};e.draw_symbol=function(c,a,d,f,g,t){var h=new Int32Array(new ArrayBuffer(4)),l=new Int32Array(new ArrayBuffer(4));h[0]=d;l[0]=f;e.draw_symbols(c,a,h,l,1,g,t)};e.draw_symbols=function(c,d,f,g,h,t,l){for(var n=c.active_canvas.getContext("2d"),p=0,q=0,s=0,k=0,A=0,A=!1,G=[],p=0;4>p;p++)G[p]={x:0,y:0};k="";A=0>l;q=Math.abs(l);s=2*q;n.fillStyle=d;n.strokeStyle=d;switch(t){case e.L_CircleSymbol:for(p=0;p<
h;p++)G=f[p],c=g[p],n.beginPath(),A?(n.arc(G,c,q,0,360),n.fill()):(n.arc(G,c,q,0,360),n.stroke());break;case e.L_SquareSymbol:if(A)for(p=0;p<h;p++)n.fillRect(f[p]-q,g[p]-q,s,s);else for(p=0;p<h;p++)n.strokeRect(f[p]-q,g[p]-q,s,s);break;case e.L_PixelSymbol:s=1;for(p=0;p<h;p+=s)n.beginPath(),n.arc(f[p],g[p],1,0,2*Math.PI,!0),n.fill();break;case e.L_ITriangleSymbol:q=-q;case e.L_TriangleSymbol:s=a.trunc(1.5*q);k=a.trunc(0.8*q);G[1].x=-k;G[1].y=s;G[2].x=2*k;G[2].y=0;G[3].x=-k;G[3].y=-s;c=[];for(p=0;4>
p;p++)c[p]={x:0,y:0};if(A)for(p=0;p<h;p++)c[0].x=f[p],c[0].y=g[p]-q,c[1].x=c[0].x+G[1].x,c[1].y=c[0].y+G[1].y,c[2].x=c[1].x+G[2].x,c[2].y=c[1].y+G[2].y,c[3].x=c[2].x+G[3].x,c[3].y=c[2].y+G[3].y,u(n,c);else for(p=0;p<h;p++)c[0].x=f[p],c[0].y=g[p]-q,c[1].x=c[0].x+G[1].x,c[1].y=c[0].y+G[1].y,c[2].x=c[1].x+G[2].x,c[2].y=c[1].y+G[2].y,c[3].x=c[2].x+G[3].x,c[3].y=c[2].y+G[3].y,A=n,D(A,c,void 0),A.stroke(),A.closePath();break;case e.L_PlusSymbol:for(p=0;p<h;p++)k=f[p],A=g[p],C(n,k,A+q,k,A-q),C(n,k+q,A,k-
q,A);break;case e.L_HLineSymbol:for(p=0;p<h;p++)k=f[p],A=g[p],C(n,k+q,A,k-q,A);break;case e.L_VLineSymbol:for(p=0;p<h;p++)k=f[p],A=g[p],C(n,k,A+q,k,A-q);break;case e.L_XSymbol:for(p=0;p<h;p++)k=f[p],A=g[p],C(n,k-q,A-q,k+q,A+q),C(n,k+q,A-q,k-q,A+q);break;default:if(k=t,q=a.trunc(c.text_w/2),A)for(p=0;p<h;p++)n.fillText(k.substring(0,2),f[p]-q,g[p]+q)}};e.trace=function(c,f,h,n,r,t,Q,R,p,q){if(h===d||n===d)throw"mx.trace requires xpoint and ypoint";t===d&&(t=1);Q===d&&(Q=1);R===d&&(R=0);p===d&&(p=0);
q===d&&(q={});if(0>=r)a.log.warn("No points to draw");else if(0===Q&&0===R)a.log.warn("No line or symbol to draw");else{var s;q.dashed&&(s={mode:"dashed",on:4,off:4});var k=e.origin(c.origin,4,c.stk[c.level]);if(0!==k.xscl&&0!==k.yscl){var A=k.x1,G=k.y1,J=k.xmin,K=1/k.xscl,u=k.ymin,C=1/k.yscl;q.noclip||e.clip(c,A,G,k.x2-A+1,k.y2-G+1);var L=Math.abs(k.xmax-k.xmin),S=Math.abs(k.ymax-k.ymin),X=Math.min(k.xmin,k.xmax),k=Math.min(k.ymin,k.ymax),w=X+L,x=k+S,y=4*Math.ceil(2*h.length),F=new Int32Array(new ArrayBuffer(y)),
y=new Int32Array(new ArrayBuffer(y)),I=0;if(0===Q){for(var D=t-1;D<=r;D+=t){var B=h[D],z=n[D],O=B>=X&&B<=w&&z>=k&&z<=x;O&&(F[I]=Math.round((B-J)*K)+A,y[I]=Math.round((z-u)*C)+G,I+=1)}0!==R&&1<I&&e.draw_symbols(c,f,F.subarray(0),y.subarray(0),I,R,p)}else if(!0===q.vertsym){for(D=t-1;D<=r;D+=t)B=h[D],z=n[D],B>=X&&B<=w&&(Q=Math.round((B-J)*K)+A,e.draw_line(c,f,Q,0,Q,c.height),z>=k&&z<=x&&(F[I]=Q,y[I]=Math.round((z-u)*C)+G,I+=1));0!==R&&1<I&&e.draw_symbols(c,f,F.subarray(0),y.subarray(0),I,R,p)}else if(!0===
q.horzsym){for(D=t-1;D<=r;D+=t)B=h[D],z=n[D],z>=k&&z<=x&&(Q=Math.round((z-u)*C)+G,e.draw_line(c,f,0,Q,c.width,Q),B>=X&&B<=w&&(F[I]=Math.round((B-J)*K)+A,y[I]=Q,I+=1));0!==R&&1<I&&e.draw_symbols(c,f,F.subarray(0),y.subarray(0),I,R,p)}else{var N;if(q&&q.highlight){N=[];N.push({start:A,color:f});for(D=0;D<q.highlight.length;D++)q.highlight[D].xstart>=w||q.highlight[D].xend<=X||(z=Math.max(q.highlight[D].xstart,X),B=Math.min(q.highlight[D].xend,w),z<B&&(z=Math.round((z-J)*K)+A,B=Math.round((B-J)*K)+A,
N.push({start:z,end:B,color:q.highlight[D].color})));N.sort(function(c,a){return c.start-a.start})}else N=f;var M,T=(c.stk[c.level].xmax+c.stk[c.level].xmin)/2,W=(c.stk[c.level].ymax+c.stk[c.level].ymin)/2,B=h[0],z=n[0];M=g(0,T,W,c.stk[c.level].xmin,c.stk[c.level].ymin,B,z);(O=B>=X&&B<=w&&z>=k&&z<=x)?(F[I]=Math.round((B-J)*K)+A,y[I]=Math.round((z-u)*C)+G,I+=1,0!==R&&e.draw_symbols(c,f,F,y,1,R,p)):I=0;for(var U=0,Z=!1,D=t;D<=t*(r-1);D+=t)if(L=B,S=z,B=h[D],z=n[D],M=g(M,T,W,L,S,B,z),Z=B>=X&&B<=w&&z>=
k&&z<=x,O&&Z)F[I]=Math.round((B-J)*K)+A,y[I]=Math.round((z-u)*C)+G,I+=1;else if(O=Z,L-=B,S-=z,0!==L||0!==S){var Y={tL:1,tE:0};l(L,X-B,Y)&&l(-L,B-w,Y)&&l(S,k-z,Y)&&l(-S,z-x,Y)&&(1>Y.tL&&(F[I]=Math.round((B-J+Y.tL*L)*K)+A,y[I]=Math.round((z-u+Y.tL*S)*C)+G,I+=1),0<Y.tE?(F[I]=Math.round((B-J+Y.tE*L)*K)+A,y[I]=Math.round((z-u+Y.tE*S)*C)+G,I+=1,e.draw_lines(c,N,F.subarray(U,I),y.subarray(U,I),I-U,Q,s),0!==R&&2<I-U&&e.draw_symbols(c,f,F.subarray(U+1,I),y.subarray(U+1,I),I-U-1,R,p),U=I):(F[I]=Math.round((B-
J)*K)+A,y[I]=Math.round((z-u)*C)+G,I+=1))}M=g(M,T,W,B,z,c.stk[c.level].xmax,c.stk[c.level].ymin);M=g(M,T,W,c.stk[c.level].xmax,c.stk[c.level].ymin,c.stk[c.level].xmin,c.stk[c.level].ymin);0<I-U&&(e.draw_lines(c,N,F.subarray(U,I),y.subarray(U,I),I-U,Q,s),Z&&(U+=1),0!==R&&1<I-U&&e.draw_symbols(c,f,F.subarray(U,I),y.subarray(U,I),I-1,R,p));q.fillStyle&&(1<I||0!==M)&&e.fill_trace(c,q.fillStyle,F,y,I)}q.noclip||e.clip(c,0,0,0,0)}}};e.draw_mode=function(c,a,e){c.linewidth=a===d?1:a;c.style=e};e.draw_line=
function(c,e,f,g,h,t,n,l){var p=c.active_canvas.getContext("2d");n===d&&(n=c.linewidth);l===d&&(l=c.style);"number"===typeof e&&(c.pixel&&0!==c.pixel.length?(e=Math.max(0,Math.min(c.pixel.length,e)),e=x(c.pixel[e].red,c.pixel[e].green,c.pixel[e].blue)):(a.log.warn("COLORMAP not initialized, defaulting to foreground"),e=c.fg));C(p,f,g,h,t,l,e,n)};e.rubberline=function(c,a,d,e,f){c=c.active_canvas.getContext("2d");C(c,a,d,e,f,{mode:"xor"},"white",1)};e.fill_trace=function(c,a,d,f,g){var h=c.active_canvas.getContext("2d");
Array.isArray(a)?h.fillStyle=e.linear_gradient(c,0,0,0,c.b-c.t,a):h.fillStyle=a;if(1>g)h.fillRect(c.l,c.t,c.r-c.l,c.b-c.t);else if(a){a=d[0];var n=f[0];h.beginPath();n===c.t?h.lineTo(c.l,c.t):h.lineTo(c.l,c.b);h.lineTo(a,n);for(var l=1;l<g;l++)a=d[l],n=f[l],h.lineTo(a,n);n===c.t&&h.lineTo(c.r,c.t);h.lineTo(c.r,c.b);f[0]===c.t&&h.lineTo(c.l,c.b);h.closePath();h.fill()}};e.draw_lines=function(c,e,f,g,h,t,n){var l=c.active_canvas.getContext("2d");if(!(1>h)){var p=f[0],q=g[0];t===d&&(t=c.linewidth);n===
d&&(n=c.style);n&&"dashed"===n.mode&&(dashOn(l,n.on,n.off)||a.log.warn("WARNING: Dashed lines aren't supported on your browser"));l.lineWidth=t;c=0;"string"===typeof e?e=[{start:0,color:e}]:e instanceof Array||(e.start===d&&(e.start=0),e=[e]);for(t=0;t<e.length;t++)null!=e[t].end&&e[t].end<p?e.remove(t):e[t].start<p&&(c=t);l.strokeStyle=e[c].color;l.beginPath();l.moveTo(p,q);for(t=0;t<h;t++)if(p!==f[t]||q!==g[t]){p=f[t];q=g[t];n=!1;if(0<c&&null!=e[c].end&&e[c].end<p)for(n=!0;null!=e[c].end&&e[c].end<
p&&(e.remove(c),c-=1,0!==c););if(c+1<e.length&&e[c+1].start<=p)for(n=!0;c+1<e.length&&e[c+1].start<=p;)c++;l.lineTo(p,q);n&&(l.stroke(),l.strokeStyle=e[c].color,l.beginPath(),l.lineTo(p,q))}l.stroke();dashOff(l);l.beginPath()}};e.clip=function(c,a,d,e,f){c=c.active_canvas.getContext("2d");0===a&&0===d&&0===e&&0===f?c.restore():(c.save(),c.beginPath(),c.rect(a,d,e,f),c.clip())};e.clear_window=function(c){var a=c.active_canvas.getContext("2d");a.fillStyle=c.bg;a.fillRect(0,0,c.width,c.height)};e.erase_window=
function(c){c.active_canvas.getContext("2d").clearRect(0,0,c.width,c.height)};e.rubberbox=function(c,a,d,f,g){e.warpbox(c,c.xpos,c.ypos,c.xpos,c.ypos,0,c.width,0,c.width,a,d,f,g)};e.warpbox=function(c,a,d,e,f,g,h,n,p,q,s,k,A){k||(k={});c.warpbox=new y;c.warpbox.xo=a;c.warpbox.yo=d;c.warpbox.xl=e;c.warpbox.yl=f;c.warpbox.xmin=g;c.warpbox.xmax=h;c.warpbox.ymin=n;c.warpbox.ymax=p;c.warpbox.func=q;c.warpbox.mode=s;c.warpbox.style=k;c.warpbox.def_style=k;c.warpbox.alt_style=A};e.origin=function(c,a,d){c=
Math.max(1,c);a=Math.max(1,a);var f=new e.STKSTRUCT;f.xmin=d.xmin;f.xmax=d.xmax;f.ymin=d.ymin;f.ymax=d.ymax;f.xscl=d.xscl;f.yscl=d.yscl;f.x1=d.x1;f.y1=d.y1;f.x2=d.x2;f.y2=d.y2;if(c!==a){var g=Math.abs(a-c);c=a+c;if(2===g||5!==c)f.xmin=d.xmax,f.xmax=d.xmin,f.xscl=-d.xscl;if(2===g||5===c)f.ymin=d.ymax,f.ymax=d.ymin,f.yscl=-d.yscl}return f};e.mult=function(c,a){var d=Math.max(Math.abs(c),Math.abs(a));if(0===d)return 1;var e=0.1447648*Math.log(d),e=e|e;1>d&&(e-=1);return 0>e?1/Math.pow(10,-3*e):Math.pow(10,
3*e)};e.widget_callback=function(c,a){if(c.prompt&&3===a.which)c.prompt.input.onsubmit();c.widget&&c.widget.callback(a)};e.prompt=function(c,a,f,g,h,t,n,l,p){if(t!==d&&(h=f(t),!h.valid))throw"Prompt default input value not valid due to '"+h.reason+"'";e.onWidgetLayer(c,function(){var q=c.active_canvas.getContext("2d"),s=q.font.indexOf("px"),k=s+3,s=q.font.substr(0,s),q=q.font.substr(k,q.font.length).toString(),q=new CanvasInput({height:c.text_h,fontFamily:q,fontSize:new Number(s),backgroundColor:c.bg,
fontColor:c.fg,borderWidth:0,borderRadius:0,padding:0,boxShadow:"none",innerShadow:"none",width:30*c.text_w,value:t!==d?t.toString():"",disableBlur:!0,renderOnReturn:!1,tabToClear:!0}),A=function(a,q){return function(){var k=this.value(),s=f(k);s.valid?(c.prompt=d,this.cleanup(),e.onWidgetLayer(c,function(){e.erase_window(c)}),g(k)):(e.message(c,"Value: '"+k+"' isn't valid due to '"+s.reason+"' - RETRY",d,a,q),setTimeout(function(){e.onWidgetLayer(c,function(){e.erase_window(c)});c.widget=null},null!=
p?p:4E3))}},k=function(c,a,d){return function(p,q){e.onWidgetLayer(c,function(){var k=(d.length+2)*c.text_w,s=k+31*c.text_w+6,f=2*c.text_h+6;p||(p=c.xpos);q||(q=c.ypos);var g=Math.max(0,Math.min(p,c.width-s)),h=Math.max(0,Math.min(q,c.height-f)),v=g+3,t=h+3,n=t+1.5*c.text_h,l=v+c.text_w;e.widgetbox(c,g,h,s,f,v,t,0,"");e.text(c,l,n,d);s=n-1.15*c.text_h;a.x(v+c.text_w+k-c.text_w);a.y(s);a.onsubmit(A(g,s-75));a.canvas()?a.render():a.canvas(c.active_canvas)})}}(c,q,a);k(n,l);q.focus();c.prompt={redraw:k,
input:q}})};e.floatValidator=function(c,a){return(a!==d&&!1!==a||""!==c)&&isNaN(parseFloat(c))||!isFinite(c)?{valid:!1,reason:"Failed float validation: not a valid floating point number"}:{valid:!0,reason:""}};e.intValidator=function(c,a){return(a===d||!1===a)&&""===c||parseFloat(c)===parseInt(c,10)&&!isNaN(c)?{valid:!0,reason:""}:{valid:!1,reason:"Failed integer validation: not a valid integer"}};e.message=function(c,a,d,f,g){e.onWidgetLayer(c,function(){var d=a.split(/\r\n|\r|\n/g),h=0,n;if(1===
d.length){d=[];h=Math.min((c.width-6)/c.text_w-2,a.length);if(0>=h)return;for(;40<h&&2.5*c.text_h*a.length<c.height*h;)h-=5;var p=0,q=0,s=0,k=0,A=0,G=0,d=[];for(n=!0;q<a.length;){for(var A=q+h-1,G=A=Math.min(A,a.length-1),l=!1,p=q;p<=A&&!l;p++)switch(a[p]){case ",":case ";":case " ":case ":":G=p;break;case "-":case "/":G!==p-1&&(G=p);break;case "@":case "\n":case "\r":n=!1,l=!0,G=p}p===a.length&&(G=A);l?d.push(a.substring(q,G)):(p=a.substring(q,G+1).replace(/^\s+/,""),d.push(p));q=G+1;k=Math.max(k,
d[s].length)}}else for(s=0;s<d.length;s++)h=Math.min((c.width-6)/c.text_w-2,Math.max(h,d[s].length));k=d.length;6<k&&(n=!1);p=0;s=Math.max(1,c.height/c.text_h);G=Math.min(k,p+s-1);h=(h+2)*c.text_w+6;k=(G-p+1)*c.text_h+6;f||(f=c.xpos);g||(g=c.ypos);q=Math.max(0,Math.min(f,c.width-h));A=Math.max(0,Math.min(g,c.height-k));s=q+3;l=A+3;e.widgetbox(c,q,A,h,k,s,l,0,"");k=l+c.text_h/3;for(s+=c.text_w;p<G;)k+=c.text_h,n&&(s=q+h/2-d[p].length*c.text_w/2),e.text(c,s,k,d[p]),p++;c.widget={type:"ONESHOT",callback:function(a){if("mousedown"===
a.type||"keydown"===a.type)c.widget=null,e.onWidgetLayer(c,function(){e.erase_window(c)})}}})};e.draw_box=function(c,a,e,f,g,h,n,l){var p=c.active_canvas.getContext("2d");if("xor"!==a)p.lineWidth=1,p.strokeStyle=a,p.strokeRect(e,f,g,h);else if("undefined"===typeof Uint8ClampedArray)p.lineWidth=1,p.strokeStyle=c.fg,p.strokeRect(e,f,g,h);else{e=Math.floor(e);f=Math.floor(f);g=Math.floor(g);h=Math.floor(h);c=c.canvas.getContext("2d");for(var q=c.getImageData(e,f,g,1),s=q.data,k=0;k<q.data.length;k++)s[4*
k]=255-s[4*k],s[4*k+1]=255-s[4*k+1],s[4*k+2]=255-s[4*k+2],s[4*k+3]=255;p.putImageData(q,e,f);q=c.getImageData(e,f+h,g,1);s=q.data;for(k=0;k<q.data.length;k++)s[4*k]=255-s[4*k],s[4*k+1]=255-s[4*k+1],s[4*k+2]=255-s[4*k+2],s[4*k+3]=255;p.putImageData(q,e,f+h);q=c.getImageData(e,f,1,h);s=q.data;for(k=0;k<h;k++)s[4*k]=255-s[4*k],s[4*k+1]=255-s[4*k+1],s[4*k+2]=255-s[4*k+2],s[4*k+3]=255;p.putImageData(q,e,f);q=c.getImageData(e+g,f,1,h);s=q.data;for(k=0;k<h;k++)s[4*k]=255-s[4*k],s[4*k+1]=255-s[4*k+1],s[4*
k+2]=255-s[4*k+2],s[4*k+3]=255;p.putImageData(q,e+g,f)}n!==d&&0<n&&(c=p.globalAlpha,p.globalAlpha=n,p.fillStyle=l?l:a,p.fillRect(e+1,f+1,g-1,h-1),p.globalAlpha=c)};e.set_font=function(c,a){var d=c.canvas.getContext("2d"),e=c.wid_canvas.getContext("2d");if(c.font&&c.font.width===a)d.font=c.text_h+"px "+c.font.font,e.font=c.text_h+"px "+c.font.font;else{var f=1;do{f+=1;d.font=f+"px Courier New, monospace";e.font=f+"px Courier New, monospace";var g=d.measureText("M");c.text_w=g.width;c.text_h=f}while(c.text_w<
a);c.font={font:"Courier New, monospace",width:a}}};e.textline=function(c,a,d,e,f,g){var h=c.active_canvas.getContext("2d");g||(g={});g.color||(g.color=c.fg);g.width||(g.width=1);C(h,a,d,e,f,g,g.color,g.width)};e.tics=function(c,a,d,e){var f=1,g=c;if(a===c)return{dtic:1,dtic1:c};f=Math.abs(a-c)/d;d=Math.max(f,1E-36);d=Math.log(d)/Math.log(10);0>d?(d=Math.ceil(d),d-=1):d=Math.floor(d);f*=Math.pow(10,-d);d=Math.pow(10,d);g=f*d;e&&5<=g&&5140800>=g?(e=17.5>g?5:37.5>g?15:270>g?60:1050>g?300:2250>g?900:
7200>g?3600:16200>g?10800:32400>g?21600:129600>g?43200:518400>g?86400:604800,f=Math.round(g/e)*e):f=1.75>f?d:2.25>f?2*d:3.5>f?2.5*d:7>f?5*d:10*d;0===f&&(f=1);a>=c?(e=Math.floor(0<=c?c/f+0.995:c/f-0.005),g=e*f):(e=Math.floor(0<=c?c/f+0.005:c/f-0.995),g=e*f,f*=-1);g+f===g&&(f=a-c);return{dtic:f,dtic1:g}};e.drawaxis=function(c,f,g,h,n,l){var r=e.origin(c.origin,1,c.stk[c.level]),u=0,p=0,q=0,s=0,k=0,A=0;h=h===d?30:h;n=n===d?30:n;l.exactbox?(u=Math.floor(r.x1),p=Math.floor(r.y1),q=Math.floor(r.x2),s=Math.floor(r.y2),
k=q-u,A=s-p):(u=Math.max(Math.floor(r.x1)-2,0),p=Math.max(Math.floor(r.y1)-2,0),q=Math.min(Math.floor(r.x2)+2,c.width),s=Math.min(Math.floor(r.y2)+2,c.height),k=q-u-4,A=s-p-4);var G=c.active_canvas.getContext("2d");l.fillStyle?Array.isArray(l.fillStyle)?G.fillStyle=e.linear_gradient(c,0,0,0,s-p,l.fillStyle):G.fillStyle=l.fillStyle:G.fillStyle=c.bg;G.fillRect(u,p,q-u,s-p);l.noaxisbox||(e.textline(c,u,p,q,p),e.textline(c,q,p,q,s),e.textline(c,q,s,u,s),e.textline(c,u,s,u,p));var J=!1;4===h&&(J=!0);G=
!1;4===n&&(G=!0);var K={dtic:0,dtic1:0},C={dtic:0,dtic1:0};0>f?(K.dtic1=r.xmin,K.dtic=(r.xmin-r.xmax)/f):K=e.tics(r.xmin,r.xmax,f,J);var w=1;J||(w=e.mult(r.xmin,r.xmax));0>g?(C.dtic1=r.ymin,C.dtic=(r.ymin-r.ymax)/g):C=e.tics(r.ymin,r.ymax,g,G);f=1;G||(f=e.mult(r.ymin,r.ymax));var L=!l.noxtlab;g=!l.noytlab;var S=Math.max(0,u-4*c.text_w),x=0,x=l.ontop?Math.min(c.height,Math.floor(s+1.5*c.text_h)):Math.max(c.text_h,Math.floor(p-0.5*c.text_h)),y,D;0<x&&(l.noyplab||(D=a.label(n,f)),l.noxplab||(y=a.label(h,
w)));y&&D?e.text(c,S,x,D+" vs "+y):y?e.text(c,S,x,y):D&&e.text(c,S,x,D);h=5.5*c.text_w;n=0;n=l.ontop?l.inside?p+1*c.text_h:p-0.2*c.text_h:l.inside?s-0.5*c.text_h:s+1*c.text_h+2;k=r.xmin!==r.xmax?k/(r.xmax-r.xmin):k/1;w=0!==w?1/w:1;y=Math.min(12,Math.round(k*K.dtic)/c.text_w);D=1;var B="";if(L)if(J)B=a.sec2tod(K.dtic1),D=B.length*c.text_w<(q-u)/2;else for(var z,x=K.dtic1;x<=r.xmax;x+=K.dtic){B=e.format_f(x*w,y,y/2);if(B===z){D=0;break}z=B}0===K.dtic&&(K.dtic=r.xmax-K.dtic1+1);S=0;B="";for(x=K.dtic1;x<=
r.xmax;x+=K.dtic)if(z=u+Math.round(k*(x-r.xmin))+2,!(z<u)&&(l.grid&&"y"!==l.grid?(l.gridStyle||(l.gridStyle={mode:"dashed",on:1,off:3}),e.textline(c,z,s,z,p,l.gridStyle)):(e.textline(c,z,s-2,z,s+2),e.textline(c,z,p-2,z,p+2)),L))if(D){if(B=null,J?z>S&&(B=a.sec2tod(x,!0),S=z+c.text_w*(B.length+1)):(B=e.format_f(x*w,y,y/2),B=F(B,!0)),B){var I=Math.round(B.length/2)*c.text_w;l.inside&&(z=Math.max(u+I,z),z=Math.min(q-I,z));e.text(c,z-I,n,B)}}else x===K.dtic1&&(J?(B=a.sec2tod(x,!0),l.inside&&(z=Math.floor(Math.max(u+
h,z))),e.text(c,z-h,n,B+" +\u0394 "+a.sec2tod(K.dtic))):(B=(K.dtic1*w).toString(),l.inside&&(z=Math.floor(Math.max(u+h,z))),e.text(c,z-h,n,B+" +\u0394 "+K.dtic*w)));h=l.yonright?l.inside?Math.min(q-6*c.text_w,c.width-5*c.text_w):Math.min(q+c.text_w,c.width-5*c.text_w):l.inside?Math.max(0,u+c.text_w):Math.max(0,Math.floor(u-5.5*c.text_w));n=0.4*c.text_h;k=r.ymin!==r.ymax?-A/(r.ymax-r.ymin):-A/1;w=0!==f?1/f:1;A=r.ymax>=r.ymin?function(c){return c<=r.ymax}:function(c){return c>=r.ymax};for(K=C.dtic1;A(K);K+=
C.dtic)z=s+Math.round(k*(K-r.ymin))-2,z>s||(l.grid&&"x"!==l.grid?(l.gridStyle||(l.gridStyle={mode:"dashed",on:1,off:3}),e.textline(c,u,z,q,z,l.gridStyle)):(e.textline(c,u-2,z,u+2,z),e.textline(c,q-2,z,q+2,z)),!g||l.inside&&(z<p+c.text_h||z>s-2*c.text_h)||(G?(J=a.sec2tod(K),f=z+n-c.text_h,L=J.indexOf("::"),-1!==L&&(f>p&&f<s&&e.text(c,h,f,J.substring(0,L)),L+=1),e.text(c,h,Math.min(s,z+n),J.substring(L+1,L+6)),f=z+n+c.text_h,f>p&&f<s&&"00"!==J.substring(L+7,L+9)&&(J+=".00",e.text(c,h,f,J.substring(L+
7,L+12)))):(J=e.format_f(K*w,12,6),J=F(J,l.inside),e.text(c,h,Math.min(s,z+n),J))))};e.inrect=function(c,a,d,e,f,g){return c>=d&&c<=d+f&&a>=e&&a<=e+g};var z={GBorder:3,sidelab:0,toplab:1};e.menu=function(c,a){var g=1.5*c.text_h;if(a){if(!c.widget){a.x=c.xpos;a.y=c.ypos;a.val=0;a.h=2*z.GBorder+g*a.items.length+z.toplab*(g+z.GBorder)-1;a.y=a.y-((z.toplab+Math.max(1,a.val)-0.5)*g+(1+z.toplab)*z.GBorder)+1;for(var l=a.title.length,r=0,t=0;t<a.items.length;t++){var u=a.items[t],l=Math.max(l,u.text.length);
"checkbox"===u.style&&(l+=2);"separator"===u.style&&(l+=2);u.checked&&"checkbox"!==u.style&&(r=g*t)}a.y-=r;l=(l+2)*c.text_w;a.w=2*z.GBorder+Math.abs(z.sidelab)+l-1;a.x-=a.w/2;c.menu=a;c.widget={type:"MENU",callback:function(g){var p=a;if(g===d)h(c,p);else if("mousemove"===g.type){p.drag_x!==d&&p.drag_y!==d&&2<Math.abs(c.xpos-p.drag_x)&&2<Math.abs(c.ypos-p.drag_y)&&(p.x+=c.xpos-p.drag_x,p.y+=c.ypos-p.drag_y,p.drag_x=c.xpos,p.drag_y=c.ypos);var q=p.x+z.GBorder+Math.max(0,z.sidelab),s=p.w-2*z.GBorder-
Math.abs(z.sidelab),k=1.5*c.text_h,A=p.y+z.GBorder+z.toplab*(k+z.GBorder);for(g=0;g<p.items.length;g++){var l=A+k*g,r=p.items[g];r.selected=!1;e.inrect(c.xpos,c.ypos,q,l,s,k)&&(r.selected=!0)}h(c,p)}else if("mouseup"===g.type)p.drag_x=d,p.drag_y=d;else if("mousedown"===g.type)g.preventDefault(),1===g.which?c.xpos>p.x&&c.xpos<p.x+p.w&&c.ypos>p.y&&c.ypos<p.y+1.5*c.text_h?(p.drag_x=c.xpos,p.drag_y=c.ypos):f(c,p):n(c,p);else if("keydown"===g.type&&c.menu)if(p=c.menu,g.preventDefault(),g=getKeyCode(g),
13===g)f(c,p);else if(38===g){for(g=0;g<p.items.length;g++)if(r=p.items[g],r.selected){r.selected=!1;p.items[g-1]!==d&&(p.items[g-1].selected=!0);break}else g===p.items.length-1&&(r.selected=!0);h(c,p)}else if(40===g){for(g=0;g<p.items.length;g++)if(r=p.items[g],r.selected){r.selected=!1;p.items[g+1]!==d&&(p.items[g+1].selected=!0);break}else g===p.items.length-1&&(p.items[0].selected=!0);h(c,p)}else if(48<=g&&57>=g||65<=g&&90>=g){g=String.fromCharCode(g).toUpperCase();p.keypresses=p.keypresses===
d?g:p.keypresses+g;for(g=q=0;g<p.items.length;g++)r=p.items[g],r.selected=!1,r.text&&0===r.text.toUpperCase().indexOf(p.keypresses)&&(0===q&&(r.selected=!0),q++);0===q?(p.keypresses=d,h(c,p)):1===q?f(c,p):h(c,p)}}}}h(c,a)}};e.widgetbox=function(c,a,d,f,g,h,l,n,p,q){e.shadowbox(c,a,d,f,g,1,2,"",0);q&&(g=q.length,g=Math.min(g,f/c.text_w),g=Math.max(g,1),a+=(f-g*c.text_w)/2,d+=3,e.text(c,a,d+(l-d+0.7*c.text_h)/2,q,c.xwfg));0<n&&0<p&&(d=c.active_canvas.getContext("2d"),d.fillStyle=c.bg,d.fillRect(h,l,
n,p))};e.text=function(c,a,e,f,g){var h=c.active_canvas.getContext("2d");a=Math.max(0,a);e=Math.max(0,e);if(0>a||0>e)throw"On No!";h.textBaseline="bottom";h.textAlign="left";h.fillStyle=g===d?c.fg:g;h.fillText(f,a,e)};e.getcolor=function(c,a,d){for(c=0;6>c&&0===a[c+1].pos;c++);for(;d>a[c].pos&&6>c;)c++;if(0===c||d>=a[c].pos)return x(w(a[c].red),w(a[c].green),w(a[c].blue));d=w((d-a[c-1].pos)/(a[c].pos-a[c-1].pos)*100);var e=255-d;return x(a[c].red/100*d+a[c-1].red/100*e,a[c].green/100*d+a[c-1].green/
100*e,a[c].blue/100*d+a[c-1].blue/100*e)};e.redraw_warpbox=function(a){a.warpbox&&(a._animationFrameHandle&&cancelAnimFrame(a._animationFrameHandle),a._animationFrameHandle=requestAnimFrame(function(){B(a)}))};e.format_g=function(a,d,f,g){d=Math.abs(a).toString();var h=d.indexOf(".");-1===h&&(d+=".",h=d.length);g=0;var l=d.indexOf("e");-1!==l&&(g=parseInt(d.slice(l+1,d.length),10),d=d.slice(0,l));for(var l=Math.min(f-(d.length-h)+1,f),n=0;n<l;n++)d+="0";if(0!==a)if(1>Math.abs(a))if("0."===d.slice(0,
2))for(n=2;n<d.length;n++)if("0"===d[n])g-=1;else{d="0."+d.slice(n,n+f);break}else d=d.slice(0,f+2);else h>f?(g=Math.max(0,d.length-f-2),d=d[0]+"."+d.slice(1,9)):d=d.slice(0,f+2);0===g?d+="    ":(f=e.pad(Math.abs(g).toString(),2,"0"),d=0>g?d+"E-"+f:d+"E+"+f);return 0>a?"-"+d:" "+d};e.format_f=function(a,d,f){a=a.toFixed(f).toString();return a=e.pad(a,d+f," ")};e.pad=function(a,d,e){for(;a.length<d;)a=e+a;return a};e.shadowbox=function(c,d,f,g,h,l,n,r){for(var p=r.length,q=0,s=0,q=0,s=[],k=0;11>k;k++)s[k]=
{x:0,y:0};k=!(1===n||-1===n);0!==n&&0<e.GBorder&&(q=a.trunc(Math.min(g,h)/3),q=Math.max(1,Math.min(q,e.GBorder)));if(0<q){s[0].x=s[1].x=d;s[8].x=s[9].x=d+g;s[1].y=s[8].y=f;s[0].y=s[9].y=f+h;switch(l){case e.L_ArrowLeft:s[0].y=s[1].y=f+a.trunc(h/2);d+=2;--g;break;case e.L_ArrowRight:s[8].y=s[9].y=f+a.trunc(h/2);--d;--g;break;case e.L_ArrowUp:s[1].x=s[8].x=d+a.trunc(g/2);f+=2;--h;break;case e.L_ArrowDown:s[0].x=s[9].x=d+a.trunc(g/2),--f,--h}s[2]=s[8];s[10]=s[0];d+=q;f+=q;g-=2*q;h-=2*q}s[4].x=s[5].x=
d;s[3].x=s[6].x=d+g;s[3].y=s[4].y=f;s[5].y=s[6].y=f+h;switch(l){case e.L_ArrowLeft:s[4].y=s[5].y=f+a.trunc(h/2);break;case e.L_ArrowRight:s[3].y=s[6].y=f+a.trunc(h/2);break;case e.L_ArrowUp:s[3].x=s[4].x=d+a.trunc(g/2);break;case e.L_ArrowDown:s[5].x=s[6].x=d+a.trunc(g/2)}s[7]=s[3];l=c.active_canvas.getContext("2d");0<q&&(l.fillStyle=0<n?c.xwts:c.xwbs,u(l,s.slice(0,7)),l.fillStyle=0>n?c.xwts:c.xwbs,u(l,s.slice(5,11)));k&&(l.fillStyle=c.xwbg,u(l,s.slice(3,8)));l.fillStyle=c.xwfg;l.textBaseline="alphabetic";
k&&0<p&&(p=Math.min(p,a.trunc(g/c.text_w)),p=Math.max(p,1),q=d+a.trunc((g-p*c.text_w)/2),s=f+a.trunc((h+0.7*c.text_h)/2),l.fillText(r,q,s))};e.ifevent=function(a,e){a.button_press=0;a.button_release=0;a.state_mask=0;var f=e.target.getBoundingClientRect(),g=e.offsetX===d?e.pageX-f.left-window.scrollX:e.offsetX,f=e.offsetX===d?e.pageY-f.top-window.scrollY:e.offsetY;switch(e.type){case "mousedown":a.xpos=M(g,0,a.width);a.ypos=M(f,0,a.height);switch(e.which){case 1:a.button_press=1;break;case 2:a.button_press=
2;break;case 3:a.button_press=3;break;case 4:a.button_press=4;break;case 5:a.button_press=5}break;case "mouseup":switch(a.xpos=M(g,0,a.width),a.ypos=M(f,0,a.height),e.which){case 1:a.button_release=1;break;case 2:a.button_release=2;break;case 3:a.button_release=3;break;case 4:a.button_release=4;break;case 5:a.button_release=5}}};e.scroll_real2pix=function(a){if(0===a.range)return{s1:a.a1,sw:a.a2-a.a1};var d,e;d=(a.a2-a.a1)/a.trange;e=a.a1+Math.floor(0.5+(a.smin-a.tmin)*d);d=e+Math.floor(0.5+a.srange*
d);e=e>a.a2-a.swmin?a.a2-a.swmin:Math.max(e,a.a1);d=d<a.a1+a.swmin?a.a1+a.swmin:Math.min(d,a.a2);return{s1:e,sw:Math.max(d-e,a.swmin)}};e.redrawScrollbar=function(c,d,f){var g,h,l,n,r,p,q,s,k=d.active_canvas.getContext("2d");h=e.scroll_real2pix(c);q=h.s1;s=h.sw;p=q;h=c.x;l=c.y;n=c.w;r=c.h;c.origin&1?(g=l+r/2,c.origin&2&&(p=n-p-s),f===e.XW_DRAW&&(f=c.arrow,e.shadowbox(d,h,l,f,r-1,e.L_ArrowLeft,2,"",0),e.shadowbox(d,h+n-f,l,f-1,r,e.L_ArrowRight,2,"",0)),d.legacyRender?e.draw_line(d,d.fg,h+c.a1,g,h+
c.a2,g):(k=k.createLinearGradient(h+c.a1,0,h+c.a2,0),k.addColorStop(0,d.xwbs),k.addColorStop(0.5,d.xwts),k.addColorStop(1,d.xwbs),e.draw_line(d,k,h+c.a1,g,h+c.a2,g,1)),e.shadowbox(d,h+p,l,s+1,r,1,2,"",0)):(g=h+a.trunc(n/2),2>=c.origin&&(p=r-p-s),f===e.XW_DRAW&&(f=c.arrow,e.shadowbox(d,h,l,n-1,f,e.L_ArrowUp,2,"",0),e.shadowbox(d,h,l+r-f,n-1,f,e.L_ArrowDown,2,"",0)),d.legacyRender?e.draw_line(d,d.fg,g,l+c.a1,g,l+c.a2):(k=k.createLinearGradient(0,l+c.a1,0,l+c.a2),k.addColorStop(0,d.xwbs),k.addColorStop(0.5,
d.xwts),k.addColorStop(1,d.xwbs),e.draw_line(d,k,g,l+c.a1,g,l+c.a2)),e.shadowbox(d,h,l+p,n,s+1,1,2,"",0));c.s1=q;c.sw=s};e.real_to_pixel=function(a,d,f,g){a=e.origin(a.origin,4,a.stk[a.level]);if(0===a.xscl||0===a.yscl)return{x:0,y:0};var h=a.x1,l=a.y1,n=a.xmin,r=1/a.xscl,p=a.ymin,q=1/a.yscl,s=d>a.xmax||d<a.xmin||f>a.ymin||f<a.ymax;g&&(d=Math.min(d,a.xmax),f=Math.max(d,a.xmin),f=Math.min(f,a.ymin),f=Math.max(f,a.ymax));d=Math.round((d-n)*r)+h;f=Math.round((f-p)*q)+l;return{x:d,y:f,clipped:s}};e.pixel_to_real=
function(a,d,e){d=Math.min(a.r,Math.max(a.l,d));e=Math.min(a.b,Math.max(a.t,e));var f=a.level;return{x:2!==a.origin&&3!==a.origin?a.stk[f].xmin+(d-a.stk[f].x1)*a.stk[f].xscl:a.stk[f].xmin+(a.stk[f].x2-d)*a.stk[f].xscl,y:2<a.origin?a.stk[f].ymin+(e-a.stk[f].y1)*a.stk[f].yscl:a.stk[f].ymin+(a.stk[f].y2-e)*a.stk[f].yscl}};e.colormap=function(a,d,e){a.pixel=Array(e);for(var f=Array(e),g=100/(Math.max(2,e)-1),h=0;h<e;h++)f[h]=g*h+0.5;for(g=0;6>g&&0===d[g+1].pos;g++);for(h=0;h<e;h++){a.pixel[h]=0;for(var l=
f[h];6>g&&Math.floor(l)>d[g].pos;)g++;if(0===g||l>=d[g].pos)a.pixel[h]={red:w(d[g].red),green:w(d[g].green),blue:w(d[g].blue)};else{var l=w((l-d[g-1].pos)/(d[g].pos-d[g-1].pos)*100),n=255-l;a.pixel[h]={red:d[g].red/100*l+d[g-1].red/100*n,green:d[g].green/100*l+d[g-1].green/100*n,blue:d[g].blue/100*l+d[g-1].blue/100*n}}}};e.colorbar=function(a,d,f,g,h){for(var l=1;l<h;l++)e.draw_line(a,Math.floor(a.pixel.length*(l-1)/h),d,f+h-l,d+g,f+h-l);e.draw_box(a,a.fg,d+0.5,f,g,h)};var W="undefined"===typeof Uint8ClampedArray?
N:T;e.shift_image_rows=function(a,d,e){a=new Uint32Array(d);0<e?(e*=d.width,a.set(a.subarray(0,a.length-e),e)):0>e&&(e=Math.abs(e)*d.width,a.set(a.subarray(e)));return d};e.update_image_row=function(a,d,e,f,g,h){f=new Uint32Array(d,f*d.width*4,d.width);var l=1;h!==g&&(l=a.pixel.length/Math.abs(h-g));for(h=0;h<e.length;h++){var n=Math.floor((e[h]-g)*l),n=Math.max(0,Math.min(a.pixel.length-1,n));(n=a.pixel[n])&&(f[h]=-16777216|n.blue<<16|n.green<<8|n.red)}return d};e.create_image=function(c,d,f,g,h,
l){c.active_canvas.getContext("2d");c.pixel&&0!==c.pixel.length||(a.log.warn("COLORMAP not initialized, defaulting to foreground"),e.colormap(c,a.Mc.colormap[1],16));var n=1;l!==h&&(n=c.pixel.length/Math.abs(l-h));f=Math.ceil(f);g=Math.ceil(g);l=new ArrayBuffer(f*g*4);l.width=f;l.height=g;for(var r=new Uint32Array(l),p=0;p<r.length;p++){var q=Math.floor((d[(3===c.origin||4===c.origin?Math.floor(p/f):g-Math.floor(p/f)-1)*f+(1===c.origin||4===c.origin?Math.floor(p%f):f-Math.floor(p%f)-1)]-h)*n),q=Math.max(0,
Math.min(c.pixel.length-1,q));(q=c.pixel[q])&&(r[p]=-16777216|q.blue<<16|q.green<<8|q.red)}return l};e.put_image=function(c,d,f,g,h,l,n,r,p,q,s){p=c.active_canvas.getContext("2d");c.pixel&&0!==c.pixel.length||(a.log.warn("COLORMAP not initialized, defaulting to foreground"),e.colormap(c,a.Mc.colormap[1],16));f=Math.floor(0<h?f*h:-h);g=Math.floor(g*l);l=new ArrayBuffer(f*g*4);l.width=f;l.height=g;h=new Uint32Array(l);for(var k=0;k<h.length;k++){var A=Math.max(0,d[k]),A=Math.min(c.pixel.length-1,A);
(A=c.pixel[A])&&(h[k]=-16777216|A.blue<<16|A.green<<8|A.red)}W(c,p,l,q,s,n,r,f,g);return l};e.draw_image=function(a,d,f,g,h,l,n,r){var p=Math.max(f,a.stk[a.level].xmin),q=Math.min(h,a.stk[a.level].xmax),s=Math.max(g,a.stk[a.level].ymin),k=Math.min(l,a.stk[a.level].ymax);if(!(1>=d.width||0===Math.abs(h-f)||1>=d.height||0===Math.abs(l-g))){var A=(d.width-1)/(h-f);f=Math.max(0,Math.floor((p-f)*A));h=Math.min(d.width,d.width-Math.floor((h-q)*A)-f);A=(d.height-1)/(l-g);g=Math.max(0,Math.floor((s-g)*A));
l=Math.min(d.height,d.height-Math.floor((l-k)*A)-g);var G,J;1===a.origin?(G=e.real_to_pixel(a,p,k),J=e.real_to_pixel(a,q,s)):2===a.origin?(G=e.real_to_pixel(a,q,k),J=e.real_to_pixel(a,p,s)):3===a.origin?(G=e.real_to_pixel(a,q,s),J=e.real_to_pixel(a,p,k)):4===a.origin&&(G=e.real_to_pixel(a,p,s),J=e.real_to_pixel(a,q,k));p=J.x-G.x;J=J.y-G.y;q=a.active_canvas.getContext("2d");W(a,q,d,n,r,G.x,G.y,p,J,f,g,h,l)}}})(window.mx,window.m);
(function(e,a,d,y){e.Layer1D=function(a){this.plot=a;this.ybuf=this.xbuf=y;this.xmax=this.xmin=this.imin=this.xdelta=this.xstart=this.offset=0;this.name="";this.cx=!1;this.hcb=y;this.size=0;this.display=!0;this.color=0;this.line=3;this.thick=1;this.symbol=0;this.radius=3;this.ysub=this.xsub=this.skip=0;this.modified=this.xdata=!1;this.preferred_origin=this.opacity=1;this.options={}};e.Layer1D.prototype={init:function(a,h){this.hcb=a;this.hcb.buf_type="D";this.ybufn=this.xbufn=this.size=this.offset=
0;this.hcb.pipe?this.size=h.framesize:2===a["class"]?(d.force1000(a),this.size=a.subsize):this.size=a.size;2>=a["class"]&&(this.xsub=-1,this.ysub=1,this.cx="C"===a.format[0]);this.skip=1;this.cx&&(this.skip=2);this.xstart=a.xstart;this.xdelta=a.xdelta;var f=a.xstart+a.xdelta*(this.size-1);this.xmin=Math.min(a.xstart,f);this.xmax=Math.max(a.xstart,f);this.xlab=a.xunits;this.ylab=a.yunits;if(this.hcb.pipe){this.drawmode="scrolling";this.position=0;this.tle=h.tl;this.ybufn=this.size*Math.max(this.skip*
e.PointArray.BYTES_PER_ELEMENT,e.PointArray.BYTES_PER_ELEMENT);this.ybuf=new ArrayBuffer(this.ybufn);var n=this;d.addPipeWriteListener(this.hcb,function(){n._onpipewrite()})}},_onpipewrite:function(){var a=new e.PointArray(this.ybuf),h=this.tle;if(h===y)h=Math.floor(d.pavail(this.hcb))/this.hcb.spa;else if(d.pavail(this.hcb)<h*this.hcb.spa)return;var f=h*this.hcb.spa;if("lefttoright"===this.drawmode)this.position=0,a.set(a.subarray(0,this.size-f),f);else if("righttoleft"===this.drawmode)this.position=
this.size-h,a.set(a.subarray(f),0);else if("scrolling"!==this.drawmode)throw"Invalid draw mode";h=Math.min(h,this.size-this.position);0!==d.grabx(this.hcb,a,h*this.hcb.spa,this.position*this.hcb.spa)&&(this.position=(this.position+h)%this.size,1<this.plot._Gx.autol&&this.plot.rescale())},get_data:function(a,h){var f=this.plot._Gx,n=this.hcb,l=this.skip,r;r=2===n["class"]?n.subsize:n.size;var u=0,l=0;f.index?(u=Math.floor(a),l=Math.floor(h+0.5)):0<=n.xdelta?(u=Math.floor((a-n.xstart)/n.xdelta)-1,l=
Math.floor((h-n.xstart)/n.xdelta+0.5)):(u=Math.floor((h-n.xstart)/n.xdelta)-1,l=Math.floor((a-n.xstart)/n.xdelta+0.5));u=Math.max(0,u);l=Math.min(r,l);f=Math.max(0,Math.min(l-u+1,f.bufmax));0>n.xdelta&&(u=l-f+1);if(!(u>=this.imin&&u+f<=this.imin+this.size&&this.ybuf!==y||this.modified)&&2>=n["class"]){r=this.offset+u;l=this.skip;this.ybufn=f*Math.max(l*e.PointArray.BYTES_PER_ELEMENT,e.PointArray.BYTES_PER_ELEMENT);if(this.ybuf===y||this.ybuf.byteLength<this.ybufn)this.ybuf=new ArrayBuffer(this.ybufn);
l=new e.PointArray(this.ybuf);f=d.grab(n,l,r,f);this.imin=u;this.xstart=n.xstart+u*this.xdelta;this.size=f}},change_settings:function(a){if(a.index!==y)if(a.index)this.xmin=this.xdelta=this.xstart=1,this.xmax=this.size;else{this.xstart=this.hcb.xstart+this.imin*this.xdelta;this.xdelta=this.hcb.xdelta;var d=this.hcb.xstart+this.hcb.xdelta*(this.size-1);this.xmin=Math.min(this.hcb.xstart,d);this.xmax=Math.max(this.hcb.xstart,d)}a.drawmode!==y&&(this.drawmode=a.drawmode,this.position=0,this.ybufn=this.size*
Math.max(this.skip*e.PointArray.BYTES_PER_ELEMENT,e.PointArray.BYTES_PER_ELEMENT),this.ybuf=new ArrayBuffer(this.ybufn))},reload:function(a,d){var e=this.hcb.dview.length!==a.length||d;if(d)for(var n in d)this.hcb[n]=d[n];this.hcb.setData(a);this.imin=0;this.xstart=y;this.size=0;n=this.xmin;var l=this.xmax;e&&(e=this.hcb.xstart+this.hcb.xdelta*(this.hcb.size-1),this.xmin=Math.min(this.hcb.xstart,e),this.xmax=Math.max(this.hcb.xstart,e),this.xdelta=this.hcb.xdelta,this.xstart=this.hcb.xstart,l=n=y);
return{xmin:n,xmax:l}},push:function(a,h,f){if(h){for(var n in h)this.hcb[n]=h[n],"type"===n&&(this.hcb["class"]=h[n]/1E3);h.subsize&&2===this.hcb["class"]&&(d.force1000(this.hcb),this.size=this.hcb.subsize,this.position=null,this.ybufn=this.size*Math.max(this.skip*e.PointArray.BYTES_PER_ELEMENT,e.PointArray.BYTES_PER_ELEMENT),this.ybuf=new ArrayBuffer(this.ybufn));n=this.hcb.xstart+this.hcb.xdelta*(this.hcb.size-1);this.xmin=Math.min(this.hcb.xstart,n);this.xmax=Math.max(this.hcb.xstart,n);this.xdelta=
this.hcb.xdelta;this.xstart=this.hcb.xstart}d.filad(this.hcb,a,f);return h?!0:!1},prep:function(a,h){var f=this.plot._Gx,n=this.plot._Mx,l=Math.ceil(this.size),r=this.skip;if(0!==l){l*e.PointArray.BYTES_PER_ELEMENT>f.pointbufsize&&(f.pointbufsize=l*e.PointArray.BYTES_PER_ELEMENT,f.xptr=new ArrayBuffer(f.pointbufsize),f.yptr=new ArrayBuffer(f.pointbufsize));var u=new e.PointArray(this.ybuf),y=new e.PointArray(f.xptr),w=this.xmin,x=this.xmax,F,B;if(5===f.cmode||0<this.xsub)0>=l?(w=f.panxmin,x=f.panxmax):
5!==f.cmode?y=new e.PointArray(this.xbuf):this.cx?d.vmov(u,r,y,1,l):0!==this.line?(B=d.vmxmn(u,l),y[0]=B.smax,y[1]=B.smin,l=2):y=u,0<l&&(B=d.vmxmn(y,l),x=B.smax,w=B.smin);else if(0<l){B=this.xstart;var M=this.xdelta,u=l;f.index?(F=0,l-=1):0<=M?(F=Math.max(1,Math.min(u,Math.round((a-B)/M)))-1,l=Math.max(1,Math.min(u,Math.round((h-B)/M)+2))-1):(F=Math.max(1,Math.min(u,Math.round((h-B)/M)-1))-1,l=Math.max(1,Math.min(u,Math.round((a-B)/M)+2))-1);l=l-F+1;0>l&&(d.log.debug("Nothing to plot"),l=0);u=(new e.PointArray(this.ybuf)).subarray(F*
r);B+=M*F;for(F=0;F<l;F++)y[F]=f.index?this.imin+F+1:B+F*M}f.panxmin>f.panxmax?(f.panxmin=w,f.panxmax=x):(f.panxmin=Math.min(f.panxmin,w),f.panxmax=Math.max(f.panxmax,x));if(0>=l)d.log.debug("Nothing to plot");else{w=new e.PointArray(f.yptr);if(this.cx)1===f.cmode?d.cvmag(u,w,l):2===f.cmode?25===f.plab?(d.cvpha(u,w,l),d.vsmul(w,1/(2*Math.PI),w,l)):24!==f.plab?d.cvpha(u,w,l):d.cvphad(u,w,l):3===f.cmode?d.vmov(u,r,w,1,l):6<=f.cmode?d.cvmag2(u,w,l):4<=f.cmode&&d.vmov(u.subarray(1),r,w,1,l);else if(5===
f.cmode)d.vfill(w,0,l);else if(1===f.cmode||6<=f.cmode)for(F=0;F<l;F++)w[F]=Math.abs(u[F]);else for(F=0;F<l;F++)w[F]=u[F];6<=f.cmode&&(d.vlog10(w,f.dbmin,w),r=10,7===f.cmode&&(r=20),0<f.lyr.length&&f.lyr[0].cx&&(r/=2),d.vsmul(w,r,w));B=d.vmxmn(w,l);x=B.smax;w=B.smin;r=x-w;0>r&&(x=w,w=x+r,r=-r);1E-20>=r?(w-=1,x+=1):(w-=0.02*r,x+=0.02*r);0===n.level&&(f.panymin>f.panymax?(f.panymin=w,f.panymax=x):(f.panymin=Math.min(f.panymin,w),f.panymax=Math.max(f.panymax,x)),1<f.autol&&(r=1/Math.max(f.autol,1),f.panymin=
f.panymin*r+n.stk[0].ymin*(1-r),f.panymax=f.panymax*r+n.stk[0].ymax*(1-r)));return l}}},draw:function(){var d=this.plot._Mx,h=this.plot._Gx,f=this.color,n=this.symbol,l=this.radius,r=0,u={};u.fillStyle=h.fillStyle;this.options&&(u.highlight=this.options.highlight,u.noclip=this.options.noclip);0===this.line?r=0:(r=1,0<this.thick?r=this.thick:0>this.thick&&(r=Math.abs(this.thick),u.dashed=!0),1===this.line&&(u.vertsym=!0),2===this.line&&(u.horzsym=!0));var y=h.segment&&5!==h.cmode&&0<this.xsub&&!0,
w=this.xdelta,x,F;this.xdata?(x=this.xmin,F=this.xmax):(x=Math.max(this.xmin,d.stk[d.level].xmin),F=Math.min(this.xmax,d.stk[d.level].xmax),x>=F&&(h.panxmin=Math.min(h.panxmin,this.xmin),h.panxmax=Math.max(h.panxmax,this.xmax)));if(!h.all){var B=(h.bufmax-1)*w;-0<=B?F=Math.min(F,x+B):x=Math.max(x,F+B)}if(0!==r||0!==n){for(;x<F;)this.hcb.pipe||this.get_data(x,F),B=this.prep(x,F),0<B&&!y&&a.trace(d,f,new e.PointArray(h.xptr),new e.PointArray(h.yptr),B,1,r,n,l,u),h.all?0===this.size?x=F:h.index?x+=B:
0<=w?x+=this.size*w:F+=this.size*w:x=F;this.position&&"scrolling"===this.drawmode&&(h=a.real_to_pixel(d,this.position*this.xdelta,0),h.x>d.l&&h.x<d.r&&a.draw_line(d,"white",h.x,d.t,h.x,d.b))}},add_highlight:function(a){this.options.highlight||(this.options.highlight=[]);a instanceof Array?this.options.highlight.push.apply(this.options.highlight,a):this.options.highlight.push(a);this.plot.refresh()},remove_highlight:function(a){if(this.options.highlight){for(var d=this.options.highlight.length;d--;)a!==
this.options.highlight[d]&&a!==this.options.highlight[d].id||this.options.highlight.splice(d,1);this.plot.refresh()}},get_highlights:function(){return this.options.highlight?this.options.highlight.slice(0):[]},clear_highlights:function(){this.options.highlight&&(this.options.highlight=y,this.plot.refresh())}};var r=[0,53,27,80,13,40,67,93,7,60,33,87,20,47,73,100];e.Layer1D.overlay=function(g,h,f){var n=g._Gx,l=g._Mx;2===h["class"]&&d.force1000(h);h.buf_type="D";var C=1;2===h["class"]&&(C=Math.min(h.size/
h.subsize,16-n.lyr.length));var u=f.name;delete f.name;for(var D=0;D<C;D++){var w=new e.Layer1D(g);w.init(h,f);w.color=a.getcolor(l,d.Mc.colormap[3],r[n.lyr.length%r.length]);2===h["class"]?(u!==y&&(Array.isArray(u)?w.name=u[D]:(w.name=u,w.name=w.name+"."+a.pad((D+1).toString(),3,"0"))),w.name||(w.name=h.file_name?d.trim_name(h.file_name):"layer_"+n.lyr.length,w.name=w.name+"."+a.pad((D+1).toString(),3,"0")),w.offset=D*h.subsize):(w.name=u!==y?u:h.file_name?d.trim_name(h.file_name):"layer_"+n.lyr.length,
w.offset=0);for(var x in f)w[x]!==y&&(w[x]=f[x]);g.add_layer(w)}}})(window.sigplot=window.sigplot||{},mx,m);
(function(e,a,d,y){e.Layer2D=function(a){this.plot=a;this.xmax=this.xmin=this.imin=this.ydelta=this.ystart=this.xdelta=this.xstart=this.offset=0;this.name="";this.cx=!1;this.hcb=y;this.display=!0;this.color=0;this.line=3;this.thick=1;this.symbol=0;this.radius=3;this.ysub=this.xsub=this.skip=0;this.modified=this.xdata=!1;this.preferred_origin=4;this.opacity=1;this.lpb=y;this.yc=1;this.options={}};e.Layer2D.prototype={init:function(a){var g=this.plot._Gx,h=this.plot._Mx;this.hcb=a;this.hcb.buf_type=
"D";if(this.hcb.pipe){var f=this;this.frame=this.position=0;this.lps=Math.ceil(Math.max(1,h.b-h.t));d.addPipeWriteListener(this.hcb,function(){f._onpipewrite()});this.buf=this.hcb.createArray(null,0,this.lps*this.hcb.subsize*this.hcb.spa);this.zbuf=new e.PointArray(this.lps*this.hcb.subsize)}else this.lps=Math.ceil(a.size);this.ybufn=this.xbufn=this.offset=0;this.drawmode="scrolling";2>=a["class"]&&(this.xsub=-1,this.ysub=1,this.cx="C"===a.format[0]);this.skip=1;this.cx&&(this.skip=2);g.index?(this.xmin=
this.xdelta=this.xstart=1,this.xmax=a.subsize,this.ymin=this.ydelta=this.ystart=1,this.ymax=this.size):(this.xstart=a.xstart,this.xdelta=a.xdelta,g=a.xstart+a.xdelta*(a.subsize-1),this.xmin=Math.min(a.xstart,g),this.xmax=Math.max(a.xstart,g),this.ystart=a.ystart,this.ydelta=a.ydelta,g=a.ystart+a.ydelta*(this.lps-1),this.ymin=Math.min(a.ystart,g),this.ymax=Math.max(a.ystart,g));this.xframe=this.hcb.subsize;this.yframe=this.lps*this.hcb.subsize/this.xframe;0===this.lpb&&(this.lpb=this.yframe);if(!this.lpb||
0>=this.lpb)this.lpb=16;this.lpb=Math.max(1,this.lpb/this.yc)*this.yc;this.xlab=a.xunits;this.ylab=a.yunits},_onpipewrite:function(){var r=this.plot._Gx,g=this.plot._Mx;if(!(d.pavail(this.hcb)<this.hcb.subsize*this.hcb.spa)){if("falling"===this.drawmode)this.position=0,this.buf.set(this.buf.subarray(0,(this.lps-1)*this.hcb.subsize*this.hcb.spa),this.hcb.subsize*this.hcb.spa),this.img&&a.shift_image_rows(g,this.img,1);else if("rising"===this.drawmode)this.position=this.lps-1,this.buf.set(this.buf.subarray(this.hcb.subsize*
this.hcb.spa),0),this.img&&a.shift_image_rows(g,this.img,-1);else if("scrolling"===this.drawmode)this.position>=this.lps&&(this.position=0);else throw"Invalid draw mode";if(0===d.grabx(this.hcb,this.buf,this.hcb.subsize*this.hcb.spa,this.position*this.hcb.subsize*this.hcb.spa))d.log.error("Internal error");else{var h=this.buf.subarray(this.position*this.hcb.subsize*this.hcb.spa,(this.position+1)*this.hcb.subsize*this.hcb.spa),f=new e.PointArray(this.hcb.subsize);this.cx?1===r.cmode?d.cvmag(h,f,f.length):
2===r.cmode?25===r.plab?(d.cvpha(h,f,f.length),d.vsmul(f,1/(2*Math.PI),f,f.length)):24!==r.plab?d.cvpha(h,f,f.length):d.cvphad(h,f,f.length):3===r.cmode?d.vmov(h,this.skip,f,1,f.length):4===r.cmode?d.vmov(h.subarray(1),this.skip,f,1,f.length):5===r.cmode?d.vfill(f,0,f.length):6===r.cmode?d.cvmag2logscale(h,r.dbmin,10,f):7===r.cmode&&d.cvmag2logscale(h,r.dbmin,20,f):1===r.cmode?d.vabs(h,f):2===r.cmode?d.vfill(f,0,f.length):3===r.cmode?d.vmov(h,this.skip,f,1,f.length):4===r.cmode?d.vfill(f,0,f.length):
5===r.cmode?d.vfill(f,0,f.length):6===r.cmode?d.vlogscale(h,r.dbmin,10,f):7===r.cmode&&d.vlogscale(h,r.dbmin,20,f);for(var h=f[0],n=f[0],l=0;l<f.length;l++)f[l]<h&&(h=f[l]),f[l]>n&&(n=f[l]);1===r.autol?(r.zmin=h,r.zmax=n):1<r.autol&&(l=1/Math.max(r.autol,1),r.zmin=r.zmin*l+h*(1-l),r.zmax=r.zmax*l+n*(1-l));this.img&&a.update_image_row(g,this.img,f,this.position,r.zmin,r.zmax);this.frame+=1;"scrolling"===this.drawmode&&(this.position=(this.position+1)%this.lps)}}},get_data:function(){var a=this.hcb;
this.buf||(this.buf=this.hcb.createArray(null,0,this.lps*this.hcb.subsize*this.hcb.spa),this.zbuf=new e.PointArray(this.lps*this.hcb.subsize));this.hcb.pipe||d.grab(a,this.buf,0,a.subsize)},get_z:function(a,d){return this.zbuf[Math.floor(d/this.hcb.ydelta)*this.hcb.subsize+Math.floor(a/this.hcb.xdelta)]},change_settings:function(a){var d=this.plot._Gx;a.cmode!==y&&(this.img=y,d.zmin=y,d.zmax=y);a.cmap!==y&&(this.img=y);a.drawmode!==y&&(this.drawmode=a.drawmode,this.frame=this.position=0,this.buf=
this.hcb.createArray(null,0,this.lps*this.hcb.subsize*this.hcb.spa),this.zbuf=new e.PointArray(this.lps*this.hcb.subsize),this.img=y)},push:function(a,g,h){if(g){for(var f in g)this.hcb[f]=g[f],"type"===f&&(this.hcb["class"]=g[f]/1E3);g.subsize&&(this.buf=this.hcb.createArray(null,0,this.lps*this.hcb.subsize*this.hcb.spa),this.zbuf=new e.PointArray(this.lps*this.hcb.subsize));f=this.hcb.xstart+this.hcb.xdelta*(this.hcb.subsize-1);this.xmin=Math.min(this.hcb.xstart,f);this.xmax=Math.max(this.hcb.xstart,
f);this.xdelta=this.hcb.xdelta;this.xstart=this.hcb.xstart;this.ystart=this.hcb.ystart;this.ydelta=this.hcb.ydelta;f=this.hcb.ystart+this.hcb.ydelta*(this.lps-1);this.ymin=Math.min(this.hcb.ystart,f);this.ymax=Math.max(this.hcb.ystart,f)}d.filad(this.hcb,a,h);return g?!0:!1},prep:function(e,g){var h=this.plot._Gx,f=this.plot._Mx,n=this.lps,l=this.xmin,C=this.xmax,u;this.get_data(e,g);if(!(5===h.cmode||0<this.xsub)&&0<n){var D=this.xstart,w=this.xdelta,x=n;h.index?(u=0,n-=1):0<=w?(u=Math.max(1,Math.min(x,
Math.round((e-D)/w)))-1,n=Math.max(1,Math.min(x,Math.round((g-D)/w)+2))-1):(u=Math.max(1,Math.min(x,Math.round((g-D)/w)-1))-1,n=Math.max(1,Math.min(x,Math.round((e-D)/w)+2))-1);n=n-u+1;0>n&&(d.log.debug("Nothing to plot"),n=0)}h.panxmin>h.panxmax?(h.panxmin=l,h.panxmax=C):(h.panxmin=Math.min(h.panxmin,l),h.panxmax=Math.max(h.panxmax,C));if(0>=n)d.log.debug("Nothing to plot");else{!(5===h.cmode||0<this.ysub)&&0<n&&(l=this.ystart,C=this.ydelta,x=n,h.index?(u=0,n-=1):0<=C?(u=Math.max(1,Math.min(x,Math.round((e-
l)/C)))-1,n=Math.max(1,Math.min(x,Math.round((g-l)/C)+2))-1):(u=Math.max(1,Math.min(x,Math.round((g-l)/C)-1))-1,n=Math.max(1,Math.min(x,Math.round((e-l)/C)+2))-1),n=n-u+1,0>n&&(d.log.debug("Nothing to plot"),n=0));h.panymin>h.panxmax?(h.panymin=this.ymin,h.panymax=this.ymax):(h.panymin=Math.min(h.panymin,this.ymin),h.panymax=Math.max(h.panymax,this.ymax));this.cx?1===h.cmode?d.cvmag(this.buf,this.zbuf,this.zbuf.length):2===h.cmode?25===h.plab?(d.cvpha(this.buf,this.zbuf,this.zbuf.length),d.vsmul(this.zbuf,
1/(2*Math.PI),this.zbuf,this.zbuf.length)):24!==h.plab?d.cvpha(this.buf,this.zbuf,this.zbuf.length):d.cvphad(this.buf,this.zbuf,this.zbuf.length):3===h.cmode?d.vmov(this.buf,this.skip,this.zbuf,1,this.zbuf.length):4===h.cmode?d.vmov(this.buf.subarray(1),this.skip,this.zbuf,1,this.zbuf.length):5===h.cmode?d.vfill(this.zbuf,0,this.zbuf.length):6===h.cmode?d.cvmag2logscale(this.buf,h.dbmin,10,this.zbuf):7===h.cmode&&d.cvmag2logscale(this.buf,h.dbmin,20,this.zbuf):1===h.cmode?d.vabs(this.buf,this.zbuf):
2===h.cmode?d.vfill(this.zbuf,0,this.zbuf.length):3===h.cmode?d.vmov(this.buf,this.skip,this.zbuf,1,this.zbuf.length):4===h.cmode?d.vfill(this.zbuf,0,this.zbuf.length):5===h.cmode?d.vfill(this.zbuf,0,this.zbuf.length):6===h.cmode?d.vlogscale(this.buf,h.dbmin,10,this.zbuf):7===h.cmode&&d.vlogscale(this.buf,h.dbmin,20,this.zbuf);x=this.zbuf;this.hcb.pipe&&this.frame<this.lps&&(x="rising"===this.drawmode?this.zbuf.subarray(this.zbuf.length-this.frame*this.hcb.subsize):this.zbuf.subarray(0,this.frame*
this.hcb.subsize));C=l=0;if(0<x.length)for(l=x[0],C=x[0],u=0;u<x.length&&!(u/this.xframe>=this.lpb);u++)x[u]<l&&(l=x[u]),x[u]>C&&(C=x[u]);h.zmin=h.zmin!==y?Math.min(h.zmin,l):l;h.zmax=h.zmax!==y?Math.min(h.zmax,C):C;this.img=a.create_image(f,this.zbuf,this.hcb.subsize,this.lps,h.zmin,h.zmax);this.img.cmode=h.cmode;this.img.cmap=h.cmap;this.img.origin=f.origin;if(this.hcb.pipe&&this.frame<this.lps)if(h=new Uint32Array(this.img),"rising"===this.drawmode)for(u=0;u<h.length-this.frame*this.hcb.subsize;u++)h[u]=
0;else for(u=this.frame*this.hcb.subsize;u<h.length;u++)h[u]=0;return n}},draw:function(){var d=this.plot._Mx,g=this.plot._Gx,h=this.hcb;if(this.hcb.pipe){var f=Math.ceil(Math.max(1,d.b-d.t));if(f!==this.lps&&this.buf){var n=this.hcb.createArray(null,0,f*this.hcb.subsize*this.hcb.spa),l=new e.PointArray(f*this.hcb.subsize);n.set(this.buf.subarray(0,n.length));l.set(this.zbuf.subarray(0,l.length));this.buf=n;this.zbuf=l;this.lps=f;this.position>=this.lps&&(this.position=0);f=h.ystart+h.ydelta*(this.lps-
1);this.ymin=Math.min(h.ystart,f);this.ymax=Math.max(h.ystart,f);this.plot.rescale()}}f=Math.max(this.xmin,d.stk[d.level].xmin);n=Math.min(this.xmax,d.stk[d.level].xmax);if(f>=n)g.panxmin=Math.min(g.panxmin,this.xmin),g.panxmax=Math.max(g.panxmax,this.xmax);else{var y=Math.max(this.ymin,d.stk[d.level].ymin),u=Math.min(this.ymax,d.stk[d.level].ymax),l=Math.abs(n-f)+1,D=Math.abs(u-y)+1,l=Math.floor(l/h.xdelta),D=Math.floor(D/h.ydelta),l=Math.min(l,h.subsize),D=Math.min(D,h.size),h=a.real_to_pixel(d,
f,y),u=a.real_to_pixel(d,n,u),D=(u.y-h.y)/D;g.xe=Math.max(1,Math.round((u.x-h.x)/l));g.ye=Math.max(1,Math.round(D));this.img?g.cmode===this.img.cmode&&g.cmap===this.img.cmap&&d.origin===this.img.origin||this.prep(f,n):this.prep(f,n);this.img&&a.draw_image(d,this.img,this.xmin,this.ymin,this.xmax,this.ymax,this.opacity,g.rasterSmoothing);this.position&&(g=a.real_to_pixel(d,0,this.position*this.ydelta),g.y>d.t&&g.y<d.b&&a.draw_line(d,"white",d.l,g.y,d.r,g.y))}}};e.Layer2D.overlay=function(a,g,h){var f=
a._Gx;g.buf_type="D";var n=new e.Layer2D(a);n.init(g);n.name=g.file_name?d.trim_name(g.file_name):"layer_"+f.lyr.length;for(var l in h)n[l]!==y&&(n[l]=h[l]);a.add_layer(n)}})(window.sigplot=window.sigplot||{},mx,m);window.sigplot=window.sigplot||{};
(function(e,a,d){function y(){this.yptr=this.xptr=void 0;this.ymax=this.ymin=this.xmax=this.xmin=this.panymax=this.panymin=this.panxmax=this.panxmin=this.xdelta=this.xstart=this.arety=this.aretx=this.ymrk=this.xmrk=this.rety=this.retx=0;this.zmax=this.zmin=void 0;this.pmt=this.pyscl=this.pxscl=this.dbmin=0;this.format=this.note="";this.modsource=this.modlayer=this.pthk=this.pyl=this.py2=this.py1=this.px2=this.px1=this.pb=this.pt=this.pr=this.pl=0;this.modified=!1;this.ydiv=this.xdiv=this.modmode=
0;this.cross=this.expand=this.all=!1;this.grid=!0;this.gridBackground=void 0;this.index=!1;this.legend=this.specs=this.pan=!0;this.xdata=!1;this.show_readout=this.show_y_axis=this.show_x_axis=!0;this.autohide_panbars=this.autohide_readout=this.hide_note=!1;this.panning=void 0;this.panmode=0;this.hold=!1;this.isec=this.nsec=this.iysec=this.sections=0;this.ylab=this.xlab=void 0;this.default_rubberbox_action="zoom";this.default_rubberbox_mode="box";this.wheelscroll_mode_natural=!0;this.scroll_time_interval=
10;this.stillPanning=this.repeatPanning=void 0;this.autol=-1;this.wheelZoom=this.rasterSmoothing=this.lineSmoothing=!1;this.wheelZoomPercent=0.2;this.inContinuousZoom=!1;this.lyr=[];this.HCB=[];this.plugins=[];this.plotData=document.createElement("canvas");this.plotData.valid=!1}function r(d,c){var e=d._Mx;a.removeEventListener(e,"mousedown",d.onmousedown,!1);a.menu(e,{title:"SCROLLBAR",refresh:function(){d.refresh()},finalize:function(){a.addEventListener(e,"mousedown",d.onmousedown,!1);d.refresh()},
items:[{text:"Expand Range",handler:function(){E(d,a.SB_EXPAND,c)}},{text:"Shrink Range",handler:function(){E(d,a.SB_SHRINK,c)}},{text:"Expand Full",handler:function(){E(d,a.SB_FULL,c)}}]})}function g(c){var e=c._Gx,f=c._Mx;a.removeEventListener(f,"mousedown",c.onmousedown,!1);var k={text:"Cntrls...",menu:{title:"CONTROLS OPTIONS",items:[{text:"Continuous (Disabled)",checked:-2===e.cntrls,handler:function(){c.change_settings({xcnt:-2})}},{text:"LM Click (Disabled)",checked:-1===e.cntrls,handler:function(){c.change_settings({xcnt:-1})}},
{text:"Off",checked:0===e.cntrls,handler:function(){c.change_settings({xcnt:0})}},{text:"LM Click",checked:1===e.cntrls,handler:function(){c.change_settings({xcnt:1})}},{text:"Continuous",checked:2===e.cntrls,handler:function(){c.change_settings({xcnt:2})}}]}},g={text:"CX Mode...",menu:{title:"COMPLEX MODE",items:[{text:"Magnitude",checked:1===e.cmode,handler:function(){c.change_settings({cmode:1})}},{text:"Phase",checked:2===e.cmode,handler:function(){c.change_settings({cmode:2})}},{text:"Real",
checked:3===e.cmode,handler:function(){c.change_settings({cmode:3})}},{text:"Imaginary",checked:4===e.cmode,handler:function(){c.change_settings({cmode:4})}},{text:"IR: Imag/Real",checked:5===e.cmode,handler:function(){c.change_settings({cmode:5})}},{text:"10*Log10",checked:6===e.cmode,handler:function(){c.change_settings({cmode:6})}},{text:"20*Log10",checked:7===e.cmode,handler:function(){c.change_settings({cmode:7})}}]}},h={text:"Scaling...",menu:{title:"SCALING",items:[{text:"Y Axis",style:"separator"},
{text:"Parameters...",checked:0===e.autoy,handler:function(){e.autoy=0;N(c,"Y Axis Min:",a.floatValidator,function(a){parseFloat(a)!==f.stk[f.level].ymin?(""===a&&(a=0),H(c,parseFloat(a),f.stk[f.level].ymax,"Y")):c.refresh()},f.stk[f.level].ymin,void 0,void 0,function(){N(c,"Y Axis Max:",a.floatValidator,function(a){parseFloat(a)!==f.stk[f.level].ymax?(""===a&&(a=0),H(c,f.stk[f.level].ymin,parseFloat(a),"Y")):c.refresh()},f.stk[f.level].ymax,void 0,void 0,void 0)})}},{text:"Min Auto",checked:1===
e.autoy,handler:function(){e.autoy=1}},{text:"Max Auto",checked:2===e.autoy,handler:function(){e.autoy=2}},{text:"Full Auto",checked:3===e.autoy,handler:function(){e.autoy=3}},{text:"X Axis",style:"separator"},{text:"Parameters...",checked:0===e.autox,handler:function(){e.autox=0;N(c,"X Axis Min:",a.floatValidator,function(a){parseFloat(a)!==f.stk[f.level].xmin?(""===a&&(a=0),H(c,parseFloat(a),f.stk[f.level].xmax,"X")):c.refresh()},f.stk[f.level].xmin,void 0,void 0,function(){N(c,"X Axis Max:",a.floatValidator,
function(a){parseFloat(a)!==f.stk[f.level].xmax?(""===a&&(a=0),H(c,f.stk[f.level].xmin,parseFloat(a),"X")):c.refresh()},f.stk[f.level].xmax,void 0,void 0,void 0)})}},{text:"Min Auto",checked:1===e.autox,handler:function(){e.autox=1}},{text:"Max Auto",checked:2===e.autox,handler:function(){e.autox=2}},{text:"Full Auto",checked:3===e.autox,handler:function(){e.autox=3}}]}},l={text:"Settings...",menu:{title:"SETTINGS",items:[{text:"ALL Mode",checked:e.all,style:"checkbox",handler:function(){c.change_settings({all:!e.all})}},
{text:"Controls...",menu:{title:"CONTROLS OPTIONS",items:[{text:"Continuous (Disabled)",checked:-2===e.cntrls,handler:function(){c.change_settings({xcnt:-2})}},{text:"LM Click (Disabled)",checked:-1===e.cntrls,handler:function(){c.change_settings({xcnt:-1})}},{text:"Off",checked:0===e.cntrls,handler:function(){c.change_settings({xcnt:0})}},{text:"LM Click",checked:1===e.cntrls,handler:function(){c.change_settings({xcnt:1})}},{text:"Continuous",checked:2===e.cntrls,handler:function(){c.change_settings({xcnt:2})}}]}},
{text:"Mouse...",menu:{title:"MOUSE OPTIONS",items:[{text:"LM Drag (Zoom)",checked:"zoom"===e.default_rubberbox_action,handler:function(){e.default_rubberbox_action="zoom"}},{text:"LM Drag (Select)",checked:"select"===e.default_rubberbox_action,handler:function(){e.default_rubberbox_action="select"}},{text:"LM Drag (Disabled)",checked:void 0===e.default_rubberbox_action,handler:function(){e.default_rubberbox_action=void 0}},{text:"Mode...",menu:{title:"MOUSE Mode",items:[{text:"Box",checked:"box"===
e.default_rubberbox_mode,handler:function(){e.default_rubberbox_mode="box"}},{text:"Horizontal",checked:"horizontal"===e.default_rubberbox_mode,handler:function(){e.default_rubberbox_mode="horizontal"}},{text:"Vertical",checked:"vertical"===e.default_rubberbox_mode,handler:function(){e.default_rubberbox_mode="vertical"}}]}},{text:"CROSShairs...",menu:{title:"Crosshairs Mode",items:[{text:"Off",checked:!e.cross,handler:function(){e.cross=!1}},{text:"On",checked:!0===e.cross,handler:function(){e.cross=
!0}},{text:"Horizontal",checked:"horizontal"===e.cross,handler:function(){e.cross="horizontal"}},{text:"Vertical",checked:"vertical"===e.cross,handler:function(){e.cross="vertical"}}]}},{text:"Mousewheel Natural Mode",checked:e.wheelscroll_mode_natural,style:"checkbox",handler:function(){c.change_settings({wheelscroll_mode_natural:!e.wheelscroll_mode_natural})}}]}},{text:"CROSShairs",checked:e.cross,style:"checkbox",handler:function(){c.change_settings({cross:!e.cross})}},{text:"GRID",checked:e.grid,
style:"checkbox",handler:function(){c.change_settings({grid:!e.grid})}},{text:"INDEX Mode",checked:e.index,style:"checkbox",handler:function(){c.change_settings({index:!e.index})}},{text:"LEGEND",checked:e.legend,style:"checkbox",handler:function(){c.change_settings({legend:!e.legend})}},{text:"PAN Scrollbars",checked:e.pan,style:"checkbox",handler:function(){c.change_settings({pan:!e.pan})}},{text:"PHase UNITS...",menu:{title:"PHASE UNITS",items:[{text:"Radians",checked:23===e.plab,handler:function(){c.change_settings({phunits:"R"})}},
{text:"Degrees",checked:24===e.plab,handler:function(){c.change_settings({phunits:"D"})}},{text:"Cycles",checked:25===e.plab,handler:function(){c.change_settings({phunits:"C"})}}]}},{text:"SPECS",checked:e.specs,style:"checkbox",handler:function(){c.change_settings({specs:!e.specs})}},{text:"XDIVisions...",handler:function(){N(c,"X Divisions:",function(c){var e=a.intValidator(c),p=d.trunc(f.width/2);return e.valid&&c>p?{valid:!1,reason:"Exceeds maximum number of divisions ("+p+")."}:e},function(a){parseFloat(a)!==
e.xdiv&&(""===a&&(a=1),e.xdiv=parseFloat(a));c.refresh()},e.xdiv,void 0,void 0,void 0)}},{text:"XLABel...",handler:function(){N(c,"X Units:",function(c){console.log("The value is "+c);return a.intValidator(c)},function(a){parseFloat(a)!==e.xlab&&(0>a&&(a=0),e.xlab=parseFloat(a));c.refresh()},e.xlab,void 0,void 0,void 0)}},{text:"YDIVisions...",handler:function(){N(c,"Y Divisions:",function(c){var e=a.intValidator(c),p=d.trunc(f.height/2);return e.valid&&c>p?{valid:!1,reason:"Exceeds maximum number of divisions ("+
p+")."}:e},function(a){parseFloat(a)!==e.ydiv&&(""===a&&(a=1),e.ydiv=parseFloat(a));c.refresh()},e.ydiv,void 0,void 0,void 0)}},{text:"YINVersion",checked:4===f.origin,style:"checkbox",handler:function(){c.change_settings({yinv:4!==f.origin})}},{text:"YLABel...",handler:function(){N(c,"Y Units:",function(c){return a.intValidator(c)},function(a){parseFloat(a)!==e.ylab&&(0>a&&(a=0),e.ylab=parseFloat(a));c.refresh()},e.ylab,void 0,void 0,void 0)}},{text:"X-axis",checked:e.show_x_axis,style:"checkbox",
handler:function(){c.change_settings({show_x_axis:!e.show_x_axis})}},{text:"Y-axis",checked:e.show_y_axis,style:"checkbox",handler:function(){c.change_settings({show_y_axis:!e.show_y_axis})}},{text:"Readout",checked:e.show_readout,style:"checkbox",handler:function(){c.change_settings({show_readout:!e.show_readout})}},{text:"Invert Colors",checked:f.xi,style:"checkbox",handler:function(){a.invertbgfg(f)}}]}},n={text:"Colormap...",menu:{title:"COLORMAP",items:[{text:"Greyscale",checked:0===e.cmap,handler:function(){c.change_settings({cmap:0})}},
{text:"Ramp Colormap",checked:1===e.cmap,handler:function(){c.change_settings({cmap:1})}},{text:"Color Wheel",checked:2===e.cmap,handler:function(){c.change_settings({cmap:2})}},{text:"Spectrum",checked:3===e.cmap,handler:function(){c.change_settings({cmap:3})}},{text:"Sunset",checked:4===e.cmap,handler:function(){c.change_settings({cmap:4})}}]}},r=function(d){return{title:"TRACE OPTIONS",items:[{text:"Dashed...",handler:function(){var k=1;if(void 0!==d)k=Math.abs(c._Gx.lyr[d].thick);else{if(0===
e.lyr.length)return;for(var k=Math.abs(c._Gx.lyr[0].thick),f=0;f<e.lyr.length;f++)if(k!==Math.abs(c._Gx.lyr[f].thick)){k=1;break}}N(c,"Line thickness:",a.intValidator,function(a){if(void 0!==d)c._Gx.lyr[d].line=3,c._Gx.lyr[d].thick=-1*a,c._Gx.lyr[d].symbol=0;else for(var d=0;d<e.lyr.length;d++)c._Gx.lyr[d].line=3,c._Gx.lyr[d].thick=-1*a,c._Gx.lyr[d].symbol=0},k)}},{text:"Dots...",handler:function(){var k=3;if(void 0!==d)k=Math.abs(c._Gx.lyr[d].radius);else{if(0===e.lyr.length)return;for(var f=0;f<
e.lyr.length;f++)if(k!==Math.abs(c._Gx.lyr[f].radius)){k=3;break}}N(c,"Radius/Shape:",a.intValidator,function(a){var k;0>a?(k=3,a=Math.abs(a)):0<a?k=2:(k=1,a=0);if(void 0!==d)c._Gx.lyr[d].line=0,c._Gx.lyr[d].radius=a,c._Gx.lyr[d].symbol=k;else for(var f=0;f<e.lyr.length;f++)c._Gx.lyr[f].line=0,c._Gx.lyr[f].radius=a,c._Gx.lyr[f].symbol=k},k)}},{text:"Solid...",handler:function(){var k=1;if(void 0!==d)k=Math.abs(c._Gx.lyr[d].thick);else{if(0===e.lyr.length)return;for(var k=Math.abs(c._Gx.lyr[0].thick),
f=0;f<e.lyr.length;f++)if(k!==Math.abs(c._Gx.lyr[f].thick)){k=1;break}}N(c,"Line thickness:",a.intValidator,function(a){if(void 0!==d)c._Gx.lyr[d].line=3,c._Gx.lyr[d].thick=a,c._Gx.lyr[d].symbol=0;else for(var k=0;k<e.lyr.length;k++)c._Gx.lyr[k].line=3,c._Gx.lyr[k].thick=a,c._Gx.lyr[k].symbol=0},k)}},{text:"Toggle",style:void 0!==d?"checkbox":void 0,checked:void 0!==d?c._Gx.lyr[d].display:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].display=!c._Gx.lyr[d].display;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].display=
!c._Gx.lyr[a].display}},{text:"Symbols...",menu:{title:"SYMBOLS",items:[{text:"Retain Current"},{text:"None",checked:void 0!==d?0===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].radius=0,c._Gx.lyr[d].symbol=0;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=0,c._Gx.lyr[a].symbol=0}},{text:"Pixels",checked:void 0!==d?1===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].radius=1,c._Gx.lyr[d].symbol=1;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=
1,c._Gx.lyr[a].symbol=1}},{text:"Circles",checked:void 0!==d?2===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].radius=4,c._Gx.lyr[d].symbol=2;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=4,c._Gx.lyr[a].symbol=2}},{text:"Squares",checked:void 0!==d?3===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].radius=4,c._Gx.lyr[d].symbol=3;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=4,c._Gx.lyr[a].symbol=3}},{text:"Plusses",checked:void 0!==
d?4===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].radius=4,c._Gx.lyr[d].symbol=4;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=4,c._Gx.lyr[a].symbol=4}},{text:"X's",checked:void 0!==d?5===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].radius=4,c._Gx.lyr[d].symbol=5;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=4,c._Gx.lyr[a].symbol=5}},{text:"Triangles",checked:void 0!==d?6===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==
d)c._Gx.lyr[d].radius=6,c._Gx.lyr[d].symbol=6;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=6,c._Gx.lyr[a].symbol=6}},{text:"Downward Triangles",checked:void 0!==d?7===c._Gx.lyr[d].symbol:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].radius=6,c._Gx.lyr[d].symbol=7;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].radius=6,c._Gx.lyr[a].symbol=7}}]}},{text:"Line Type...",menu:{title:"LINE TYPE",items:[{text:"Retain Current"},{text:"None",checked:void 0!==d?0===c._Gx.lyr[d].line:void 0,
handler:function(){if(void 0!==d)c._Gx.lyr[d].line=0;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].line=0}},{text:"Verticals",checked:void 0!==d?1===c._Gx.lyr[d].line:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].line=1;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].line=1}},{text:"Horizontals",checked:void 0!==d?2===c._Gx.lyr[d].line:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].line=2;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].line=2}},{text:"Connecting",checked:void 0!==
d?3===c._Gx.lyr[d].line:void 0,handler:function(){if(void 0!==d)c._Gx.lyr[d].line=3;else for(var a=0;a<e.lyr.length;a++)c._Gx.lyr[a].line=3}}]}},{text:"Thickness...",handler:function(){var k=1;void 0!==d&&(k=c._Gx.lyr[d].thick);N(c,"Thickness",a.intValidator,function(a){""===a&&(a=1);a=Math.max(0,a);if(void 0!==d)c._Gx.lyr[d].thick=a;else for(var k=0;k<e.lyr.length;k++)c._Gx.lyr[k].thick=a},k,void 0,void 0,void 0)}},{text:"Opacity...",handler:function(){var k=1;void 0!==d&&(k=c._Gx.lyr[d].opacity);
N(c,"Opacity:",a.floatValidator,function(a){""===a&&(a=1);a=Math.max(0,a);a=Math.min(1,a);if(void 0!==d)c._Gx.lyr[d].opacity=a;else for(var k=0;k<e.lyr.length;k++)c._Gx.lyr[k].opacity=a},k,void 0,void 0,void 0)}}]}},t={text:"Plugins...",menu:{title:"PLUGINS",items:function(){for(var a=[],c=0;c<e.plugins.length;c++){var d=e.plugins[c];d.impl.menu&&("function"===typeof d.impl.menu?a.push(d.impl.menu()):a.push(d.impl.menu))}return a}()}};a.menu(f,{title:"SIG-PLOT",finalize:function(){f.prompt||a.addEventListener(f,
"mousedown",c.onmousedown,!1);c.refresh()},items:[{text:"Refresh"},k,g,h,{text:"View...",menu:{title:"VIEW",items:[{text:"Reset",handler:function(){c.unzoom()}},{text:"Y Axis",style:"separator"},{text:"Expand Range",handler:function(){E(c,a.SB_EXPAND,"YPAN")}},{text:"Shrink Range",handler:function(){E(c,a.SB_SHRINK,"YPAN")}},{text:"Expand Full",handler:function(){E(c,a.SB_FULL,"YPAN")}},{text:"X Axis",style:"separator"},{text:"Expand Range",handler:function(){E(c,a.SB_EXPAND,"XPAN")}},{text:"Shrink Range",
handler:function(){E(c,a.SB_SHRINK,"XPAN")}},{text:"Expand Full",handler:function(){E(c,a.SB_FULL,"XPAN")}}]}},{text:"Grid",handler:function(){c.change_settings({grid:!e.grid})}},l,n,{text:"Traces...",menu:function(){var a=c._Gx,d={title:"TRACE",items:[]};d.items.push({text:"All",menu:r()});for(var e=0;e<a.lyr.length;e++)d.items.push({text:a.lyr[e].name,menu:r(e)});return d}},{text:"Files...",menu:{title:"FILES OPTIONS",items:[{text:"Deoverlay File...",menu:function(){var a=c._Gx,d={title:"DEOVERLAY",
items:[]};d.items.push({text:"Deoverlay All",handler:function(){c.deoverlay()}});for(var e=0;e<a.lyr.length;e++){var k=function(a){return function(){c.deoverlay(a)}}(e);d.items.push({text:a.lyr[e].name,handler:k})}return d}}]}},t,{text:"Keypress Info",handler:function(){a.message(f,P)}},{text:"Exit",handler:function(){var c=document.createEvent("Event");c.initEvent("sigplotexit",!0,!0);a.dispatchEvent(f,c)}}]})}function h(c){return function(e,f,k,g,h,l){var n,r=c._Gx,t=c._Mx,u=Math.min(f,g);n=Math.min(k,
h);var v=Math.abs(g-f),w=Math.abs(h-k);void 0===l||"zoom"===l?1===e.which&&(2>v&&2>w?(u=!1,n=c._Mx,v=n.xpos,w=n.ypos,f=n.text_h,k=n.text_w,g=" ",v<n.l-k&&w<=n.b&&w>=n.t?(g="YCENTER",u=!0):w>n.b+d.trunc(0.5*k)&&w<=n.b+d.trunc(d.trunc(3*f)/2)&&v>=n.l&&v<=n.r&&(g="XCENTER",u=!0),n=g,u?" "!==n&&B(c,n,0,e):1===r.cntrls&&(f=document.createEvent("Event"),f.initEvent("mtag",!0,!0),f.x=r.xmrk,f.y=r.ymrk,f.w=void 0,f.h=void 0,f.shift=e.shiftKey,a.dispatchEvent(t,f))):(c.pixel_zoom(f,k,g,h),c.refresh())):"select"===
l&&(f=document.createEvent("Event"),f.initEvent("mtag",!0,!0),r=z(c,u,n),u=z(c,u+v,n+w),f.x=r.x,f.y=r.y,f.w=Math.abs(u.x-r.x),f.h=Math.abs(u.y-r.y),f.shift=e.shiftKey,a.dispatchEvent(t,f))}}function f(c,e){var f=c._Mx,k=c._Gx;k.xmin=void 0===e.xmin?0:e.xmin;k.xmax=void 0===e.xmax?0:e.xmax;var g=void 0!==e.xmin,h=void 0!==e.xmax,l=void 0===e.cmode?"":e.cmode.toUpperCase();k.ylab=e.ylab;k.ymin=void 0===e.ymin?0:e.ymin;k.ymax=void 0===e.ymax?0:e.ymax;var r=void 0!==e.ymin,t=void 0!==e.ymax;void 0!==
e.colors&&a.setbgfg(f,e.colors.bg,e.colors.fg,f.xi);void 0!==e.xi&&a.invertbgfg(f);k.forcelab=void 0===e.forcelab?!0:e.forcelab;k.all=void 0===e.all?!1:e.all;k.expand=void 0===e.expand?!1:e.expand;k.xlab=e.xlab;k.segment=void 0===e.segment?!1:e.segment;k.plab=24;var u=void 0===e.phunits?"D":e.phunits;"R"===u[0]?k.plab=23:"C"===u[0]&&(k.plab=25);k.xdiv=void 0===e.xdiv?5:e.xdiv;k.ydiv=void 0===e.ydiv?5:e.ydiv;f.origin=1;e.yinv&&(f.origin=4);k.pmt=void 0===e.pmt?1:e.pmt;k.bufmax=void 0===e.bufmax?32768:
e.bufmax;k.sections=void 0===e.nsec?0:e.nsec;k.anno_type=void 0===e.anno_type?0:e.anno_type;k.xfmt=void 0===e.xfmt?"":e.xfmt;k.yfmt=void 0===e.yfmt?"":e.yfmt;k.index=void 0===e.index?!1:e.index;if(u=k.index||"IN"===l.slice(0,2))g&&1===k.xmin&&(g=!1),h&&1===k.xmin&&(h=!1);k.yptr=void 0;k.xptr=void 0;k.pointbufsize=0;k.xdata=!1;k.note="";k.hold=0;d.vstype("D");e.inputs||n(c,!1);var v=l.slice(0,2);if("IN"===v||"AB"===v||"__"===v)v=l.slice(2,4);k.cmode=0<k.lyr.length&&k.lyr[0].cx?1:3;"MA"===v&&(k.cmode=
1);"PH"===v&&(k.cmode=2);"RE"===v&&(k.cmode=3);"IM"===v&&(k.cmode=4);if("LO"===v||"D1"===v)k.cmode=6;if("L2"===v||"D2"===v)k.cmode=7;if("RI"===v||"IR"===v)k.index?alert("Imag/Real mode not permitted in INDEX mode"):k.cmode=5;k.basemode=k.cmode;c.change_settings({cmode:k.cmode});k.dbmin=1E-20;6<=k.cmode&&(l=10,7===k.cmode&&(l=20),"L"===v[0]?0<k.lyr.length&&k.lyr[0].cx?(k.ymin=Math.max(k.ymin,1E-10),k.ymax=Math.max(k.ymax,1E-10)):(k.ymin=Math.max(k.ymin,1E-20),k.ymax=Math.max(k.ymax,1E-20)):0<k.lyr.length&&
k.lyr[0].cx?(k.ymin=Math.max(-18*l,k.ymin),k.ymax=Math.max(-18*l,k.ymax),k.dbmin=1E-37):Math.min(k.ymin,k.ymax)<-20*l&&(k.ymin=Math.max(-37*l,k.ymin),k.ymax=Math.max(-37*l,k.ymax),k.dbmin=Math.pow(10,Math.min(k.ymin,k.ymax)/l)));f.level=0;u&&!k.index&&(g&&(k.xmin=k.xstart+k.xdelta*(k.xmin-1)),g&&(k.xmax=k.xstart+k.xdelta*(k.xmax-1)));k.autox=void 0===e.autox?-1:e.autox;0>k.autox&&(k.autox=0,g||(k.autox+=1),h||(k.autox+=2));k.autoy=void 0===e.autoy?-1:e.autoy;0>k.autoy&&(k.autoy=0,r||(k.autoy+=1),
t||(k.autoy+=2));k.autol=void 0===e.autol?-1:e.autol;g||(k.xmin=void 0);h||(k.xmax=void 0);O(c,{get_data:!0},k.xmin,k.xmax,k.xlab,k.ylab);g||(k.xmin=f.stk[0].xmin);h||(k.xmax=f.stk[0].xmax);r||(k.ymin=f.stk[0].ymin);t||(k.ymax=f.stk[0].ymax);k.xmin>k.xmax&&(f.stk[0].xmin=k.xmax,k.xmax=k.xmin,k.xmin=f.stk[0].xmin);k.ymin>k.ymax&&(f.stk[0].ymin=k.ymax,k.ymax=k.ymin,k.ymin=f.stk[0].ymin);f.stk[0].xmin=k.xmin;f.stk[0].xmax=k.xmax;f.stk[0].ymin=k.ymin;f.stk[0].ymax=k.ymax;k.panxmin=Math.min(k.panxmin,
k.xmin);k.panxmax=Math.max(k.panxmax,k.xmax);k.panymin=Math.min(k.panymin,k.ymin);k.panymax=Math.max(k.panymax,k.ymax);k.xmin=f.stk[0].xmin;k.ymin=f.stk[0].ymin;a.set_font(f,Math.min(7,f.width/64));k.ncolors=void 0===e.ncolors?16:e.ncolors;k.cmap=void 0===e.xc?-1:e.xc;0>k.ncolors&&(k.ncolors*=-1,k.cmap=Math.max(1,k.cmap));if(1>k.cmap||5<k.cmap)k.cmap=2===k.cmode?2:1;a.colormap(f,d.Mc.colormap[k.cmap],k.ncolors);k.cntrls="leftmouse"===e.xcnt?1:"continuous"===e.xcnt?2:void 0===e.xcnt?1:e.xcnt;k.default_rubberbox_mode=
void 0===e.rubberbox_mode?"box":e.rubberbox_mode;k.default_rubberbox_action=void 0===e.rubberbox_action?"zoom":e.rubberbox_action;k.cross=void 0===e.cross?!1:e.cross;k.grid=void 0===e.nogrid?!0:!e.nogrid;k.gridBackground=e.gridBackground;k.gridStyle=e.gridStyle;k.wheelZoom=e.wheelZoom;k.wheelZoomPercent=e.wheelZoomPercent;k.legend=void 0===e.legend?!1:e.legend;k.legendBtnLocation={x:0,y:0,width:0,height:0};k.pan=void 0===e.nopan?!0:!e.nopan;k.nomenu=void 0===e.nomenu?!1:e.nomenu;k.modmode=0;k.modlayer=
-1;k.modsource=0;k.modified=e.mod&&0<k.lyr.length;k.nmark=0;k.iabsc=0;k.index&&(k.iabsc=1);k.specs=!e.nospecs;k.scroll_time_interval=void 0===e.scroll_time_interval?k.scroll_time_interval:e.scroll_time_interval;k.autohide_readout=e.autohide_readout;k.autohide_panbars=e.autohide_panbars;k.specs?(k.show_x_axis=!e.noxaxis,k.show_y_axis=!e.noyaxis,k.show_readout=!e.noreadout,k.specs=k.show_x_axis||k.show_y_axis||k.show_readout?!0:!1):(k.show_x_axis=!1,k.show_y_axis=!1,k.show_readout=!1);k.hide_note=e.hide_note||
!1;k.xmrk=0;k.ymrk=0;e.nodragdrop||(a.addEventListener(f,"dragover",function(a){a.preventDefault()},!1),a.addEventListener(f,"drop",function(a){return function(c){var d=c.dataTransfer.files;0<d.length&&(c.preventDefault(),a.load_files(d))}}(c),!1))}function n(a,c){var d=a._Gx,e=a._Mx;if(c){var f=d.HCB[0];d.xstart=f.xstart;d.xdelta=f.xdelta}else d.xstart=0,d.xdelta=1,d.autol=-1,d.zmin=void 0,d.zmax=void 0;e.origin=1}function l(c,e){var f=c._Mx,k=c._Gx;if(0<e&&(4<=e&&k.show_readout&&!k.hide_note&&a.text(f,
f.width-k.lbtn-(k.note.length+1)*f.text_w,f.text_h,k.note),4<=e&&F(c),1<=e&&k.legend)){for(var f=c._Mx,k=c._Gx,g=f.canvas.getContext("2d"),h=0,l=0,n=0,r=0,t=0,u=0,v=0,w=h=0,x=0,r=f.text_w,v=23*r,h=(k.lyr.length+1)*f.text_h,t=f.r-v,u=f.t,l=t+2,n=u+2,w=v-5,x=h-5,y=0,h=v=0;h<k.lyr.length;h++){var z=g.measureText(k.lyr[h].name).width;z>y&&(y=z)}98<y&&(v=y-98,w+=v,l-=v);g.strokeStyle=f.fg;g.fillStyle=f.bg;g.fillRect(l,n,w,x);g.strokeRect(l,n,w,x);for(h=0;h<k.lyr.length;h++)l=t+4*r,n=u+h*f.text_h+f.text_h,
h===k.modlayer&&a.text(f,t+r-v,n+Math.floor(f.text_w/2),"**"),k.lyr[h].display&&(x=k.lyr[h].color,0<k.lyr[h].line&&(w=d.sign(Math.min(r,Math.abs(k.lyr[h].thick)),k.lyr[h].thick),0>w||w===a.L_dashed?a.draw_line(f,x,l-v,n-3,l+2*r-v,n-3,Math.abs(w),{mode:"dashed",on:4,off:4}):a.draw_line(f,x,l-v,n-3,l+2*r-v,n-3,Math.abs(w))),0<k.lyr[h].symbol&&(w=0>k.lyr[h].radius?-d.trunc(0.6*r):Math.min(k.lyr[h].radius,d.trunc(0.6*r)),a.draw_symbol(f,x,l+r-v,n-3,k.lyr[h].symbol,w))),l+=3*r,n+=0.3*f.text_h,a.text(f,
l-v,n,k.lyr[h].name)}}function C(a){for(var c=a._Gx,d=a._Mx.canvas.getContext("2d"),e,f=0;f<c.plugins.length;)c.plugins[f].impl.refresh&&(e=c.plugins[f].canvas,e.width!==a._Mx.canvas.width&&(e.width=a._Mx.canvas.width),e.height!==a._Mx.canvas.height&&(e.height=a._Mx.canvas.height),e.getContext("2d").clearRect(0,0,e.width,e.height),c.plugins[f].impl.refresh(e),d.drawImage(e,0,0)),f+=1}function u(a){a=a._Gx;if(0===a.HCB.length)a.note="";else if(void 0===a.HCB[0].plotnote){for(var c=[],d=0;d<a.HCB.length;d++)a.HCB[d].file_name&&
c.push(a.HCB[d].file_name);a.note=c.join("|").toUpperCase()}}function D(a,c){var d=a._Gx;c>=d.lyr.length||!d.lyr[c].display||0!==d.hold||d.lyr[c].draw()}function w(c){var d=c._Gx;c=c._Mx;d.cross&&(("vertical"===d.cross||!0===d.cross)&&c.xpos>=c.l&&c.xpos<=c.r&&d.cross_xpos!==c.xpos&&(void 0!==d.cross_xpos&&a.rubberline(c,d.cross_xpos,c.t,d.cross_xpos,c.b),a.rubberline(c,c.xpos,c.t,c.xpos,c.b),d.cross_xpos=c.xpos),("horizontal"===d.cross||!0===d.cross)&&c.ypos>=c.t&&c.ypos<=c.b&&d.cross_ypos!==c.ypos&&
(void 0!==d.cross_ypos&&a.rubberline(c,c.l,d.cross_ypos,c.r,d.cross_ypos),a.rubberline(c,c.l,c.ypos,c.r,c.ypos),d.cross_ypos=c.ypos))}function x(a,c){var d=a._Mx,e=a._Gx;e.xdata=!1;for(var f=0;f<e.lyr.length;f++)e.lyr[f].xdata=5===c?!0:!1,e.lyr[f].xdata&&(e.xdata=!0);if(c!==e.cmode)if(5===c&&e.index)alert("Imag/Real mode not permitted in INDEX mode");else if(0>=e.lyr.length)e.cmode=c,T(a);else if(0<c){f=e.cmode;e.cmode=c;var g=e.autox,h=e.autoy;e.autox=3;e.autoy=3;if(5===c||5===f)e.panxmin=1,e.panxmax=
-1,e.panymin=1,e.panymax=-1,d.level=0,c===e.basemode?(d.stk[0].xmin=e.xmin,d.stk[0].xmax=e.xmax,d.stk[0].ymin=e.ymin,d.stk[0].ymax=e.ymax):5===c||5===e.basemode?O(a,{get_data:!0}):(d.stk[0].xmin=e.xmin,d.stk[0].xmax=e.xmax,O(a,{get_data:!0},e.xmin,e.xmax));else for(c===e.basemode?(e.panymin=1,e.panymax=-1,d.stk[0].ymin=e.ymin,d.stk[0].ymax=e.ymax):O(a,{},d.stk[d.level].xmin,d.stk[d.level].xmax),f=1;f<=d.level;f++)d.stk[f].ymin=d.stk[0].ymin,d.stk[f].ymax=d.stk[0].ymax;e.autox=g;e.autoy=h;a.refresh()}}
function F(c){var d,e=c._Mx,k=c._Gx;if(k.pan&&!e.widget){d=e.level;var f={ps:e.stk[d].ymin,pe:e.stk[d].ymax},g=f.ps!==k.panymin||f.pe!==k.panymax,g=g&&0<e.level;!k.autohide_panbars||g&&c.mouseOnCanvas||k.panning?(a.scrollbar(e,0,k.pyl,k.pyl+k.pthk,e.t,e.b,f,k.panymin,k.panymax,void 0,e.scrollbar_y),e.stk[d].ymin=f.ps,e.stk[d].ymax=f.pe):(f=e.canvas.getContext("2d"),f.fillStyle=e.bg,f.fillRect(k.pyl,e.t,k.pyl+k.pthk,e.b-e.t));k.pl<e.width&&(f={ps:e.stk[d].xmin,pe:e.stk[d].xmax},g=(g=f.ps!==k.panxmin||
f.pe!==k.panxmax)&&(!k.all||0<e.level),!k.autohide_panbars||g&&c.mouseOnCanvas||k.panning?(a.scrollbar(e,0,k.pl,k.pr,k.pt,k.pt+k.pthk,f,k.panxmin,k.panxmax,void 0,e.scrollbar_x),e.stk[d].xmin=f.ps,e.stk[d].xmax=f.pe):(f=e.canvas.getContext("2d"),f.fillStyle=e.bg,f.fillRect(k.pl,k.pt-1,k.pr-k.pl,k.pthk+4)))}}function B(c,d,e,k){var f=c._Mx,g=c._Gx,h,l,n,r;r=new a.SCROLLBAR;l=new a.SCROLLBAR;var t=!1;h=f.level;0<g.panmode?(r.flag=11,l.flag=11):(r.flag=-12,l.flag=-12);0===e&&(r.action=0,l.action=0);
if("Y"===d.substring(0,1)){if(r=f.stk[h].ymin,e=f.stk[h].ymax,n=e-r,"YPAN"===d?(d=f.scrollbar_y,e={ps:r,pe:e},a.scrollbar(f,l,g.pyl,g.pyl+g.pthk,f.t,f.b,e,g.panymin,g.panymax,k,d),r=e.ps,e=e.pe,0!==l.action&&a.scroll(f,l,a.XW_UPDATE,void 0,d)):"YCENTER"===d&&(r-=n*(f.ypos-(f.t+f.b)/2)/(f.b-f.t),e=r+n),r!==f.stk[h].ymin||e!==f.stk[h].ymax)f.stk[h].ymin=r,f.stk[h].ymax=e,g.cmode===g.basemode&&1===f.level&&(g.ymin=Math.min(g.ymin,r),g.ymax=Math.max(g.ymax,e)),this.inPan=!0,k=document.createEvent("Event"),
k.initEvent("ypan",!0,!0),k.level=f.level,k.xmin=f.stk[f.level].xmin,k.ymin=f.stk[f.level].ymin,k.xmax=f.stk[f.level].xmax,k.ymax=f.stk[f.level].ymax,a.dispatchEvent(f,k),this.inPan=!1,c.refresh(),t=!0}else if(l=f.stk[h].xmin,e=f.stk[h].xmax,n=e-l,"XPAN"===d?(d=f.scrollbar_x,e={ps:l,pe:e},a.scrollbar(f,r,g.pl,g.pr,g.pt,g.pt+g.pthk,e,g.panxmin,g.panxmax,k,d),l=e.ps,e=e.pe,0!==r.action&&a.scroll(f,r,a.XW_UPDATE,void 0,d)):"XCENTER"===d&&(l+=n*(f.xpos-(f.l+f.r)/2)/(f.r-f.l),l!==f.stk[h].xmin&&(e=l+n)),
f.stk[h].xmin!==l||f.stk[h].xmax!==e)f.stk[h].xmin=l,f.stk[h].xmax=e,g.xdata||1!==f.level||(g.xmin=f.stk[1].xmin,g.xmax=f.stk[1].xmax),this.inPan=!0,k=document.createEvent("Event"),k.initEvent("xpan",!0,!0),k.level=f.level,k.xmin=f.stk[f.level].xmin,k.ymin=f.stk[f.level].ymin,k.xmax=f.stk[f.level].xmax,k.ymax=f.stk[f.level].ymax,a.dispatchEvent(f,k),this.inPan=!1,c.refresh(),t=!0;return t}function M(c,d,e){var f=c._Mx,g=c._Gx,h,l,n;if("XPAN"===d)n=c._Mx.scrollbar_x;else if("YPAN"===d)n=c._Mx.scrollbar_y;
else throw"Unable to drag scrollbar - scrollAction is not 'XPAN' or 'YPAN'!!";n.flag=-12;l=f.level;"XPAN"===d?(h=f.stk[l].xmin,l=f.stk[l].xmax):"YPAN"===d?(h=f.stk[l].ymin,l=f.stk[l].ymax):l=h=void 0;var r=n;r.action=a.SB_DRAG;if("YPAN"===d){var t=f.scrollbar_y.trange/f.scrollbar_y.h;4===r.origin&&(t*=-1);e=e.screenY-g.panning.ypos;e*=t;g.panning.ymin-e<g.panymin?(l=g.panymin+(l-h),h=g.panymin):g.panning.ymax-e>g.panymax?(h=g.panymax-(l-h),l=g.panymax):(h=g.panning.ymin-e,l=g.panning.ymax-e)}else"XPAN"===
d&&(t=f.scrollbar_x.trange/f.scrollbar_x.w,3===r.origin&&(t*=-1),e=e.screenX-g.panning.xpos,e*=t,g.panning.xmin+e<g.panxmin?(l=g.panxmin+(l-h),h=g.panxmin):g.panning.xmax+e>g.panxmax?(h=g.panxmax-(l-h),l=g.panxmax):(h=g.panning.xmin+e,l=g.panning.xmax+e));n.smin=h;n.srange=l-h;a.redrawScrollbar(n,f,void 0);H(c,n.smin,n.smin+n.srange,d.slice(0,1));this.inPan=!0;g=document.createEvent("Event");"XPAN"===d?g.initEvent("xpan",!0,!0):"YPAN"===d&&g.initEvent("ypan",!0,!0);g.level=f.level;g.xmin=f.stk[f.level].xmin;
g.ymin=f.stk[f.level].ymin;g.xmax=f.stk[f.level].xmax;g.ymax=f.stk[f.level].ymax;a.dispatchEvent(f,g);this.inPan=!1;n.action=0;c.refresh()}function N(c,d,e,f,g,h,l,n){var r=c._Mx;if(r.prompt)throw"Prompt already exists! Can only have one prompt at a time!";a.disableListeners(r);c.disable_listeners();var t=function(c,d){return function(e){d(e);a.enableListeners(r);c.enable_listeners();c.refresh();void 0!==n&&n()}},u=function(){c.refresh()};try{a.prompt(r,d,e,t(c,f),u,g,h,l,5E3)}catch(v){console.log("ERROR: Failed to set up prompt due to: "+
v)}}function T(c){var e=c._Mx,f=c._Gx,k=e.canvas.getContext("2d");0===f.sections&&(f.isec=0);f.aretx=f.retx;f.arety=f.rety;f.dretx=f.retx-f.xmrk;f.drety=f.rety-f.ymrk;5===f.cmode&&1===f.iabsc&&(f.iabsc=2);1===f.iabsc?(f.aretx=Math.round((f.aretx-f.xstart)/f.xdelta),f.index||(f.aretx+=1),f.dretx=Math.round(f.dretx/f.xdelta)):2===f.iabsc&&(0!==f.aretx&&(f.aretx=1/f.aretx),0!==f.arety&&(f.arety=1/f.arety),0!==f.dretx&&(f.dretx=1/f.dretx),0!==f.drety&&(f.drety=1/f.drety));if(f.show_readout&&!e.widget){k.fillStyle=
e.bg;var g=Math.floor(e.height-2.5*e.text_h);k.fillRect(e.text_w,g,49*e.text_w,g+1.5*e.text_h);var g=Math.floor(e.height-0.5*e.text_h),h=Math.max(f.pr+e.text_w,e.width-2*e.text_w);k.fillStyle=e.bg;k.fillRect(h,g-e.text_h,e.text_w,e.text_h);if(!f.autohide_readout||c.mouseOnCanvas||f.panning){var l;0===f.iabsc&&4===f.ylab?(k=(d.sec2tspec(f.arety)+"                ").substring(0,16),l=(d.sec2tspec(f.drety,"delta")+"                ").substring(0,16)):(k=a.format_g(f.arety,16,9,!0),l=a.format_g(f.drety,
16,9));0===f.iabsc&&4===f.xlab?(g=(d.sec2tspec(f.aretx)+"                ").substring(0,16),c=(d.sec2tspec(f.dretx,"delta")+"                ").substring(0,16)):(g=a.format_g(f.aretx,16,9,!0),c=a.format_g(f.dretx,16,9));k="y: "+k+" dy: "+l+" L="+e.level+" "+Q[f.cmode-1];c="x: "+g+" dx: "+c+" "+R[f.iabsc];3===f.iabsc&&(k=0===f.dretx?k.substr(0,20)+"sl: Inf             "+k.substr(40,k.length):k.substr(0,20)+"sl: "+a.format_g(f.drety/f.dretx,16,9)+k.substr(40,k.length));g=Math.floor(e.height-1.5*e.text_h);
a.text(e,e.text_w,g,k);g=Math.floor(e.height-0.5*e.text_h);a.text(e,e.text_w,g,c);h<e.width&&(0<f.cntrls?a.text(e,h,g,"C"):a.text(e,h,g," "));a.colorbar(e,49*e.text_w-1,e.height-2.5*e.text_h,e.text_w,2*e.text_h)}}}function O(a,c,d,e,f,g){var h=a._Mx;a=a._Gx;c=!0===c.get_data;a.panxmin=1;a.panxmax=-1;a.panymin=1;a.panymax=-1;var l=void 0===d,n=void 0===e;if(0===a.lyr.length)a.panxmin=-1,a.panxmax=1,a.panymin=-1,a.panymax=1;else for(void 0===f&&(a.xlab=a.lyr[0].xlab),void 0===g&&(a.ylab=a.lyr[0].ylab),
f=0;f<a.lyr.length;f++)if(l&&(d=a.lyr[f].xmin),n&&(e=a.lyr[f].xmax),a.xlab!==a.lyr[f].xlab&&(a.xlab=0),a.ylab!==a.lyr[f].ylab&&(a.ylab=0),c&&a.lyr[f].get_data(d,e),0<a.autox||0<a.autoy)for(;d<e;)a.lyr[f].get_data(d,e),g=a.lyr[f].prep(d,e),a.all&&a.expand?0===a.lyr[f].size?d=e:a.index?d+=g:0<=a.lyr[f].xdelta?d+=a.lyr[f].size*a.lyr[f].xdelta:e+=a.lyr[f].size*a.lyr[f].xdelta:d=e;else a.lyr[f].prep(1,-1);f=a.panxmax-a.panxmin;0>f&&(a.panxmax=a.panxmin,a.panxmin=a.panxmax+f,f=-f);1E-20>=f&&(a.panxmin-=
1,a.panxmax+=1);0!==(a.autox&1)&&l&&(h.stk[0].xmin=a.panxmin);if(0!==(a.autox&2)&&n&&(h.stk[0].xmax=a.panxmax,!a.all&&!a.xdata))for(f=0;f<a.lyr.length;f++)e=Math.min(a.lyr[f].xmax,h.stk[0].xmax),g=Math.abs((e-a.lyr[f].xmin)/a.lyr[f].xdelta)-a.bufmax+1,0<g&&(h.stk[0].xmax=e-g*Math.abs(a.lyr[f].xdelta));0!==(a.autoy&1)&&(h.stk[0].ymin=a.panymin);0!==(a.autoy&2)&&(h.stk[0].ymax=a.panymax)}function z(c,d,e){var f=c._Gx;c=a.pixel_to_real(c._Mx,d,e);f.index&&(c.x*=f.xdelta);return c}function W(a,c,d,e,
f,g){return a>=d&&a<=d+f&&c>=e&&c<=e+g}function c(a){var c=!1,e=a._Gx,f=a._Mx,g=f.xpos,h=f.ypos,l=" ";if(!a.mouseOnCanvas)return!1;e.pan&&g>f.r&&h>=f.t&&h<=f.b?(l="YPAN",f.xpos=e.pyl+d.trunc(e.pthk/2),c=!0):e.pan&&g>=e.pl&&g<=e.pr&&(e.show_readout&&h>e.pt-2||!e.show_readout&&h<=e.pt+e.pthk+2)&&(l="XPAN",f.ypos=e.pt+d.trunc(e.pthk/2),c=!0);return{inPanRegion:c,command:l}}function v(c,d){var e,f,g;d.origin&1?(g=c.x-d.x,d.origin&2&&(g=d.w-g)):(g=c.y-d.y,2>=d.origin&&(g=d.h-g));f=a.scroll_real2pix(d);
e=f.s1;f=f.sw;return g>=e&&g<=e+f?!0:!1}function E(c,d,e){var f=c._Mx,g;"XPAN"===e?g=f.scrollbar_x:"YPAN"===e&&(g=f.scrollbar_y);g.action=d;g.step=0.1*g.srange;g.page=9*g.step;g.scale=2;a.scroll(f,g,a.XW_COMMAND,void 0,g);H(c,g.smin,g.smin+g.srange,e.slice(0,1));this.inPan=!0;c=document.createEvent("Event");"XPAN"===e?c.initEvent("xpan",!0,!0):"YPAN"===e&&c.initEvent("ypan",!0,!0);c.level=f.level;c.xmin=f.stk[f.level].xmin;c.ymin=f.stk[f.level].ymin;c.xmax=f.stk[f.level].xmax;c.ymax=f.stk[f.level].ymax;
a.dispatchEvent(f,c);this.inPan=!1}function H(a,c,d,e){var f=a._Mx,g=a._Gx,h=f.level;if("X"===e){if(f.stk[h].xmin!==c||f.stk[h].xmax!==d)f.stk[h].xmin=c,f.stk[h].xmax=d,g.xdata||1!==f.level||(g.xmin=f.stk[1].xmin,g.xmax=f.stk[1].xmax),a.refresh()}else"Y"!==e||c===f.stk[h].ymin&&d===f.stk[h].ymax||(f.stk[h].ymin=c,f.stk[h].ymax=d,g.cmode===g.basemode&&1===f.level&&(g.ymin=Math.min(g.ymin,c),g.ymax=Math.max(g.ymax,d)),a.refresh())}var P="Keypress Table:\n--------------\n?    - Main help box.\nA    - Toggle display x,y readouts:\n       (absc) -> (index) -> (1/absc) -> (time).\nB    - Toggle LM Drag Mode:\n       (box) -> (horizontal) -> (vertical).\nC    - Toggle controls.\nL    - Toggle legend.\nM    - Pops up main menu\nR    - Toggle display specs (x/y readout)\nS    - Toggle display specs and axes.\nT    - Popup box with timecode value at mouse.\nX    - Popup box with X value at mouse.\nY    - Popup box with Y value at mouse.\nF    - Toggle fullscreen.\n";
e.browserIsCompatible=function(){var a=document.createElement("canvas").getContext?!0:!1,c="ArrayBuffer"in window;return a&&c};navigator.userAgent.match(/(iPad|iPhone|iPod)/i)||"undefined"===typeof Float64Array||Float64Array.emulated||!Float64Array.BYTES_PER_ELEMENT?e.PointArray=Float32Array:e.PointArray=Float64Array;e.Plot=function(p,q){if(!e.browserIsCompatible())throw"Browser is not compatible";var l=this._Mx=a.open(p);this._Gx=new y;this._Gx.parent=p;this.mouseOnCanvas=!1;q||(q={});f(this,q);
this._refresh();this.onmousemove=function(c){return function(d){var e=c._Mx,f=c._Gx,g=d.target.getBoundingClientRect(),p=void 0===d.offsetX?d.pageX-g.left-window.scrollX:d.offsetX;d=void 0===d.offsetX?d.pageY-g.top-window.scrollY:d.offsetY;g=z(c,p,d);f.retx=g.x;f.rety=g.y;e.widget||(T(c),g=document.createEvent("Event"),g.initEvent("mmove",!0,!0),g.xpos=p,g.ypos=d,g.x=f.retx,g.y=f.rety,a.dispatchEvent(e,g)&&(f.cross&&(e.warpbox?(void 0!==f.cross_xpos&&a.rubberline(e,f.cross_xpos,e.t,f.cross_xpos,e.b),
void 0!==f.cross_ypos&&a.rubberline(e,e.l,f.cross_ypos,e.r,f.cross_ypos),f.cross_xpos=void 0,f.cross_ypos=void 0):w(c)),2===f.cntrls&&(g=document.createEvent("Event"),g.initEvent("mtag",!0,!0),g.x=f.retx,g.y=f.rety,a.dispatchEvent(e,g))))}}(this);this.ontouchmove=function(a){return function(c){c.preventDefault();a.onmousemove(c)}}(this);this.throttledOnMouseMove=d.throttle(this._Gx.scroll_time_interval,this.onmousemove);a.addEventListener(l,"mousemove",this.throttledOnMouseMove,!1);this.onmouseout=
function(a){return function(c){c=a._Gx;var d=a._Mx;a.mouseOnCanvas&&(a.mouseOnCanvas=!1,c.autohide_readout&&T(a),c.autohide_panbars&&F(a),d.prompt&&d.prompt.input.enableBlur())}}(this);a.addEventListener(l,"mouseout",this.onmouseout,!1);this.onmouseover=function(a){return function(c){c=a._Gx;var d=a._Mx;a.mouseOnCanvas=!0;c.autohide_panbars&&F(a);d.prompt&&d.prompt.input.disableBlur()}}(this);a.addEventListener(l,"mouseover",this.onmouseover,!1);this.onmousedown=function(d){return function(e){e.preventDefault();
var f=d._Mx,p=d._Gx;f.widget&&"ONESHOT"===f.widget.type&&(f.widget=null,d.refresh());a.ifevent(f,e);var q=document.createEvent("Event");q.initEvent("mdown",!0,!0);q.xpos=f.xpos;q.ypos=f.ypos;q.x=p.retx;q.y=p.rety;q.which=e.which;if(!a.dispatchEvent(f,q))return!1;var l=c(d);if(l.inPanRegion){if(e.preventDefault()," "!==l.command){var n=null,q=null;"XPAN"===l.command?n=f.scrollbar_x:"YPAN"===l.command&&(n=f.scrollbar_y);if(2===e.which)q={x:f.xpos,y:f.ypos},void 0!==n&&v(q,n)&&r(d,l.command);else if(" "!==
l.command&&(q={x:f.xpos,y:f.ypos},!v(q,n)&&1===e.which)){B(d,l.command,0,e);var s=function(){v({x:f.xpos,y:f.ypos},n)?p.stillPanning&&(window.clearInterval(p.stillPanning),p.repeatPanning=void 0):B(d,l.command,0,e)};p.stillPanning=window.setTimeout(function(){p.repeatPanning=window.setInterval(s,50)},250)}}}else if(1===e.which)if(W(f.xpos,f.ypos,p.legendBtnLocation.x,p.legendBtnLocation.y,p.legendBtnLocation.width,p.legendBtnLocation.height))d.change_settings({legend:!p.legend});else{p.xmrk=p.retx;
p.ymrk=p.rety;T(d);var q={opacity:0,return_value:"zoom"},t={opacity:0.4,fill_color:f.hi,return_value:"select"};"zoom"===p.default_rubberbox_action?a.rubberbox(f,h(d),p.default_rubberbox_mode,q,t):"select"===p.default_rubberbox_action&&a.rubberbox(f,h(d),p.default_rubberbox_mode,t,q)}else 2===e.which&&(p.nomenu||g(d));return!1}}(this);this.ontouchstart=function(a){return function(c){c.preventDefault();a.onmousedown({which:1})}}(this);a.addEventListener(l,"mousedown",this.onmousedown,!1);this.docMouseUp=
function(a){return function(c){var d=a._Gx;1===c.which&&(d.panning=void 0,a._Mx.scrollbar_x.action=0,a._Mx.scrollbar_y.action=0);d.stillPanning&&(window.clearTimeout(d.stillPanning),d.stillPanning=void 0);d.repeatPanning&&(window.clearInterval(d.repeatPanning),d.repeatPanning=void 0);return!1}}(this);document.addEventListener("mouseup",this.docMouseUp,!1);this.mouseup=function(c){return function(d){d.preventDefault();var e=c._Gx,f=c._Mx;a.ifevent(c._Mx,d);var g=document.createEvent("Event");g.initEvent("mup",
!0,!0);g.xpos=f.xpos;g.ypos=f.ypos;g.x=e.retx;g.y=e.rety;g.which=d.which;if(a.dispatchEvent(f,g))if(3===d.which)d.preventDefault(),c.unzoom(1),c.refresh();else if(2===d.which&&e.nomenu&&(g=document.createEvent("Event"),g.initEvent("showmenu",!0,!0),g.x=d.x||d.clientX,g.y=d.y||d.clientY,a.dispatchEvent(f,g))){d.stopPropagation&&d.stopPropagation();d.cancelBubble=!0;a.removeEventListener(f,"mousedown",c.onmousedown,!1);var p=function(){try{var d=document.createEvent("Event");d.initEvent("hidemenu",
!0,!0);a.dispatchEvent(f,d)&&a.addEventListener(f,"mousedown",c.onmousedown,!1)}finally{document.removeEventListener("mouseup",p,!1)}};document.addEventListener("mouseup",p,!1)}}}(this);this.ontouchend=function(a){return function(a){a.preventDefault()}}(this);a.addEventListener(l,"mouseup",this.mouseup,!1);this.mouseclick=function(c){return function(d){d.preventDefault();var e=c._Gx,f=c._Mx;a.ifevent(c._Mx,d);var g=document.createEvent("Event");g.initEvent("mclick",!0,!0);g.xpos=f.xpos;g.ypos=f.ypos;
g.x=e.retx;g.y=e.rety;g.which=d.which;a.dispatchEvent(f,g);return!1}}(this);a.addEventListener(l,"click",this.mouseclick,!1);this.mousedblclick=function(c){return function(d){d.preventDefault();var e=c._Gx,f=c._Mx;a.ifevent(c._Mx,d);var g=document.createEvent("Event");g.initEvent("mdblclick",!0,!0);g.xpos=f.xpos;g.ypos=f.ypos;g.x=e.retx;g.y=e.rety;g.which=d.which;a.dispatchEvent(f,g);return!1}}(this);a.addEventListener(l,"dblclick",this.mousedblclick,!1);this.dragMouseDownHandler=function(a){return function(d){var e=
a._Mx,f=a._Gx,g=c(a);if(g.inPanRegion&&(d.preventDefault()," "!==g.command)){var p;"XPAN"===g.command?p=e.scrollbar_x:"YPAN"===g.command&&(p=e.scrollbar_y);var q={x:e.xpos,y:e.ypos};void 0!==p&&v(q,p)&&1===d.which&&(f.panning={axis:g.command,xpos:d.screenX,ypos:d.screenY,xmin:e.stk[e.level].xmin,xmax:e.stk[e.level].xmax,ymin:e.stk[e.level].ymin,ymax:e.stk[e.level].ymax})}}}(this);window.addEventListener("mousedown",this.dragMouseDownHandler,!1);this.dragMouseMoveHandler=function(a){return function(c){var d=
a._Gx;if(void 0!==d.panning)try{M(a,d.panning.axis,c)}catch(e){console.log("Error: "+e)}}}(this);this.throttledDragOnMouseMove=d.throttle(this._Gx.scroll_time_interval,this.dragMouseMoveHandler);window.addEventListener("mousemove",this.throttledDragOnMouseMove,!1);this.dragMouseUpHandler=function(a){return function(c){var d=a._Gx;1===c.which&&(d.panning=void 0)}}(this);window.addEventListener("mouseup",this.dragMouseUpHandler,!1);this.onresize=function(c){return function(d){a.checkresize(c._Mx)&&
c.refresh()}}(this);this.wheelHandler=function(e){var f=e._Mx,g=e._Gx,p=d.throttle(100,function(c){var d;"XPAN"===c.command?d=f.scrollbar_x:"YPAN"===c.command&&(d=f.scrollbar_y);d.action=g.wheelscroll_mode_natural?0>event.deltaY?a.SB_WHEELDOWN:a.SB_WHEELUP:0>event.deltaY?a.SB_WHEELUP:a.SB_WHEELDOWN;d.step=0.1*d.srange;d.page=9*d.step;a.scroll(f,d,a.XW_COMMAND,void 0,d);H(e,d.smin,d.smin+d.srange,c.command.slice(0,1))}),q=d.throttle(100,function(){var a=g.wheelZoomPercent||0.2;g.wheelscroll_mode_natural?
0<event.deltaY&&(a*=-1):0>event.deltaY&&(a*=-1);"x"===g.wheelZoom?e.percent_zoom(a,1,!0):"y"===g.wheelZoom?e.percent_zoom(1,a,!0):e.percent_zoom(a,a,!0)});return function(d){a.ifevent(f,d);var h=c(e);e.mouseOnCanvas&&(d.preventDefault(),h.inPanRegion?p(h):g.wheelZoom&&q())}}(this);window.addWheelListener(window,this.wheelHandler,!1);window.addEventListener("resize",this.onresize,!1);q.nokeypress||(this.onkeypress=function(c){return function(e){var f=c._Mx,p=c._Gx;if(c.mouseOnCanvas&&(!f.widget||"MENU"!==
f.widget.type))if(f.widget&&"ONESHOT"===f.widget.type)f.widget=null,c.refresh();else{var q=getKeyCode(e);97===q?(p.iabsc=(p.iabsc+1)%4,T(c)):108===q?c.change_settings({legend:!p.legend}):103===q?c.change_settings({grid:!p.grid}):98===q||2===q?f.warpbox&&(f.warpbox.mode="box"===f.warpbox.mode?"horizontal":"horizontal"===f.warpbox.mode?"vertical":"box",a.redraw_warpbox(f)):99===q?c.change_settings({xcnt:-1*p.cntrls}):114===q?c.change_settings({show_readout:!p.show_readout}):115===q?c.change_settings({specs:!p.specs}):
120===q?(f=c._Gx,e=c._Mx,p=f.aretx.toString(),1===f.iabsc?a.message(e,"INDEX = "+p):2===f.iabsc?a.message(e,"1/X = "+p):a.message(e,"X = "+p)):121===q?(f=c._Gx,e=c._Mx,p=f.arety.toString(),2===f.iabsc?a.message(e,"1/Y = "+p):a.message(e,"Y = "+p)):122===q?(f=c._Gx,e=c._Mx,f.zmin&&f.zmax&&(p="",p=1===f.lyr.length?"Z = "+f.lyr[0].get_z(f.retx,f.rety).toString():"TODO",a.message(e,p))):116===q?(f=c._Gx,e=c._Mx,0<f.lyr.length&&(p=f.lyr[0].hcb,1===p.xunits?a.message(e,"Time = "+d.sec2tod(p.timecode+f.retx)):
a.message(e,"Time = UNK"))):109===q?p.nomenu||(e=document.createEvent("Event"),e.initEvent("showmenu",!0,!0),e.x=f.x,e.y=f.y,a.dispatchEvent(f,e)&&g(c)):63===q?a.message(f,"To zoom, press and drag the left mouse (LM) over the region of interest and release. To unzoom, press right mouse (RM).  Press the middle mouse (MM) button or press the key 'M' to bring up the menu.  Information about keypresses and what they do can be foundby selecting 'Keypress Info' from the main menu."):102===q?(a.fullscreen(f),
c.refresh()):9===q&&e.ctrlKey&&c.change_settings({invert:null})}}}(this),setKeypressHandler(this.onkeypress));return this};e.Plot.prototype={add_plugin:function(a,c){void 0===c&&(c=Number.MAX_VALUE);if(0>=c)throw"Invalid plugin zorder";a.init(this);var d=document.createElement("canvas");d.width=this._Mx.canvas.width;d.height=this._Mx.canvas.height;this._Gx.plugins.push({impl:a,zorder:c,canvas:d});this._Gx.plugins.sort(function(a,c){return a.zorder-c.zorder});this.refresh()},remove_plugin:function(a){for(var c=
0;c<this._Gx.plugins.length;c++)this._Gx.plugins[c].impl===a&&(a.dispose&&a.dispose(),this._Gx.plugins[c].canvas.parentNode&&this._Gx.plugins[c].canvas.parentNode.removeElement(this._Gx.plugins[c].canvas));this._Gx.plugins.sort(function(a,c){return a.zorder-c.zorder});this.refresh()},addListener:function(c,d){a.addEventListener(this._Mx,c,d,!1)},removeListener:function(c,d){a.removeEventListener(this._Mx,c,d,!1)},change_settings:function(c){for(var e=this._Gx,f=this._Mx,g=0;g<e.lyr.length;g++)e.lyr[g].change_settings(c);
void 0!==c.grid&&(e.grid=null===c.grid?!e.grid:c.grid);void 0!==c.gridBackground&&(e.gridBackground=c.gridBackground);void 0!==c.gridStyle&&(e.gridStyle=c.gridStyle);void 0!==c.wheelZoom&&(e.wheelZoom=c.wheelZoom);void 0!==c.wheelZoomPercent&&(e.wheelZoomPercent=c.wheelZoomPercent);void 0!==c.autol&&(e.autol=c.autol);void 0!==c.index&&c.index!==e.index&&(e.index=null===c.index?!e.index:c.index,e.index&&1!==e.iabsc?e.iabsc=1:e.index||1!==e.iabsc||(e.iabsc=0),O(this,{get_data:!1},void 0,void 0),this.unzoom());
void 0!==c.all&&(e.all=null===c.all?!e.all:c.all);void 0!==c.show_x_axis&&(e.show_x_axis=null===c.show_x_axis?!e.show_x_axis:c.show_x_axis,e.specs=e.show_x_axis||e.show_y_axis||e.show_readout);void 0!==c.show_y_axis&&(e.show_y_axis=null===c.show_y_axis?!e.show_y_axis:c.show_y_axis,e.specs=e.show_x_axis||e.show_y_axis||e.show_readout);void 0!==c.show_readout&&(e.show_readout=null===c.show_readout?!e.show_readout:c.show_readout,e.specs=e.show_x_axis||e.show_y_axis||e.show_readout);void 0!==c.specs&&
(e.specs=null===c.specs?!e.specs:c.specs,e.specs?(e.show_x_axis=!0,e.show_y_axis=!0,e.show_readout=!0):(e.show_x_axis=!1,e.show_y_axis=!1,e.show_readout=!1));void 0!==c.xcnt&&(e.cntrls="leftmouse"===c.xcnt?1:"continuous"===c.xcnt?2:"disable"===c.xcnt&&0<e.cntrls?-1*e.cntrls:"enable"===c.xcnt&&0>e.cntrls?-1*e.cntrls:c.xcnt);void 0!==c.legend&&(e.legend=null===c.legend?!e.legend:c.legend,l(this,-1),g=e.lbtn-2,e.show_readout?(e.legendBtnLocation={x:this._Mx.width-e.lbtn,y:2,width:g,height:g},a.shadowbox(this._Mx,
this._Mx.width-e.lbtn,2,g,g,1,-1,"L")):(e.legendBtnLocation={x:this._Mx.width-e.lbtn,y:2,width:g,height:g},a.shadowbox(this._Mx,this._Mx.width-e.lbtn,2,g,g,1,1,"L")),l(this,1));void 0!==c.pan&&(e.pan=null===c.pan?!e.pan:c.pan);void 0!==c.cross&&(e.cross=null===c.cross?!e.cross:c.cross,e.cross?(e.cross_xpos=void 0,e.cross_ypos=void 0,w(this)):(void 0!==e.cross_xpos&&a.rubberline(f,e.cross_xpos,f.t,e.cross_xpos,f.b),void 0!==e.cross_ypos&&a.rubberline(f,f.l,e.cross_ypos,f.r,e.cross_ypos),e.cross_xpos=
void 0,e.cross_ypos=void 0));void 0!==c.cmode&&x(this,c.cmode);if(void 0!==c.phunits){var h=c.phunits,g=this._Gx,n=this._Mx,r=g.plab;"R"===h?r=23:"D"===h&&(r=24);"C"===h&&(r=25);if(r!==g.plab&&(h=[Math.PI,180,0.5],h=h[r-23]/h[g.plab-23],g.plab=r,2===g.cmode)){for(r=0;r<=n.level;r++)n.stk[r].ymin*=h,n.stk[r].ymax*=h,n.stk[r].yscl*=h;g.panymin*=h;g.panymax*=h;this.refresh()}}void 0!==c.rubberbox_action&&(e.default_rubberbox_action=c.rubberbox_action);void 0!==c.rubberbox_mode&&(e.default_rubberbox_mode=
c.rubberbox_mode);void 0!==c.wheelscroll_mode_natural&&(e.wheelscroll_mode_natural=c.wheelscroll_mode_natural);void 0!==c.colors&&(c.colors.fg||(c.colors.fg=f.fg),c.colors.bg||(c.colors.bg=f.bg),a.setbgfg(f,c.colors.bg,c.colors.fg,f.xi));void 0!==c.cmap&&(e.cmap=null===c.cmap?2===e.cmode?2:1:c.cmap,a.colormap(f,d.Mc.colormap[e.cmap],e.ncolors));void 0!==c.yinv&&(f.origin=c.yinv?4:1);void 0!==c.rasterSmoothing&&(e.rasterSmoothing=null===c.rasterSmoothing?!e.rasterSmoothing:c.rasterSmoothing);void 0!==
c.fillStyle&&(e.fillStyle=c.fillStyle);void 0!==c.invert&&(null===c.invert?a.invertbgfg(f):!0===c.invert?a.setbgfg(this,"white","black"):a.setbgfg(this,"black","white"));void 0!==c.nomenu&&(e.nomenu=null===c.nomenu?!e.nomenu:c.nomenu);void 0!==c.ymin&&H(this,c.ymin,f.stk[0].ymax,"Y");void 0!==c.ymax&&H(this,f.stk[0].ymin,c.ymax,"Y");void 0!==c.xmin&&H(this,c.xmin,f.stk[0].xmax,"X");void 0!==c.xmax&&H(this,f.stk[0].xmin,c.xmax,"X");void 0!==c.note&&(e.note=c.note);this.refresh();void 0!==c.pan&&T(this)},
reread:function(){for(var c=this._Gx,d=[],e=0;e<c.lyr.length;e++)d[e]=c.lyr[e];e=c.HCB.slice();this.deoverlay();for(var f=0;f<e.length;f++)this.overlay_bluefile(e[f]);for(e=0;e<c.lyr.length;e++)c.lyr[e].symbol=d[e].symbol,c.lyr[e].radius=d[e].radius;this.refresh();c=document.createEvent("Event");c.initEvent("reread",!0,!0);a.dispatchEvent(this._Mx,c)},cleanup:function(){},reload:function(a,c,d){var e=this._Mx,f=this._Gx;0>a||a>=f.lyr.length||void 0===f.lyr[a].reload||(a=f.lyr[a].reload(c,d),0===e.level&&
O(this,{get_data:!1},a.xmin,a.xmax),this.refresh())},rescale:function(){0===this._Mx.level&&O(this,{get_data:!1},void 0,void 0);this.refresh()},push:function(a,c,d,e){var f=this._Mx,g=this._Gx;0>a||a>=g.lyr.length||void 0===g.lyr[a].push||(a=g.lyr[a].push(c,d,e),0===f.level&&a&&O(this,{get_data:!1}),this.refresh())},overlay_array:function(a,c,e){d.log.debug("Overlay array");a=d.initialize(a,c);return this.overlay_bluefile(a,e)},overlay_pipe:function(a,c){d.log.debug("Overlay pipe");a||(a={});a.pipe=
!0;var e=d.initialize(null,a);return this.overlay_bluefile(e,c)},overlay_websocket:function(a,c,e){d.log.debug("Overlay websocket: "+a);a=new WebSocket(a,"plot-data");a.binaryType="arraybuffer";var f=this;c||(c={});c.pipe=!0;var g=d.initialize(null,c);g.ws=a;var h=this.overlay_bluefile(g,e);a.onopen=function(a){};a.onmessage=function(a){return function(a){a.data instanceof ArrayBuffer?(a=g.createArray(a.data),f.push(h,a)):"string"===typeof a.data&&(f._Gx.lyr[h].hcb||d.log.warning("Couldn't find header for layer "+
h),a=JSON.parse(a.data),f.push(h,[],a))}}(a);return h},overlay_href:function(a,c,e){d.log.debug("Overlay href: "+a);try{this.show_spinner();var f=function(a,c){return function(d){try{if(d){var f=a.overlay_bluefile(d,e);c&&c(d,f)}else alert("Failed to load data")}finally{a.hide_spinner()}}}(this,c);(new BlueFileReader).read_http(a,f)}catch(g){console.log(g),alert("Failed to load data"),this.hide_spinner()}},show_spinner:function(){this._Gx.spinner||(t.color=this._Mx.xwfg,this._Gx.spinner=(new Spinner(t)).spin(this._Gx.parent))},
hide_spinner:function(){this._Gx.spinner&&this._Gx.spinner.stop();this._Gx.spinner=void 0},add_layer:function(c){var d=this._Gx,e=this._Mx;d.lyr.push(c);var f=document.createEvent("Event");f.initEvent("file_overlayed",!0,!0);f.index=d.lyr.length-1;f.name=c.name;a.dispatchEvent(e,f)},get_layer:function(a){var c=this._Gx;return 0<=a&&a<c.lyr.length?c.lyr[a]:null},overlay_bluefile:function(a,c){d.log.debug("Overlay bluefile: "+a.file_name);var f=this._Mx,g=this._Gx;c=c||{};var h=0===g.HCB.length;g.HCB.push(a);
1===g.HCB.length&&n(this,!0);var l=g.lyr.length;void 0===c.layerType?1===a["class"]?e.Layer1D.overlay(this,a,c):2===a["class"]&&e.Layer2D.overlay(this,a,c):c.layerType.overlay(this,a,c);x(this,g.cmode);if(h)if(0===g.HCB.length)n(this,!1);else{g.basemode=g.cmode;var r,t;0===(g.autox&&1)&&(r=g.xmin);0===(g.autox&&2)&&(t=g.xmin);O(this,{get_data:!0},r,t);f.level=0;0!==(g.autox&&1)&&(g.xmin=f.stk[0].xmin);0!==(g.autox&&2)&&(g.xmax=f.stk[0].xmax);0!==(g.autoy&&1)&&(g.ymin=f.stk[0].ymin);0!==(g.autoy&&
2)&&(g.ymax=f.stk[0].ymax);f.resize=!0;f.origin=g.lyr[0].preferred_origin?g.lyr[0].preferred_origin:1}else for(f=l;f<g.lyr.length;f++)D(this,f);u(this);this.refresh();return g.HCB.length-1},load_files:function(a,c){for(var d=function(a){return function(d){a.overlay_bluefile(d,c)}}(this),e=0;e<a.length;e++){var f=a[e];(new BlueFileReader).read(f,d)}},deoverlay:function(a){var c=this._Gx;if(0<c.HCB.length)if(void 0===a)for(a=c.HCB.length-1;0<=a;a--)this.remove_layer(a);else if(0>a){a=c.HCB.length+a;
if(0>a)return;this.remove_layer(a)}else a<c.HCB.length&&this.remove_layer(a);0===c.lyr.length&&(n(this,!1),O(this,{}))},remove_layer:function(c){var d=this._Gx,e="",f=null;if(0<=c&&c<d.HCB.length){e=d.HCB[c].file_name;f=d.HCB[c];for(d.HCB[c]=null;c<d.HCB.length-1;c++)d.HCB[c]=d.HCB[c+1];d.HCB.length-=1}for(c=d.lyr.length-1;0<=c;c--)if(d.lyr[c].hcb===f){var g=c,h=this._Gx;h.lyr[g].ybufn=0;h.lyr[g].ybuf=null;if(g<h.lyr.length-1)for(;g<h.lyr.length-1;g++)h.lyr[g]=h.lyr[g+1];h.lyr.length-=1;0<h.HCB.length&&
(h.panxmin=1,h.panxmax=-1,h.panymin=1,h.panymax=-1)}u(this);this.refresh();d=document.createEvent("Event");d.initEvent("file_deoverlayed",!0,!0);""!==e&&(d.fileName=e);a.dispatchEvent(this._Mx,d)},pixel_zoom:function(a,c,d,e,f){a=z(this,a,c);d=z(this,d,e);this.zoom(a,d,f)},percent_zoom:function(a,c,d){var e=this._Mx,f=this._Gx,g=0;1>Math.abs(a)&&(g=Math.abs(e.stk[e.level].xmax-e.stk[e.level].xmin),g=g*a/2);a=0;1>Math.abs(c)&&(a=Math.abs(e.stk[e.level].ymax-e.stk[e.level].ymin),a=a*c/2);c={x:Math.max(e.stk[e.level].xmin+
g,f.panxmin),y:Math.max(e.stk[e.level].ymin+a,f.panymin)};e={x:Math.min(e.stk[e.level].xmax-g,f.panxmax),y:Math.min(e.stk[e.level].ymax-a,f.panymax)};this.zoom(c,e,d)},zoom:function(c,d,e){var f=this._Mx,g=this._Gx;if(!(9<=f.level)){void 0===c.x&&(c.x=f.stk[f.level].xmin);void 0===c.y&&(c.y=f.stk[f.level].ymin);void 0===d.x&&(d.x=f.stk[f.level].xmax);void 0===d.y&&(d.y=f.stk[f.level].ymax);if(d.x<c.x){var h=d.x;d.x=c.x;c.x=h}d.y<c.y&&(h=d.y,d.y=c.y,c.y=h);h={};h.xscl=f.stk[f.level].xscl;h.yscl=f.stk[f.level].yscl;
h.xmin=c.x;h.xmax=d.x;h.ymin=c.y;h.ymax=d.y;g.index&&(h.xmin=Math.min(h.xmin/g.xdelta),h.xmax=Math.min(h.xmax/g.xdelta));e&&g.inContinuousZoom?f.stk[f.level]=h:(f.stk.push(h),f.level=f.stk.length-1);g.inContinuousZoom=e;this.inZoom=!0;c=document.createEvent("Event");c.initEvent("zoom",!0,!0);c.level=f.level;c.inContinuousZoom=g.inContinuousZoom;c.xmin=f.stk[f.level].xmin;c.ymin=f.stk[f.level].ymin;c.xmax=f.stk[f.level].xmax;c.ymax=f.stk[f.level].ymax;a.dispatchEvent(f,c);this.inZoom=!1;this.refresh()}},
unzoom:function(c){var d=this._Mx,e=this._Gx;if(0!==d.level){c||(c=d.stk.length);for(;0<c&&0!==d.level;)d.stk.pop(),d.level=d.stk.length-1,c-=1;e.inContinuousZoom=!1;this.inZoom=!0;c=document.createEvent("Event");c.initEvent("unzoom",!0,!0);c.level=d.level;c.xmin=d.stk[d.level].xmin;c.ymin=d.stk[d.level].ymin;c.xmax=d.stk[d.level].xmax;c.ymax=d.stk[d.level].ymax;a.dispatchEvent(d,c);this.inZoom=!1;this.refresh()}},mimic:function(a,c){var d=this;if(!c)throw"mimic must be called with at least one event mask";
c.zoom?a.addListener("zoom",function(a){d.inZoom||d.zoom({x:a.xmin,y:a.ymin},{x:a.xmax,y:a.ymax},a.inContinuousZoom)}):c.xzoom?a.addListener("zoom",function(a){d.inZoom||d.zoom({x:a.xmin,y:void 0},{x:a.xmax,y:void 0},a.inContinuousZoom)}):c.yzoom&&a.addListener("zoom",function(a){d.inZoom||d.zoom({x:void 0,y:a.ymin},{x:void 0,y:a.ymax},a.inContinuousZoom)});c.unzoom&&a.addListener("unzoom",function(a){d.inZoom||a.level<d._Mx.level&&d.unzoom(d._Mx.level-a.level)});(c.pan||c.xpan)&&a.addListener("xpan",
function(a){d.inPan||H(d,a.xmin,a.xmax,"X")});(c.pan||c.ypan)&&a.addListener("ypan",function(a){d.inPan||H(d,a.ymin,a.ymax,"Y")})},redraw:function(){var a=this._Gx,c=this._Mx,d=c.canvas.getContext("2d");a.plotData.valid?(d.drawImage(a.plotData,c.l-1,c.t-1,c.r-c.l+2,c.b-c.t+2,c.l-1,c.t-1,c.r-c.l+2,c.b-c.t+2),C(this),a.cross_xpos=void 0,a.cross_ypos=void 0,w(this)):this.refresh()},refresh:function(){var c=this;a.render(this._Mx,function(){c._refresh()})},enable_listeners:function(){var c=this._Mx;a.addEventListener(c,
"mousedown",this.onmousedown,!1);a.addEventListener(c,"mousemove",this.throttledOnMouseMove,!1);document.addEventListener("mouseup",this.docMouseUp,!1);a.addEventListener(c,"mouseup",this.mouseup,!1);window.addEventListener("mousedown",this.dragMouseDownHandler,!1);window.addEventListener("mousemove",this.throttledDragOnMouseMove,!1);window.addEventListener("mouseup",this.dragMouseUpHandler,!1);window.addEventListener("wheel",this.wheelHandler,!1);window.addEventListener("mousewheel",this.wheelHandler,
!1);window.addEventListener("DOMMouseScroll",this.wheelHandler,!1);window.addEventListener("keypress",this.onkeypress,!1)},disable_listeners:function(){var c=this._Mx;a.removeEventListener(c,"mousedown",this.onmousedown,!1);a.removeEventListener(c,"mousemove",this.throttledOnMouseMove,!1);document.removeEventListener("mouseup",this.docMouseUp,!1);a.removeEventListener(c,"mouseup",this.mouseup,!1);window.removeEventListener("mousedown",this.dragMouseDownHandler,!1);window.removeEventListener("mousemove",
this.throttledDragOnMouseMove,!1);window.removeEventListener("mouseup",this.dragMouseUpHandler,!1);window.removeEventListener("wheel",this.wheelHandler,!1);window.removeEventListener("mousewheel",this.wheelHandler,!1);window.removeEventListener("DOMMouseScroll",this.wheelHandler,!1);window.removeEventListener("keypress",this.onkeypress,!1)},checkresize:function(){a.checkresize(this._Mx)&&this.refresh()},_refresh:function(){var c=this._Mx,d=this._Gx;c.canvas.getContext("2d");if(!d.hold){a.set_font(c,
Math.min(8,c.width/64));d.pthk=1.5*c.text_w;d.specs?(c.l=!0===d.show_y_axis?6*c.text_w:1,c.r=!0===d.pan?c.width-(d.pthk+2*c.text_w):c.width-2,d.show_readout?(c.t=2*c.text_h,c.b=d.show_x_axis?c.height-4*c.text_h:c.height-3*c.text_h):(c.t=d.pan?d.pthk+2*c.text_w:1,c.b=d.show_x_axis?c.height-3*c.text_h/2:c.height-2),d.pl=d.show_readout?50*c.text_w:35*c.text_w,d.pr=Math.max(d.pl+9*c.text_w,c.r),d.pt=d.show_readout?d.show_x_axis?c.b+c.text_h+(c.height-c.b-c.text_h-d.pthk)/2:c.b+(c.height-c.b-d.pthk)/2:
(c.t-d.pthk)/2,d.lbtn=c.text_h+c.text_w+2):(d.pan?(c.t=d.pthk+2*c.text_w,c.r=c.width-(d.pthk+c.text_w)):(c.t=1,c.r=c.width-2),c.b=c.height-2,c.l=1,d.pl=c.l,d.pr=c.r,d.pt=(c.t-d.pthk)/2,d.lbtn=0);d.pyl=c.r+(c.width-c.r-d.pthk)/2+1;var e=c.level;c.stk[e].x1=c.l;c.stk[e].y1=c.t;c.stk[e].x2=c.r;c.stk[e].y2=c.b;c.stk[e].xscl=(c.stk[e].xmax-c.stk[e].xmin)/(c.r-c.l);c.stk[e].yscl=(c.stk[e].ymax-c.stk[e].ymin)/(c.b-c.t);e=z(this,c.xpos,c.ypos);d.retx=e.x;d.rety=e.y;if(0===d.panning||0!==d.panning)d.plotData.valid=
!1,a.clear_window(c);var e=d.xlab,f=d.ylab;void 0===e&&(e=30);d.index&&(e=0);void 0===f&&(f=0<d.lyr.length&&d.lyr[0].cx,1===d.cmode?f=28:2===d.cmode?f=d.plab:3===d.cmode&&f?f=21:4===d.cmode?f=22:5===d.cmode?(f=22,e=21):f=6===d.cmode?26:7===d.cmode?27:0);if(d.specs){if(0===d.sections){var g={grid:d.grid};2===d.panning&&(g.noxtlab=!0);d.show_x_axis||(g.noxtics=!0,g.noxtlab=!0,g.noxplab=!0);d.show_y_axis||(g.noytics=!0,g.noytlab=!0,g.noyplab=!0);!d.specs||d.show_readout||d.pan||(g.noyplab=!0,g.noxplab=
!0);d.gridBackground&&(g.fillStyle=d.gridBackground);d.gridStyle&&(g.gridStyle=d.gridStyle);a.drawaxis(c,d.xdiv,d.ydiv,e,f,g)}e=d.lbtn-2;d.show_readout&&d.pan&&(d.legend?(d.legendBtnLocation={x:c.width-d.lbtn,y:2,width:e,height:e},a.shadowbox(c,c.width-d.lbtn,2,e,e,1,-2,"L")):(d.legendBtnLocation={x:c.width-d.lbtn,y:2,width:e,height:e},a.shadowbox(c,c.width-d.lbtn,2,e,e,1,2,"L")),T(this))}else d.grid&&0<=d.sections&&(g={grid:!0,noaxisbox:!0,noxtics:!0,noxtlab:!0,noxplab:!0,noytics:!0,noytlab:!0,noyplab:!0},
a.drawaxis(c,d.xdiv,d.ydiv,e,f,g));for(e=0;e<d.lyr.length;e++)D(this,e);l(this,4);c.r>c.l&&c.b>c.t&&(d.plotData.width=c.canvas.width,d.plotData.height=c.canvas.height,d.plotData.getContext("2d").drawImage(c.canvas,0,0),d.plotData.valid=!0);C(this);d.cross_xpos=void 0;d.cross_ypos=void 0;w(this)}}};var t={lines:13,length:7,width:4,radius:10,corners:1,rotate:0,color:"#FFF",speed:1,trail:60,shadow:!1,hwaccel:!1,className:"spinner",zIndex:2E9,top:"auto",left:"auto"},Q="Ma Ph Re Im IR Lo L2".split(" "),
R=["(absc)","(indx)","(1/ab)","(dydx)"]})(window.sigplot,window.mx,window.m);
